
module MenhirBasics = struct
  
  exception Error
  
  let _eRR =
    fun _s ->
      raise Error
  
  type token = 
    | YIELDS
    | WHILE
    | VERSION of (
# 32 "src/lang/parser.mly"
       (Lang_string.Version.t)
# 17 "src/lang/parser.ml"
  )
    | VARLPAR of (
# 30 "src/lang/parser.mly"
       (string)
# 22 "src/lang/parser.ml"
  )
    | VARLBRA of (
# 31 "src/lang/parser.mly"
       (string)
# 27 "src/lang/parser.ml"
  )
    | VAR of (
# 29 "src/lang/parser.mly"
       (string)
# 32 "src/lang/parser.ml"
  )
    | UNDERSCORE
    | UMINUS
    | TRY
    | TO
    | TIMES
    | TIME of (
# 40 "src/lang/parser.mly"
       (Parsed_term.time_el)
# 42 "src/lang/parser.ml"
  )
    | TILD
    | THEN
    | STRING of (
# 35 "src/lang/parser.mly"
       (char * string )
# 49 "src/lang/parser.ml"
  )
    | SLASH
    | SET
    | SEQSEQ
    | SEQ
    | RPAR
    | REPLACES
    | REGEXP of (
# 36 "src/lang/parser.mly"
       (string * char list )
# 60 "src/lang/parser.ml"
  )
    | RCUR
    | RBRA
    | QUESTION_DOT
    | QUESTION
    | PP_STRING of (
# 33 "src/lang/parser.mly"
       (char * string * Parsed_term.pos)
# 69 "src/lang/parser.ml"
  )
    | PP_REGEXP of (
# 34 "src/lang/parser.mly"
       (string * char list * Parsed_term.pos)
# 74 "src/lang/parser.ml"
  )
    | PP_INT_DOT_LCUR of (
# 37 "src/lang/parser.mly"
       (string)
# 79 "src/lang/parser.ml"
  )
    | PP_IFVERSION
    | PP_IFENCODER of (
# 74 "src/lang/parser.mly"
       (bool)
# 85 "src/lang/parser.ml"
  )
    | PP_IFDEF of (
# 71 "src/lang/parser.mly"
       (bool)
# 90 "src/lang/parser.ml"
  )
    | PP_ENDL
    | PP_ENDIF
    | PP_ELSE
    | OR
    | OPEN
    | NOT
    | MINUS
    | LPAR
    | LETLBRA of (
# 45 "src/lang/parser.mly"
       (Parser_helper.lexer_let_decoration)
# 103 "src/lang/parser.ml"
  )
    | LET of (
# 44 "src/lang/parser.mly"
       (Parser_helper.lexer_let_decoration)
# 108 "src/lang/parser.ml"
  )
    | LCUR
    | LBRA
    | INTERVAL of (
# 41 "src/lang/parser.mly"
       (Parsed_term.time_el * Parsed_term.time_el)
# 115 "src/lang/parser.ml"
  )
    | INTERPOLATED_STRING of (
# 79 "src/lang/parser.mly"
       (string)
# 120 "src/lang/parser.ml"
  )
    | INT of (
# 37 "src/lang/parser.mly"
       (string)
# 125 "src/lang/parser.ml"
  )
    | INCLUDE of (
# 80 "src/lang/parser.mly"
       (Parsed_term.inc)
# 130 "src/lang/parser.ml"
  )
    | IF
    | GETS
    | GET
    | FUN
    | FOR
    | FLOAT of (
# 38 "src/lang/parser.mly"
       (string)
# 140 "src/lang/parser.ml"
  )
    | FINALLY
    | EOF
    | END_INTERPOLATION
    | END
    | ENCODER of (
# 42 "src/lang/parser.mly"
       (string)
# 149 "src/lang/parser.ml"
  )
    | ELSIF
    | ELSE
    | DOTVAR of (
# 57 "src/lang/parser.mly"
       (string)
# 156 "src/lang/parser.ml"
  )
    | DOTDOTDOT
    | DOT
    | DO
    | DEF of (
# 49 "src/lang/parser.mly"
       (Parser_helper.lexer_let_decoration)
# 164 "src/lang/parser.ml"
  )
    | COMMA
    | COLONCOLON
    | COLON
    | COALESCE
    | CATCH
    | BOOL of (
# 39 "src/lang/parser.mly"
       (bool)
# 174 "src/lang/parser.ml"
  )
    | BIN3 of (
# 64 "src/lang/parser.mly"
       (string)
# 179 "src/lang/parser.ml"
  )
    | BIN2 of (
# 63 "src/lang/parser.mly"
       (string)
# 184 "src/lang/parser.ml"
  )
    | BIN1 of (
# 62 "src/lang/parser.mly"
       (string)
# 189 "src/lang/parser.ml"
  )
    | BEGIN_INTERPOLATION of (
# 77 "src/lang/parser.mly"
       (char)
# 194 "src/lang/parser.ml"
  )
    | BEGIN
    | AT
    | ARGS_OF
    | AND
  
end

include MenhirBasics

# 23 "src/lang/parser.mly"
  
open Parsed_term
(* All auxiliary functions for parser are there *)
open Parser_helper

# 211 "src/lang/parser.ml"

type ('s, 'r) _menhir_state = 
  | MenhirState000 : ('s, _menhir_box_annotate) _menhir_state
    (** State 000.
        Stack shape : .
        Start symbol: annotate. *)

  | MenhirState003 : (('s, _menhir_box_annotate) _menhir_cell1_annotate_metadata_entry, _menhir_box_annotate) _menhir_state
    (** State 003.
        Stack shape : annotate_metadata_entry.
        Start symbol: annotate. *)

  | MenhirState006 : (('s, _menhir_box_annotate) _menhir_cell1_annotate_key, _menhir_box_annotate) _menhir_state
    (** State 006.
        Stack shape : annotate_key.
        Start symbol: annotate. *)

  | MenhirState017 : ('s, _menhir_box_annotate_metadata_entry) _menhir_state
    (** State 017.
        Stack shape : .
        Start symbol: annotate_metadata_entry. *)

  | MenhirState020 : (('s, _menhir_box_annotate_metadata_entry) _menhir_cell1_annotate_key, _menhir_box_annotate_metadata_entry) _menhir_state
    (** State 020.
        Stack shape : annotate_key.
        Start symbol: annotate_metadata_entry. *)

  | MenhirState023 : ('s, _menhir_box_interactive) _menhir_state
    (** State 023.
        Stack shape : .
        Start symbol: interactive. *)

  | MenhirState025 : (('s, 'r) _menhir_cell1_WHILE, 'r) _menhir_state
    (** State 025.
        Stack shape : WHILE.
        Start symbol: <undetermined>. *)

  | MenhirState026 : (('s, 'r) _menhir_cell1_VARLPAR, 'r) _menhir_state
    (** State 026.
        Stack shape : VARLPAR.
        Start symbol: <undetermined>. *)

  | MenhirState027 : (('s, 'r) _menhir_cell1_VARLBRA, 'r) _menhir_state
    (** State 027.
        Stack shape : VARLBRA.
        Start symbol: <undetermined>. *)

  | MenhirState029 : (('s, 'r) _menhir_cell1_UMINUS, 'r) _menhir_state
    (** State 029.
        Stack shape : UMINUS.
        Start symbol: <undetermined>. *)

  | MenhirState030 : (('s, 'r) _menhir_cell1_TRY, 'r) _menhir_state
    (** State 030.
        Stack shape : TRY.
        Start symbol: <undetermined>. *)

  | MenhirState042 : (('s, 'r) _menhir_cell1_PP_IFVERSION _menhir_cell0_if_version_op _menhir_cell0_if_version_version, 'r) _menhir_state
    (** State 042.
        Stack shape : PP_IFVERSION if_version_op if_version_version.
        Start symbol: <undetermined>. *)

  | MenhirState044 : (('s, 'r) _menhir_cell1_PP_IFENCODER _menhir_cell0_ENCODER, 'r) _menhir_state
    (** State 044.
        Stack shape : PP_IFENCODER ENCODER.
        Start symbol: <undetermined>. *)

  | MenhirState045 : (('s, 'r) _menhir_cell1_PP_IFDEF, 'r) _menhir_state
    (** State 045.
        Stack shape : PP_IFDEF.
        Start symbol: <undetermined>. *)

  | MenhirState047 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 047.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState049 : ((('s, 'r) _menhir_cell1_PP_IFDEF, 'r) _menhir_cell1_if_def_var, 'r) _menhir_state
    (** State 049.
        Stack shape : PP_IFDEF if_def_var.
        Start symbol: <undetermined>. *)

  | MenhirState050 : (('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_state
    (** State 050.
        Stack shape : OPEN.
        Start symbol: <undetermined>. *)

  | MenhirState051 : (('s, 'r) _menhir_cell1_NOT, 'r) _menhir_state
    (** State 051.
        Stack shape : NOT.
        Start symbol: <undetermined>. *)

  | MenhirState052 : (('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 052.
        Stack shape : LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState054 : (('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_state
    (** State 054.
        Stack shape : LCUR.
        Start symbol: <undetermined>. *)

  | MenhirState056 : ((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 056.
        Stack shape : LCUR VAR.
        Start symbol: <undetermined>. *)

  | MenhirState057 : (('s, 'r) _menhir_cell1_LBRA, 'r) _menhir_state
    (** State 057.
        Stack shape : LBRA.
        Start symbol: <undetermined>. *)

  | MenhirState061 : (('s, 'r) _menhir_cell1_IF, 'r) _menhir_state
    (** State 061.
        Stack shape : IF.
        Start symbol: <undetermined>. *)

  | MenhirState062 : (('s, 'r) _menhir_cell1_LETLBRA, 'r) _menhir_state
    (** State 062.
        Stack shape : LETLBRA.
        Start symbol: <undetermined>. *)

  | MenhirState064 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 064.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState065 : (('s, 'r) _menhir_cell1_GET, 'r) _menhir_state
    (** State 065.
        Stack shape : GET.
        Start symbol: <undetermined>. *)

  | MenhirState067 : (('s, 'r) _menhir_cell1_FUN _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 067.
        Stack shape : FUN LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState070 : (('s, 'r) _menhir_cell1_TILD _menhir_cell0_VAR, 'r) _menhir_state
    (** State 070.
        Stack shape : TILD VAR.
        Start symbol: <undetermined>. *)

  | MenhirState071 : ((('s, 'r) _menhir_cell1_TILD _menhir_cell0_VAR, 'r) _menhir_cell1_GETS, 'r) _menhir_state
    (** State 071.
        Stack shape : TILD VAR GETS.
        Start symbol: <undetermined>. *)

  | MenhirState072 : (((('s, 'r) _menhir_cell1_TILD _menhir_cell0_VAR, 'r) _menhir_cell1_GETS, 'r) _menhir_cell1_UNDERSCORE, 'r) _menhir_state
    (** State 072.
        Stack shape : TILD VAR GETS UNDERSCORE.
        Start symbol: <undetermined>. *)

  | MenhirState073 : (('s, 'r) _menhir_cell1_GETS, 'r) _menhir_state
    (** State 073.
        Stack shape : GETS.
        Start symbol: <undetermined>. *)

  | MenhirState074 : (('s, 'r) _menhir_cell1_FOR, 'r) _menhir_state
    (** State 074.
        Stack shape : FOR.
        Start symbol: <undetermined>. *)

  | MenhirState076 : ((('s, 'r) _menhir_cell1_FOR, 'r) _menhir_cell1_optvar, 'r) _menhir_state
    (** State 076.
        Stack shape : FOR optvar.
        Start symbol: <undetermined>. *)

  | MenhirState078 : (('s, 'r) _menhir_cell1_ENCODER, 'r) _menhir_state
    (** State 078.
        Stack shape : ENCODER.
        Start symbol: <undetermined>. *)

  | MenhirState079 : ((('s, 'r) _menhir_cell1_ENCODER, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 079.
        Stack shape : ENCODER LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState081 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 081.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState083 : (('s, 'r) _menhir_cell1_BEGIN_INTERPOLATION, 'r) _menhir_state
    (** State 083.
        Stack shape : BEGIN_INTERPOLATION.
        Start symbol: <undetermined>. *)

  | MenhirState085 : (('s, 'r) _menhir_cell1_BEGIN, 'r) _menhir_state
    (** State 085.
        Stack shape : BEGIN.
        Start symbol: <undetermined>. *)

  | MenhirState092 : (('s, 'r) _menhir_cell1_optvar, 'r) _menhir_state
    (** State 092.
        Stack shape : optvar.
        Start symbol: <undetermined>. *)

  | MenhirState096 : ((('s, 'r) _menhir_cell1_optvar, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 096.
        Stack shape : optvar expr.
        Start symbol: <undetermined>. *)

  | MenhirState097 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_TIMES, 'r) _menhir_state
    (** State 097.
        Stack shape : expr TIMES.
        Start symbol: <undetermined>. *)

  | MenhirState098 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_TIMES, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 098.
        Stack shape : expr TIMES expr.
        Start symbol: <undetermined>. *)

  | MenhirState099 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_QUESTION_DOT, 'r) _menhir_state
    (** State 099.
        Stack shape : expr QUESTION_DOT.
        Start symbol: <undetermined>. *)

  | MenhirState100 : (('s, 'r) _menhir_cell1_VARLPAR, 'r) _menhir_state
    (** State 100.
        Stack shape : VARLPAR.
        Start symbol: <undetermined>. *)

  | MenhirState102 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 102.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState103 : ((('s, 'r) _menhir_cell1_VAR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 103.
        Stack shape : VAR expr.
        Start symbol: <undetermined>. *)

  | MenhirState104 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_SET, 'r) _menhir_state
    (** State 104.
        Stack shape : expr SET.
        Start symbol: <undetermined>. *)

  | MenhirState105 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_SET, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 105.
        Stack shape : expr SET expr.
        Start symbol: <undetermined>. *)

  | MenhirState106 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_QUESTION, 'r) _menhir_state
    (** State 106.
        Stack shape : expr QUESTION.
        Start symbol: <undetermined>. *)

  | MenhirState107 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_QUESTION, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 107.
        Stack shape : expr QUESTION expr.
        Start symbol: <undetermined>. *)

  | MenhirState108 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_OR, 'r) _menhir_state
    (** State 108.
        Stack shape : expr OR.
        Start symbol: <undetermined>. *)

  | MenhirState109 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_OR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 109.
        Stack shape : expr OR expr.
        Start symbol: <undetermined>. *)

  | MenhirState110 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_MINUS, 'r) _menhir_state
    (** State 110.
        Stack shape : expr MINUS.
        Start symbol: <undetermined>. *)

  | MenhirState111 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_MINUS, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 111.
        Stack shape : expr MINUS expr.
        Start symbol: <undetermined>. *)

  | MenhirState112 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_DOT, 'r) _menhir_state
    (** State 112.
        Stack shape : expr DOT.
        Start symbol: <undetermined>. *)

  | MenhirState113 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_DOT, 'r) _menhir_cell1_VARLBRA, 'r) _menhir_state
    (** State 113.
        Stack shape : expr DOT VARLBRA.
        Start symbol: <undetermined>. *)

  | MenhirState114 : ((((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_DOT, 'r) _menhir_cell1_VARLBRA, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 114.
        Stack shape : expr DOT VARLBRA expr.
        Start symbol: <undetermined>. *)

  | MenhirState116 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_COLONCOLON, 'r) _menhir_state
    (** State 116.
        Stack shape : expr COLONCOLON.
        Start symbol: <undetermined>. *)

  | MenhirState117 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_COLONCOLON, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 117.
        Stack shape : expr COLONCOLON expr.
        Start symbol: <undetermined>. *)

  | MenhirState118 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_COALESCE, 'r) _menhir_state
    (** State 118.
        Stack shape : expr COALESCE.
        Start symbol: <undetermined>. *)

  | MenhirState119 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_COALESCE, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 119.
        Stack shape : expr COALESCE expr.
        Start symbol: <undetermined>. *)

  | MenhirState120 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_BIN3, 'r) _menhir_state
    (** State 120.
        Stack shape : expr BIN3.
        Start symbol: <undetermined>. *)

  | MenhirState121 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_BIN3, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 121.
        Stack shape : expr BIN3 expr.
        Start symbol: <undetermined>. *)

  | MenhirState122 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_BIN2, 'r) _menhir_state
    (** State 122.
        Stack shape : expr BIN2.
        Start symbol: <undetermined>. *)

  | MenhirState123 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_BIN2, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 123.
        Stack shape : expr BIN2 expr.
        Start symbol: <undetermined>. *)

  | MenhirState124 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_BIN1, 'r) _menhir_state
    (** State 124.
        Stack shape : expr BIN1.
        Start symbol: <undetermined>. *)

  | MenhirState125 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_BIN1, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 125.
        Stack shape : expr BIN1 expr.
        Start symbol: <undetermined>. *)

  | MenhirState126 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_AT, 'r) _menhir_state
    (** State 126.
        Stack shape : expr AT.
        Start symbol: <undetermined>. *)

  | MenhirState127 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_AT, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 127.
        Stack shape : expr AT expr.
        Start symbol: <undetermined>. *)

  | MenhirState128 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_AND, 'r) _menhir_state
    (** State 128.
        Stack shape : expr AND.
        Start symbol: <undetermined>. *)

  | MenhirState129 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_AND, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 129.
        Stack shape : expr AND expr.
        Start symbol: <undetermined>. *)

  | MenhirState131 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_DOT, 'r) _menhir_cell1_LCUR, 'r) _menhir_state
    (** State 131.
        Stack shape : expr DOT LCUR.
        Start symbol: <undetermined>. *)

  | MenhirState133 : ((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_DOTDOTDOT, 'r) _menhir_state
    (** State 133.
        Stack shape : LCUR DOTDOTDOT.
        Start symbol: <undetermined>. *)

  | MenhirState134 : (((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_DOTDOTDOT, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 134.
        Stack shape : LCUR DOTDOTDOT expr.
        Start symbol: <undetermined>. *)

  | MenhirState135 : ((((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_DOT, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_record, 'r) _menhir_state
    (** State 135.
        Stack shape : expr DOT LCUR record.
        Start symbol: <undetermined>. *)

  | MenhirState139 : (((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_record, 'r) _menhir_cell1_COMMA _menhir_cell0_VAR, 'r) _menhir_state
    (** State 139.
        Stack shape : LCUR record COMMA VAR.
        Start symbol: <undetermined>. *)

  | MenhirState140 : ((((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_record, 'r) _menhir_cell1_COMMA _menhir_cell0_VAR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 140.
        Stack shape : LCUR record COMMA VAR expr.
        Start symbol: <undetermined>. *)

  | MenhirState141 : (((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_record, 'r) _menhir_cell1_COMMA _menhir_cell0_DOTDOTDOT, 'r) _menhir_state
    (** State 141.
        Stack shape : LCUR record COMMA DOTDOTDOT.
        Start symbol: <undetermined>. *)

  | MenhirState142 : ((((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_record, 'r) _menhir_cell1_COMMA _menhir_cell0_DOTDOTDOT, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 142.
        Stack shape : LCUR record COMMA DOTDOTDOT expr.
        Start symbol: <undetermined>. *)

  | MenhirState146 : ((((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_QUESTION, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_COLON, 'r) _menhir_state
    (** State 146.
        Stack shape : expr QUESTION expr COLON.
        Start symbol: <undetermined>. *)

  | MenhirState149 : (('s, 'r) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 149.
        Stack shape : ARGS_OF LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState150 : ((('s, 'r) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, 'r) _menhir_cell1_VARLBRA, 'r) _menhir_state
    (** State 150.
        Stack shape : ARGS_OF LPAR VARLBRA.
        Start symbol: <undetermined>. *)

  | MenhirState152 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 152.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState155 : (('s, 'r) _menhir_cell1_GET _menhir_cell0_VAR, 'r) _menhir_state
    (** State 155.
        Stack shape : GET VAR.
        Start symbol: <undetermined>. *)

  | MenhirState163 : ((('s, 'r) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 163.
        Stack shape : ARGS_OF LPAR VAR.
        Start symbol: <undetermined>. *)

  | MenhirState166 : ((('s, 'r) _menhir_cell1_VAR, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 166.
        Stack shape : VAR VAR.
        Start symbol: <undetermined>. *)

  | MenhirState171 : ((('s, 'r) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, 'r) _menhir_cell1_subfield_lbra, 'r) _menhir_state
    (** State 171.
        Stack shape : ARGS_OF LPAR subfield_lbra.
        Start symbol: <undetermined>. *)

  | MenhirState177 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 177.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState179 : (('s, 'r) _menhir_cell1_app_list_elem, 'r) _menhir_state
    (** State 179.
        Stack shape : app_list_elem.
        Start symbol: <undetermined>. *)

  | MenhirState186 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 186.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState188 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_s, 'r) _menhir_state
    (** State 188.
        Stack shape : expr s.
        Start symbol: <undetermined>. *)

  | MenhirState191 : (('s, 'r) _menhir_cell1_def, 'r) _menhir_state
    (** State 191.
        Stack shape : def.
        Start symbol: <undetermined>. *)

  | MenhirState194 : ((('s, 'r) _menhir_cell1_def, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 194.
        Stack shape : def VAR.
        Start symbol: <undetermined>. *)

  | MenhirState196 : ((('s, 'r) _menhir_cell1_VAR, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 196.
        Stack shape : VAR VAR.
        Start symbol: <undetermined>. *)

  | MenhirState198 : ((('s, 'r) _menhir_cell1_def, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 198.
        Stack shape : def LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState200 : (((('s, 'r) _menhir_cell1_def, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_optvar, 'r) _menhir_state
    (** State 200.
        Stack shape : def LPAR optvar.
        Start symbol: <undetermined>. *)

  | MenhirState201 : (('s, 'r) _menhir_cell1_VARLPAR, 'r) _menhir_state
    (** State 201.
        Stack shape : VARLPAR.
        Start symbol: <undetermined>. *)

  | MenhirState204 : (('s, 'r) _menhir_cell1_VAR _menhir_cell0_VARLPAR, 'r) _menhir_state
    (** State 204.
        Stack shape : VAR VARLPAR.
        Start symbol: <undetermined>. *)

  | MenhirState217 : (('s, 'r) _menhir_cell1_ty_content_arg, 'r) _menhir_state
    (** State 217.
        Stack shape : ty_content_arg.
        Start symbol: <undetermined>. *)

  | MenhirState221 : (('s, 'r) _menhir_cell1_VAR _menhir_cell0_VAR _menhir_cell0_VARLPAR, 'r) _menhir_state
    (** State 221.
        Stack shape : VAR VAR VARLPAR.
        Start symbol: <undetermined>. *)

  | MenhirState226 : (('s, 'r) _menhir_cell1_VAR _menhir_cell0_VAR _menhir_cell0_VAR _menhir_cell0_VARLPAR, 'r) _menhir_state
    (** State 226.
        Stack shape : VAR VAR VAR VARLPAR.
        Start symbol: <undetermined>. *)

  | MenhirState231 : (('s, 'r) _menhir_cell1_VAR _menhir_cell0_ty_content, 'r) _menhir_state
    (** State 231.
        Stack shape : VAR ty_content.
        Start symbol: <undetermined>. *)

  | MenhirState239 : (('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 239.
        Stack shape : LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState241 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 241.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState242 : (('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_state
    (** State 242.
        Stack shape : LCUR.
        Start symbol: <undetermined>. *)

  | MenhirState245 : (('s, 'r) _menhir_cell1_VAR _menhir_cell0_QUESTION, 'r) _menhir_state
    (** State 245.
        Stack shape : VAR QUESTION.
        Start symbol: <undetermined>. *)

  | MenhirState246 : (('s, 'r) _menhir_cell1_LBRA, 'r) _menhir_state
    (** State 246.
        Stack shape : LBRA.
        Start symbol: <undetermined>. *)

  | MenhirState257 : (('s, 'r) _menhir_cell1_ty _menhir_cell0_LCUR, 'r) _menhir_state
    (** State 257.
        Stack shape : ty LCUR.
        Start symbol: <undetermined>. *)

  | MenhirState262 : (('s, 'r) _menhir_cell1_STRING _menhir_cell0_VAR _menhir_cell0_VAR _menhir_cell0_QUESTION, 'r) _menhir_state
    (** State 262.
        Stack shape : STRING VAR VAR QUESTION.
        Start symbol: <undetermined>. *)

  | MenhirState264 : (('s, 'r) _menhir_cell1_STRING _menhir_cell0_VAR _menhir_cell0_VAR, 'r) _menhir_state
    (** State 264.
        Stack shape : STRING VAR VAR.
        Start symbol: <undetermined>. *)

  | MenhirState269 : (('s, 'r) _menhir_cell1_meth_ty, 'r) _menhir_state
    (** State 269.
        Stack shape : meth_ty.
        Start symbol: <undetermined>. *)

  | MenhirState272 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 272.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState279 : (('s, 'r) _menhir_cell1_QUESTION _menhir_cell0_VAR, 'r) _menhir_state
    (** State 279.
        Stack shape : QUESTION VAR.
        Start symbol: <undetermined>. *)

  | MenhirState284 : (('s, 'r) _menhir_cell1_ty, 'r) _menhir_state
    (** State 284.
        Stack shape : ty.
        Start symbol: <undetermined>. *)

  | MenhirState288 : (('s, 'r) _menhir_cell1_argty, 'r) _menhir_state
    (** State 288.
        Stack shape : argty.
        Start symbol: <undetermined>. *)

  | MenhirState293 : ((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_argsty _menhir_cell0_RPAR, 'r) _menhir_state
    (** State 293.
        Stack shape : LPAR argsty RPAR.
        Start symbol: <undetermined>. *)

  | MenhirState296 : ((((('s, 'r) _menhir_cell1_def, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_optvar, 'r) _menhir_cell1_ty _menhir_cell0_RPAR, 'r) _menhir_state
    (** State 296.
        Stack shape : def LPAR optvar ty RPAR.
        Start symbol: <undetermined>. *)

  | MenhirState298 : (((((('s, 'r) _menhir_cell1_def, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_optvar, 'r) _menhir_cell1_ty _menhir_cell0_RPAR, 'r) _menhir_cell1_g, 'r) _menhir_state
    (** State 298.
        Stack shape : def LPAR optvar ty RPAR g.
        Start symbol: <undetermined>. *)

  | MenhirState301 : (('s, 'r) _menhir_cell1_binding, 'r) _menhir_state
    (** State 301.
        Stack shape : binding.
        Start symbol: <undetermined>. *)

  | MenhirState302 : ((('s, 'r) _menhir_cell1_binding, 'r) _menhir_cell1_s, 'r) _menhir_state
    (** State 302.
        Stack shape : binding s.
        Start symbol: <undetermined>. *)

  | MenhirState304 : (('s, 'r) _menhir_cell1__let, 'r) _menhir_state
    (** State 304.
        Stack shape : _let.
        Start symbol: <undetermined>. *)

  | MenhirState306 : ((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 306.
        Stack shape : _let VAR.
        Start symbol: <undetermined>. *)

  | MenhirState308 : ((('s, 'r) _menhir_cell1_VAR, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 308.
        Stack shape : VAR VAR.
        Start symbol: <undetermined>. *)

  | MenhirState309 : (('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_state
    (** State 309.
        Stack shape : LCUR.
        Start symbol: <undetermined>. *)

  | MenhirState312 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 312.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState314 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 314.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState317 : (('s, 'r) _menhir_cell1_UNDERSCORE, 'r) _menhir_state
    (** State 317.
        Stack shape : UNDERSCORE.
        Start symbol: <undetermined>. *)

  | MenhirState319 : (('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 319.
        Stack shape : LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState320 : (('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_state
    (** State 320.
        Stack shape : LCUR.
        Start symbol: <undetermined>. *)

  | MenhirState321 : (('s, 'r) _menhir_cell1_DOTDOTDOT, 'r) _menhir_state
    (** State 321.
        Stack shape : DOTDOTDOT.
        Start symbol: <undetermined>. *)

  | MenhirState328 : (('s, 'r) _menhir_cell1_meth_pattern_el, 'r) _menhir_state
    (** State 328.
        Stack shape : meth_pattern_el.
        Start symbol: <undetermined>. *)

  | MenhirState331 : (('s, 'r) _menhir_cell1_LBRA, 'r) _menhir_state
    (** State 331.
        Stack shape : LBRA.
        Start symbol: <undetermined>. *)

  | MenhirState332 : (('s, 'r) _menhir_cell1_DOTDOTDOT, 'r) _menhir_state
    (** State 332.
        Stack shape : DOTDOTDOT.
        Start symbol: <undetermined>. *)

  | MenhirState336 : (('s, 'r) _menhir_cell1_tuple_pattern, 'r) _menhir_state
    (** State 336.
        Stack shape : tuple_pattern.
        Start symbol: <undetermined>. *)

  | MenhirState339 : ((('s, 'r) _menhir_cell1_LBRA, 'r) _menhir_cell1_spread, 'r) _menhir_state
    (** State 339.
        Stack shape : LBRA spread.
        Start symbol: <undetermined>. *)

  | MenhirState343 : (('s, 'r) _menhir_cell1_pattern_list, 'r) _menhir_state
    (** State 343.
        Stack shape : pattern_list.
        Start symbol: <undetermined>. *)

  | MenhirState348 : (('s, 'r) _menhir_cell1_list_pattern, 'r) _menhir_state
    (** State 348.
        Stack shape : list_pattern.
        Start symbol: <undetermined>. *)

  | MenhirState354 : ((('s, 'r) _menhir_cell1_LBRA, 'r) _menhir_cell1_pattern_list, 'r) _menhir_state
    (** State 354.
        Stack shape : LBRA pattern_list.
        Start symbol: <undetermined>. *)

  | MenhirState356 : (((('s, 'r) _menhir_cell1_LBRA, 'r) _menhir_cell1_pattern_list, 'r) _menhir_cell1_spread, 'r) _menhir_state
    (** State 356.
        Stack shape : LBRA pattern_list spread.
        Start symbol: <undetermined>. *)

  | MenhirState362 : (('s, 'r) _menhir_cell1_meth_pattern_el, 'r) _menhir_state
    (** State 362.
        Stack shape : meth_pattern_el.
        Start symbol: <undetermined>. *)

  | MenhirState363 : ((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 363.
        Stack shape : _let LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState365 : (((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_pattern, 'r) _menhir_state
    (** State 365.
        Stack shape : _let LPAR pattern.
        Start symbol: <undetermined>. *)

  | MenhirState368 : ((((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_pattern, 'r) _menhir_cell1_ty _menhir_cell0_RPAR, 'r) _menhir_state
    (** State 368.
        Stack shape : _let LPAR pattern ty RPAR.
        Start symbol: <undetermined>. *)

  | MenhirState369 : (((((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_pattern, 'r) _menhir_cell1_ty _menhir_cell0_RPAR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 369.
        Stack shape : _let LPAR pattern ty RPAR expr.
        Start symbol: <undetermined>. *)

  | MenhirState371 : ((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_subfield, 'r) _menhir_state
    (** State 371.
        Stack shape : _let subfield.
        Start symbol: <undetermined>. *)

  | MenhirState372 : (((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_subfield, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 372.
        Stack shape : _let subfield expr.
        Start symbol: <undetermined>. *)

  | MenhirState374 : ((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_pattern, 'r) _menhir_state
    (** State 374.
        Stack shape : _let pattern.
        Start symbol: <undetermined>. *)

  | MenhirState375 : (((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_pattern, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 375.
        Stack shape : _let pattern expr.
        Start symbol: <undetermined>. *)

  | MenhirState376 : ((('s, 'r) _menhir_cell1_def, 'r) _menhir_cell1_subfield_lpar, 'r) _menhir_state
    (** State 376.
        Stack shape : def subfield_lpar.
        Start symbol: <undetermined>. *)

  | MenhirState377 : (('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 377.
        Stack shape : LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState379 : ((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_optvar, 'r) _menhir_state
    (** State 379.
        Stack shape : LPAR optvar.
        Start symbol: <undetermined>. *)

  | MenhirState381 : (((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_optvar, 'r) _menhir_cell1_ty _menhir_cell0_RPAR, 'r) _menhir_state
    (** State 381.
        Stack shape : LPAR optvar ty RPAR.
        Start symbol: <undetermined>. *)

  | MenhirState384 : (('s, 'r) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 384.
        Stack shape : ARGS_OF LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState385 : ((('s, 'r) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, 'r) _menhir_cell1_VARLBRA, 'r) _menhir_state
    (** State 385.
        Stack shape : ARGS_OF LPAR VARLBRA.
        Start symbol: <undetermined>. *)

  | MenhirState391 : ((('s, 'r) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, 'r) _menhir_cell1_subfield_lbra, 'r) _menhir_state
    (** State 391.
        Stack shape : ARGS_OF LPAR subfield_lbra.
        Start symbol: <undetermined>. *)

  | MenhirState397 : (('s, 'r) _menhir_cell1_optvar, 'r) _menhir_state
    (** State 397.
        Stack shape : optvar.
        Start symbol: <undetermined>. *)

  | MenhirState400 : (((('s, 'r) _menhir_cell1_def, 'r) _menhir_cell1_subfield_lpar, 'r) _menhir_cell1_arglist _menhir_cell0_RPAR, 'r) _menhir_state
    (** State 400.
        Stack shape : def subfield_lpar arglist RPAR.
        Start symbol: <undetermined>. *)

  | MenhirState401 : ((((('s, 'r) _menhir_cell1_def, 'r) _menhir_cell1_subfield_lpar, 'r) _menhir_cell1_arglist _menhir_cell0_RPAR, 'r) _menhir_cell1_g, 'r) _menhir_state
    (** State 401.
        Stack shape : def subfield_lpar arglist RPAR g.
        Start symbol: <undetermined>. *)

  | MenhirState405 : (('s, 'r) _menhir_cell1_arg, 'r) _menhir_state
    (** State 405.
        Stack shape : arg.
        Start symbol: <undetermined>. *)

  | MenhirState407 : ((('s, 'r) _menhir_cell1_def, 'r) _menhir_cell1_subfield, 'r) _menhir_state
    (** State 407.
        Stack shape : def subfield.
        Start symbol: <undetermined>. *)

  | MenhirState408 : (((('s, 'r) _menhir_cell1_def, 'r) _menhir_cell1_subfield, 'r) _menhir_cell1_g, 'r) _menhir_state
    (** State 408.
        Stack shape : def subfield g.
        Start symbol: <undetermined>. *)

  | MenhirState411 : ((('s, 'r) _menhir_cell1_def, 'r) _menhir_cell1_optvar, 'r) _menhir_state
    (** State 411.
        Stack shape : def optvar.
        Start symbol: <undetermined>. *)

  | MenhirState412 : (((('s, 'r) _menhir_cell1_def, 'r) _menhir_cell1_optvar, 'r) _menhir_cell1_g, 'r) _menhir_state
    (** State 412.
        Stack shape : def optvar g.
        Start symbol: <undetermined>. *)

  | MenhirState417 : (('s, 'r) _menhir_cell1_string_interpolation_elem, 'r) _menhir_state
    (** State 417.
        Stack shape : string_interpolation_elem.
        Start symbol: <undetermined>. *)

  | MenhirState419 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 419.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState420 : ((('s, 'r) _menhir_cell1_VAR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 420.
        Stack shape : VAR expr.
        Start symbol: <undetermined>. *)

  | MenhirState422 : (('s, 'r) _menhir_cell1_STRING, 'r) _menhir_state
    (** State 422.
        Stack shape : STRING.
        Start symbol: <undetermined>. *)

  | MenhirState423 : ((('s, 'r) _menhir_cell1_STRING, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 423.
        Stack shape : STRING expr.
        Start symbol: <undetermined>. *)

  | MenhirState424 : (('s, 'r) _menhir_cell1_ENCODER, 'r) _menhir_state
    (** State 424.
        Stack shape : ENCODER.
        Start symbol: <undetermined>. *)

  | MenhirState429 : (('s, 'r) _menhir_cell1_encoder_param, 'r) _menhir_state
    (** State 429.
        Stack shape : encoder_param.
        Start symbol: <undetermined>. *)

  | MenhirState432 : (((('s, 'r) _menhir_cell1_FOR, 'r) _menhir_cell1_optvar, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 432.
        Stack shape : FOR optvar expr.
        Start symbol: <undetermined>. *)

  | MenhirState433 : ((((('s, 'r) _menhir_cell1_FOR, 'r) _menhir_cell1_optvar, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_TO, 'r) _menhir_state
    (** State 433.
        Stack shape : FOR optvar expr TO.
        Start symbol: <undetermined>. *)

  | MenhirState434 : (((((('s, 'r) _menhir_cell1_FOR, 'r) _menhir_cell1_optvar, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_TO, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 434.
        Stack shape : FOR optvar expr TO expr.
        Start symbol: <undetermined>. *)

  | MenhirState435 : ((((((('s, 'r) _menhir_cell1_FOR, 'r) _menhir_cell1_optvar, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_TO, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_DO, 'r) _menhir_state
    (** State 435.
        Stack shape : FOR optvar expr TO expr DO.
        Start symbol: <undetermined>. *)

  | MenhirState438 : ((((('s, 'r) _menhir_cell1_FOR, 'r) _menhir_cell1_optvar, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_DO, 'r) _menhir_state
    (** State 438.
        Stack shape : FOR optvar expr DO.
        Start symbol: <undetermined>. *)

  | MenhirState441 : ((('s, 'r) _menhir_cell1_GETS, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 441.
        Stack shape : GETS expr.
        Start symbol: <undetermined>. *)

  | MenhirState446 : (('s, 'r) _menhir_cell1_TILD _menhir_cell0_LPAR _menhir_cell0_VAR, 'r) _menhir_state
    (** State 446.
        Stack shape : TILD LPAR VAR.
        Start symbol: <undetermined>. *)

  | MenhirState448 : ((('s, 'r) _menhir_cell1_TILD _menhir_cell0_LPAR _menhir_cell0_VAR, 'r) _menhir_cell1_ty _menhir_cell0_RPAR, 'r) _menhir_state
    (** State 448.
        Stack shape : TILD LPAR VAR ty RPAR.
        Start symbol: <undetermined>. *)

  | MenhirState452 : ((('s, 'r) _menhir_cell1_FUN _menhir_cell0_LPAR, 'r) _menhir_cell1_arglist _menhir_cell0_RPAR, 'r) _menhir_state
    (** State 452.
        Stack shape : FUN LPAR arglist RPAR.
        Start symbol: <undetermined>. *)

  | MenhirState453 : (((('s, 'r) _menhir_cell1_FUN _menhir_cell0_LPAR, 'r) _menhir_cell1_arglist _menhir_cell0_RPAR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 453.
        Stack shape : FUN LPAR arglist RPAR expr.
        Start symbol: <undetermined>. *)

  | MenhirState454 : ((('s, 'r) _menhir_cell1_GET, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 454.
        Stack shape : GET expr.
        Start symbol: <undetermined>. *)

  | MenhirState455 : ((('s, 'r) _menhir_cell1_VAR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 455.
        Stack shape : VAR expr.
        Start symbol: <undetermined>. *)

  | MenhirState457 : (('s, 'r) _menhir_cell1_let_opt_el, 'r) _menhir_state
    (** State 457.
        Stack shape : let_opt_el.
        Start symbol: <undetermined>. *)

  | MenhirState462 : ((('s, 'r) _menhir_cell1_IF, 'r) _menhir_cell1_exprs, 'r) _menhir_state
    (** State 462.
        Stack shape : IF exprs.
        Start symbol: <undetermined>. *)

  | MenhirState463 : (((('s, 'r) _menhir_cell1_IF, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_exprs, 'r) _menhir_state
    (** State 463.
        Stack shape : IF exprs exprs.
        Start symbol: <undetermined>. *)

  | MenhirState464 : (((('s, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_ELSIF, 'r) _menhir_state
    (** State 464.
        Stack shape : exprs exprs ELSIF.
        Start symbol: <undetermined>. *)

  | MenhirState466 : ((((('s, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_ELSIF, 'r) _menhir_cell1_exprs, 'r) _menhir_state
    (** State 466.
        Stack shape : exprs exprs ELSIF exprs.
        Start symbol: <undetermined>. *)

  | MenhirState467 : (((((('s, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_ELSIF, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_exprs, 'r) _menhir_state
    (** State 467.
        Stack shape : exprs exprs ELSIF exprs exprs.
        Start symbol: <undetermined>. *)

  | MenhirState468 : (((('s, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_ELSE, 'r) _menhir_state
    (** State 468.
        Stack shape : exprs exprs ELSE.
        Start symbol: <undetermined>. *)

  | MenhirState473 : (('s, 'r) _menhir_cell1_DOTDOTDOT, 'r) _menhir_state
    (** State 473.
        Stack shape : DOTDOTDOT.
        Start symbol: <undetermined>. *)

  | MenhirState474 : ((('s, 'r) _menhir_cell1_DOTDOTDOT, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 474.
        Stack shape : DOTDOTDOT expr.
        Start symbol: <undetermined>. *)

  | MenhirState476 : (('s, 'r) _menhir_cell1_inner_list_item, 'r) _menhir_state
    (** State 476.
        Stack shape : inner_list_item.
        Start symbol: <undetermined>. *)

  | MenhirState478 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 478.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState481 : (((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_VAR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 481.
        Stack shape : LCUR VAR expr.
        Start symbol: <undetermined>. *)

  | MenhirState483 : ((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_OPEN, 'r) _menhir_state
    (** State 483.
        Stack shape : LCUR OPEN.
        Start symbol: <undetermined>. *)

  | MenhirState484 : (((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 484.
        Stack shape : LCUR OPEN expr.
        Start symbol: <undetermined>. *)

  | MenhirState485 : ((((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_s, 'r) _menhir_state
    (** State 485.
        Stack shape : LCUR OPEN expr s.
        Start symbol: <undetermined>. *)

  | MenhirState489 : ((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_record, 'r) _menhir_state
    (** State 489.
        Stack shape : LCUR record.
        Start symbol: <undetermined>. *)

  | MenhirState493 : ((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 493.
        Stack shape : LCUR expr.
        Start symbol: <undetermined>. *)

  | MenhirState494 : (((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_s, 'r) _menhir_state
    (** State 494.
        Stack shape : LCUR expr s.
        Start symbol: <undetermined>. *)

  | MenhirState496 : ((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_explicit_binding, 'r) _menhir_state
    (** State 496.
        Stack shape : LCUR explicit_binding.
        Start symbol: <undetermined>. *)

  | MenhirState497 : (((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_explicit_binding, 'r) _menhir_cell1_s, 'r) _menhir_state
    (** State 497.
        Stack shape : LCUR explicit_binding s.
        Start symbol: <undetermined>. *)

  | MenhirState501 : ((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 501.
        Stack shape : LPAR expr.
        Start symbol: <undetermined>. *)

  | MenhirState503 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_COMMA, 'r) _menhir_state
    (** State 503.
        Stack shape : expr COMMA.
        Start symbol: <undetermined>. *)

  | MenhirState505 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_COMMA, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 505.
        Stack shape : expr COMMA expr.
        Start symbol: <undetermined>. *)

  | MenhirState506 : (((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_COLON, 'r) _menhir_state
    (** State 506.
        Stack shape : LPAR expr COLON.
        Start symbol: <undetermined>. *)

  | MenhirState509 : ((('s, 'r) _menhir_cell1_NOT, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 509.
        Stack shape : NOT expr.
        Start symbol: <undetermined>. *)

  | MenhirState510 : ((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 510.
        Stack shape : OPEN expr.
        Start symbol: <undetermined>. *)

  | MenhirState511 : (((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_s, 'r) _menhir_state
    (** State 511.
        Stack shape : OPEN expr s.
        Start symbol: <undetermined>. *)

  | MenhirState515 : (((('s, 'r) _menhir_cell1_PP_IFDEF, 'r) _menhir_cell1_if_def_var, 'r) _menhir_cell1_exprs, 'r) _menhir_state
    (** State 515.
        Stack shape : PP_IFDEF if_def_var exprs.
        Start symbol: <undetermined>. *)

  | MenhirState520 : ((('s, 'r) _menhir_cell1_PP_IFENCODER _menhir_cell0_ENCODER, 'r) _menhir_cell1_exprs, 'r) _menhir_state
    (** State 520.
        Stack shape : PP_IFENCODER ENCODER exprs.
        Start symbol: <undetermined>. *)

  | MenhirState525 : ((('s, 'r) _menhir_cell1_PP_IFVERSION _menhir_cell0_if_version_op _menhir_cell0_if_version_version, 'r) _menhir_cell1_exprs, 'r) _menhir_state
    (** State 525.
        Stack shape : PP_IFVERSION if_version_op if_version_version exprs.
        Start symbol: <undetermined>. *)

  | MenhirState529 : ((('s, 'r) _menhir_cell1_TRY, 'r) _menhir_cell1_exprs, 'r) _menhir_state
    (** State 529.
        Stack shape : TRY exprs.
        Start symbol: <undetermined>. *)

  | MenhirState532 : ((('s, 'r) _menhir_cell1_TRY, 'r) _menhir_cell1_exprs, 'r) _menhir_state
    (** State 532.
        Stack shape : TRY exprs.
        Start symbol: <undetermined>. *)

  | MenhirState534 : (((('s, 'r) _menhir_cell1_TRY, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_optvar, 'r) _menhir_state
    (** State 534.
        Stack shape : TRY exprs optvar.
        Start symbol: <undetermined>. *)

  | MenhirState536 : ((((('s, 'r) _menhir_cell1_TRY, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_optvar, 'r) _menhir_cell1_exprs, 'r) _menhir_state
    (** State 536.
        Stack shape : TRY exprs optvar exprs.
        Start symbol: <undetermined>. *)

  | MenhirState540 : (((('s, 'r) _menhir_cell1_TRY, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_optvar, 'r) _menhir_state
    (** State 540.
        Stack shape : TRY exprs optvar.
        Start symbol: <undetermined>. *)

  | MenhirState542 : ((((('s, 'r) _menhir_cell1_TRY, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_optvar, 'r) _menhir_cell1_varlist, 'r) _menhir_state
    (** State 542.
        Stack shape : TRY exprs optvar varlist.
        Start symbol: <undetermined>. *)

  | MenhirState544 : (((((('s, 'r) _menhir_cell1_TRY, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_optvar, 'r) _menhir_cell1_varlist, 'r) _menhir_cell1_exprs, 'r) _menhir_state
    (** State 544.
        Stack shape : TRY exprs optvar varlist exprs.
        Start symbol: <undetermined>. *)

  | MenhirState549 : ((('s, 'r) _menhir_cell1_VARLBRA, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 549.
        Stack shape : VARLBRA expr.
        Start symbol: <undetermined>. *)

  | MenhirState553 : ((('s, 'r) _menhir_cell1_WHILE, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 553.
        Stack shape : WHILE expr.
        Start symbol: <undetermined>. *)

  | MenhirState554 : (((('s, 'r) _menhir_cell1_WHILE, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_DO, 'r) _menhir_state
    (** State 554.
        Stack shape : WHILE expr DO.
        Start symbol: <undetermined>. *)

  | MenhirState562 : ('s _menhir_cell0_LPAR, _menhir_box_plain_encoder_params) _menhir_state
    (** State 562.
        Stack shape : LPAR.
        Start symbol: plain_encoder_params. *)

  | MenhirState566 : ('s, _menhir_box_program) _menhir_state
    (** State 566.
        Stack shape : .
        Start symbol: program. *)

  | MenhirState572 : ('s, _menhir_box_time_predicate) _menhir_state
    (** State 572.
        Stack shape : .
        Start symbol: time_predicate. *)


and ('s, 'r) _menhir_cell1__let = 
  | MenhirCell1__let of 's * ('s, 'r) _menhir_state * (Parsed_term.let_decoration) * Lexing.position

and ('s, 'r) _menhir_cell1_annotate_key = 
  | MenhirCell1_annotate_key of 's * ('s, 'r) _menhir_state * (string)

and ('s, 'r) _menhir_cell1_annotate_metadata_entry = 
  | MenhirCell1_annotate_metadata_entry of 's * ('s, 'r) _menhir_state * (string * string)

and ('s, 'r) _menhir_cell1_app_list_elem = 
  | MenhirCell1_app_list_elem of 's * ('s, 'r) _menhir_state * (Parsed_term.app_arg)

and ('s, 'r) _menhir_cell1_arg = 
  | MenhirCell1_arg of 's * ('s, 'r) _menhir_state * (Parsed_term.fun_arg)

and ('s, 'r) _menhir_cell1_arglist = 
  | MenhirCell1_arglist of 's * ('s, 'r) _menhir_state * (Parser_helper.arglist)

and ('s, 'r) _menhir_cell1_argsty = 
  | MenhirCell1_argsty of 's * ('s, 'r) _menhir_state * (Parsed_term.type_annotation Type.argument list)

and ('s, 'r) _menhir_cell1_argty = 
  | MenhirCell1_argty of 's * ('s, 'r) _menhir_state * (Parsed_term.type_annotation Type.argument)

and ('s, 'r) _menhir_cell1_binding = 
  | MenhirCell1_binding of 's * ('s, 'r) _menhir_state * (Parser_helper.binding) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_def = 
  | MenhirCell1_def of 's * ('s, 'r) _menhir_state * (Parsed_term.let_decoration) * Lexing.position

and ('s, 'r) _menhir_cell1_encoder_param = 
  | MenhirCell1_encoder_param of 's * ('s, 'r) _menhir_state * ([ `Anonymous of Parsed_term.string_param
  | `Encoder of Parsed_term.encoder
  | `Labelled of Parsed_term.string_param * Parsed_term.t ])

and ('s, 'r) _menhir_cell1_explicit_binding = 
  | MenhirCell1_explicit_binding of 's * ('s, 'r) _menhir_state * (Parser_helper.explicit_binding) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_expr = 
  | MenhirCell1_expr of 's * ('s, 'r) _menhir_state * (Parsed_term.t) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_exprs = 
  | MenhirCell1_exprs of 's * ('s, 'r) _menhir_state * (Parsed_term.t) * Lexing.position

and ('s, 'r) _menhir_cell1_g = 
  | MenhirCell1_g of 's * ('s, 'r) _menhir_state * (unit)

and ('s, 'r) _menhir_cell1_if_def_var = 
  | MenhirCell1_if_def_var of 's * ('s, 'r) _menhir_state * (string list)

and 's _menhir_cell0_if_version_op = 
  | MenhirCell0_if_version_op of 's * ([ `Eq | `Geq | `Gt | `Leq | `Lt ])

and 's _menhir_cell0_if_version_version = 
  | MenhirCell0_if_version_version of 's * (Lang_string.Version.t)

and ('s, 'r) _menhir_cell1_inner_list_item = 
  | MenhirCell1_inner_list_item of 's * ('s, 'r) _menhir_state * (Parsed_term.list_el)

and ('s, 'r) _menhir_cell1_let_opt_el = 
  | MenhirCell1_let_opt_el of 's * ('s, 'r) _menhir_state * (Parser_helper.let_opt_el)

and ('s, 'r) _menhir_cell1_list_pattern = 
  | MenhirCell1_list_pattern of 's * ('s, 'r) _menhir_state * (Parsed_term.pattern_entry) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_meth_pattern_el = 
  | MenhirCell1_meth_pattern_el of 's * ('s, 'r) _menhir_state * (string * Parsed_term.meth_term_default)

and ('s, 'r) _menhir_cell1_meth_ty = 
  | MenhirCell1_meth_ty of 's * ('s, 'r) _menhir_state * (Parsed_term.meth_annotation)

and ('s, 'r) _menhir_cell1_optvar = 
  | MenhirCell1_optvar of 's * ('s, 'r) _menhir_state * (string) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_pattern = 
  | MenhirCell1_pattern of 's * ('s, 'r) _menhir_state * (Parsed_term.pattern)

and ('s, 'r) _menhir_cell1_pattern_list = 
  | MenhirCell1_pattern_list of 's * ('s, 'r) _menhir_state * (Parsed_term.pattern list)

and ('s, 'r) _menhir_cell1_record = 
  | MenhirCell1_record of 's * ('s, 'r) _menhir_state * (Parsed_term.methods list)

and ('s, 'r) _menhir_cell1_s = 
  | MenhirCell1_s of 's * ('s, 'r) _menhir_state * (unit) * Lexing.position

and ('s, 'r) _menhir_cell1_spread = 
  | MenhirCell1_spread of 's * ('s, 'r) _menhir_state * (string) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_string_interpolation_elem = 
  | MenhirCell1_string_interpolation_elem of 's * ('s, 'r) _menhir_state * (Parsed_term.string_interpolation)

and ('s, 'r) _menhir_cell1_subfield = 
  | MenhirCell1_subfield of 's * ('s, 'r) _menhir_state * (string list) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_subfield_lbra = 
  | MenhirCell1_subfield_lbra of 's * ('s, 'r) _menhir_state * (string list)

and ('s, 'r) _menhir_cell1_subfield_lpar = 
  | MenhirCell1_subfield_lpar of 's * ('s, 'r) _menhir_state * (string list) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_tuple_pattern = 
  | MenhirCell1_tuple_pattern of 's * ('s, 'r) _menhir_state * (Parsed_term.pattern_entry) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_ty = 
  | MenhirCell1_ty of 's * ('s, 'r) _menhir_state * (Parsed_term.type_annotation) * Lexing.position

and 's _menhir_cell0_ty_content = 
  | MenhirCell0_ty_content of 's * (string * Parsed_term.track_annotation list)

and ('s, 'r) _menhir_cell1_ty_content_arg = 
  | MenhirCell1_ty_content_arg of 's * ('s, 'r) _menhir_state * (Parsed_term.track_annotation)

and ('s, 'r) _menhir_cell1_varlist = 
  | MenhirCell1_varlist of 's * ('s, 'r) _menhir_state * (Parsed_term.list_el list) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_AND = 
  | MenhirCell1_AND of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_ARGS_OF = 
  | MenhirCell1_ARGS_OF of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_AT = 
  | MenhirCell1_AT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_BEGIN = 
  | MenhirCell1_BEGIN of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_BEGIN_INTERPOLATION = 
  | MenhirCell1_BEGIN_INTERPOLATION of 's * ('s, 'r) _menhir_state * (
# 77 "src/lang/parser.mly"
       (char)
# 1472 "src/lang/parser.ml"
) * Lexing.position

and ('s, 'r) _menhir_cell1_BIN1 = 
  | MenhirCell1_BIN1 of 's * ('s, 'r) _menhir_state * (
# 62 "src/lang/parser.mly"
       (string)
# 1479 "src/lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_BIN2 = 
  | MenhirCell1_BIN2 of 's * ('s, 'r) _menhir_state * (
# 63 "src/lang/parser.mly"
       (string)
# 1486 "src/lang/parser.ml"
)

and ('s, 'r) _menhir_cell1_BIN3 = 
  | MenhirCell1_BIN3 of 's * ('s, 'r) _menhir_state * (
# 64 "src/lang/parser.mly"
       (string)
# 1493 "src/lang/parser.ml"
)

and ('s, 'r) _menhir_cell1_COALESCE = 
  | MenhirCell1_COALESCE of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_COLON = 
  | MenhirCell1_COLON of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_COLONCOLON = 
  | MenhirCell1_COLONCOLON of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_COMMA = 
  | MenhirCell1_COMMA of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_DO = 
  | MenhirCell1_DO of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_DOT = 
  | MenhirCell1_DOT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_DOTDOTDOT = 
  | MenhirCell1_DOTDOTDOT of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and 's _menhir_cell0_DOTDOTDOT = 
  | MenhirCell0_DOTDOTDOT of 's * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_ELSE = 
  | MenhirCell1_ELSE of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_ELSIF = 
  | MenhirCell1_ELSIF of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_ENCODER = 
  | MenhirCell1_ENCODER of 's * ('s, 'r) _menhir_state * (
# 42 "src/lang/parser.mly"
       (string)
# 1530 "src/lang/parser.ml"
) * Lexing.position

and 's _menhir_cell0_ENCODER = 
  | MenhirCell0_ENCODER of 's * (
# 42 "src/lang/parser.mly"
       (string)
# 1537 "src/lang/parser.ml"
) * Lexing.position

and ('s, 'r) _menhir_cell1_FOR = 
  | MenhirCell1_FOR of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_FUN = 
  | MenhirCell1_FUN of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_GET = 
  | MenhirCell1_GET of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_GETS = 
  | MenhirCell1_GETS of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_IF = 
  | MenhirCell1_IF of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_LBRA = 
  | MenhirCell1_LBRA of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_LCUR = 
  | MenhirCell1_LCUR of 's * ('s, 'r) _menhir_state * Lexing.position

and 's _menhir_cell0_LCUR = 
  | MenhirCell0_LCUR of 's * Lexing.position

and ('s, 'r) _menhir_cell1_LETLBRA = 
  | MenhirCell1_LETLBRA of 's * ('s, 'r) _menhir_state * (
# 45 "src/lang/parser.mly"
       (Parser_helper.lexer_let_decoration)
# 1568 "src/lang/parser.ml"
) * Lexing.position

and ('s, 'r) _menhir_cell1_LPAR = 
  | MenhirCell1_LPAR of 's * ('s, 'r) _menhir_state * Lexing.position

and 's _menhir_cell0_LPAR = 
  | MenhirCell0_LPAR of 's * Lexing.position

and ('s, 'r) _menhir_cell1_MINUS = 
  | MenhirCell1_MINUS of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_NOT = 
  | MenhirCell1_NOT of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_OPEN = 
  | MenhirCell1_OPEN of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_OR = 
  | MenhirCell1_OR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_PP_IFDEF = 
  | MenhirCell1_PP_IFDEF of 's * ('s, 'r) _menhir_state * (
# 71 "src/lang/parser.mly"
       (bool)
# 1593 "src/lang/parser.ml"
) * Lexing.position

and ('s, 'r) _menhir_cell1_PP_IFENCODER = 
  | MenhirCell1_PP_IFENCODER of 's * ('s, 'r) _menhir_state * (
# 74 "src/lang/parser.mly"
       (bool)
# 1600 "src/lang/parser.ml"
) * Lexing.position

and ('s, 'r) _menhir_cell1_PP_IFVERSION = 
  | MenhirCell1_PP_IFVERSION of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_QUESTION = 
  | MenhirCell1_QUESTION of 's * ('s, 'r) _menhir_state * Lexing.position

and 's _menhir_cell0_QUESTION = 
  | MenhirCell0_QUESTION of 's * Lexing.position

and ('s, 'r) _menhir_cell1_QUESTION_DOT = 
  | MenhirCell1_QUESTION_DOT of 's * ('s, 'r) _menhir_state

and 's _menhir_cell0_RPAR = 
  | MenhirCell0_RPAR of 's * Lexing.position

and ('s, 'r) _menhir_cell1_SET = 
  | MenhirCell1_SET of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_STRING = 
  | MenhirCell1_STRING of 's * ('s, 'r) _menhir_state * (
# 35 "src/lang/parser.mly"
       (char * string )
# 1625 "src/lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_TILD = 
  | MenhirCell1_TILD of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_TIMES = 
  | MenhirCell1_TIMES of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_TO = 
  | MenhirCell1_TO of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_TRY = 
  | MenhirCell1_TRY of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_UMINUS = 
  | MenhirCell1_UMINUS of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_UNDERSCORE = 
  | MenhirCell1_UNDERSCORE of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_VAR = 
  | MenhirCell1_VAR of 's * ('s, 'r) _menhir_state * (
# 29 "src/lang/parser.mly"
       (string)
# 1650 "src/lang/parser.ml"
) * Lexing.position * Lexing.position

and 's _menhir_cell0_VAR = 
  | MenhirCell0_VAR of 's * (
# 29 "src/lang/parser.mly"
       (string)
# 1657 "src/lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_VARLBRA = 
  | MenhirCell1_VARLBRA of 's * ('s, 'r) _menhir_state * (
# 31 "src/lang/parser.mly"
       (string)
# 1664 "src/lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_VARLPAR = 
  | MenhirCell1_VARLPAR of 's * ('s, 'r) _menhir_state * (
# 30 "src/lang/parser.mly"
       (string)
# 1671 "src/lang/parser.ml"
) * Lexing.position * Lexing.position

and 's _menhir_cell0_VARLPAR = 
  | MenhirCell0_VARLPAR of 's * (
# 30 "src/lang/parser.mly"
       (string)
# 1678 "src/lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_WHILE = 
  | MenhirCell1_WHILE of 's * ('s, 'r) _menhir_state * Lexing.position

and _menhir_box_time_predicate = 
  | MenhirBox_time_predicate of (Parsed_term.t) [@@unboxed]

and _menhir_box_program = 
  | MenhirBox_program of (Parsed_term.t) [@@unboxed]

and _menhir_box_plain_encoder_params = 
  | MenhirBox_plain_encoder_params of (Parser_helper.Term.encoder_params) [@@unboxed]

and _menhir_box_interactive = 
  | MenhirBox_interactive of (Parsed_term.t) [@@unboxed]

and _menhir_box_annotate_metadata_entry = 
  | MenhirBox_annotate_metadata_entry of (string * string) [@@unboxed]

and _menhir_box_annotate = 
  | MenhirBox_annotate of ((string * string) list) [@@unboxed]

let _menhir_action_006 =
  fun _1 ->
    (
# 482 "src/lang/parser.mly"
        ( Parser_helper.let_decoration_of_lexer_let_decoration _1 )
# 1707 "src/lang/parser.ml"
     : (Parsed_term.let_decoration))

let _menhir_action_007 =
  fun _1 _2 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 483 "src/lang/parser.mly"
                         (
      match _1 with
        | `Json_parse     -> `Json_parse (Parser_helper.args_of_json_parse ~pos:_loc _2)
        | _ -> raise (Term_base.Parse_error (_loc, "Invalid let constructor")) )
# 1721 "src/lang/parser.ml"
     : (Parsed_term.let_decoration))

let _menhir_action_008 =
  fun _1 ->
    (
# 663 "src/lang/parser.mly"
                            ( _1 )
# 1729 "src/lang/parser.ml"
     : ((string * string) list))

let _menhir_action_009 =
  fun _1 ->
    (
# 673 "src/lang/parser.mly"
        ( _1 )
# 1737 "src/lang/parser.ml"
     : (string))

let _menhir_action_010 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 674 "src/lang/parser.mly"
           ( render_string ~pos:_loc _1 )
# 1748 "src/lang/parser.ml"
     : (string))

let _menhir_action_011 =
  fun _1 _2 ->
    (
# 666 "src/lang/parser.mly"
                                              ( _1::_2 )
# 1756 "src/lang/parser.ml"
     : ((string * string) list))

let _menhir_action_012 =
  fun _1 _3 ->
    (
# 667 "src/lang/parser.mly"
                                     ( [_1, _3] )
# 1764 "src/lang/parser.ml"
     : ((string * string) list))

let _menhir_action_013 =
  fun _1 _3 ->
    (
# 670 "src/lang/parser.mly"
                                           ( _1, _3 )
# 1772 "src/lang/parser.ml"
     : (string * string))

let _menhir_action_014 =
  fun _1 ->
    (
# 677 "src/lang/parser.mly"
        ( _1 )
# 1780 "src/lang/parser.ml"
     : (string))

let _menhir_action_015 =
  fun _1 ->
    (
# 678 "src/lang/parser.mly"
          ( _1 )
# 1788 "src/lang/parser.ml"
     : (string))

let _menhir_action_016 =
  fun _1 ->
    (
# 679 "src/lang/parser.mly"
         ( string_of_bool _1 )
# 1796 "src/lang/parser.ml"
     : (string))

let _menhir_action_017 =
  fun _1 ->
    (
# 680 "src/lang/parser.mly"
        ( _1 )
# 1804 "src/lang/parser.ml"
     : (string))

let _menhir_action_018 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 681 "src/lang/parser.mly"
           ( render_string ~pos:_loc _1 )
# 1815 "src/lang/parser.ml"
     : (string))

let _menhir_action_019 =
  fun () ->
    (
# 394 "src/lang/parser.mly"
                                 ( [] )
# 1823 "src/lang/parser.ml"
     : (Parsed_term.app_arg list))

let _menhir_action_020 =
  fun _1 ->
    (
# 395 "src/lang/parser.mly"
                                 ( [_1] )
# 1831 "src/lang/parser.ml"
     : (Parsed_term.app_arg list))

let _menhir_action_021 =
  fun _1 _3 ->
    (
# 396 "src/lang/parser.mly"
                                 ( _1::_3 )
# 1839 "src/lang/parser.ml"
     : (Parsed_term.app_arg list))

let _menhir_action_022 =
  fun _1 _3 ->
    (
# 382 "src/lang/parser.mly"
                  ( `Term (_1,_3) )
# 1847 "src/lang/parser.ml"
     : (Parsed_term.app_arg))

let _menhir_action_023 =
  fun _1 ->
    (
# 383 "src/lang/parser.mly"
                  ( `Term ("",_1) )
# 1855 "src/lang/parser.ml"
     : (Parsed_term.app_arg))

let _menhir_action_024 =
  fun _3 ->
    (
# 384 "src/lang/parser.mly"
                                 ( `Argsof {only = []; except = []; source = _3 } )
# 1863 "src/lang/parser.ml"
     : (Parsed_term.app_arg))

let _menhir_action_025 =
  fun _3 ->
    (
# 386 "src/lang/parser.mly"
                                 ( `Argsof {only = []; except = []; source = String.concat "." _3 } )
# 1871 "src/lang/parser.ml"
     : (Parsed_term.app_arg))

let _menhir_action_026 =
  fun _3 _4 ->
    (
# 387 "src/lang/parser.mly"
                                                  (
                                   `Argsof {only = fst _4; except = snd _4; source = _3 }
                                 )
# 1881 "src/lang/parser.ml"
     : (Parsed_term.app_arg))

let _menhir_action_027 =
  fun _3 _4 ->
    (
# 391 "src/lang/parser.mly"
                                 ( `Argsof {only = fst _4; except = snd _4; source = String.concat "." _3} )
# 1889 "src/lang/parser.ml"
     : (Parsed_term.app_arg))

let _menhir_action_028 =
  fun _2 _3 ->
    (
# 516 "src/lang/parser.mly"
                 ( `Term {label = _2; as_variable = None; typ = None; default = _3} )
# 1897 "src/lang/parser.ml"
     : (Parsed_term.fun_arg))

let _menhir_action_029 =
  fun _3 _5 _7 ->
    (
# 517 "src/lang/parser.mly"
                                    (
                   `Term {label = _3; as_variable = None; typ =  Some _5; default = _7}
                 )
# 1907 "src/lang/parser.ml"
     : (Parsed_term.fun_arg))

let _menhir_action_030 =
  fun _2 _5 ->
    (
# 520 "src/lang/parser.mly"
                                 (
                   `Term {label = _2; as_variable = Some "_"; typ = None; default = _5}
                 )
# 1917 "src/lang/parser.ml"
     : (Parsed_term.fun_arg))

let _menhir_action_031 =
  fun _1 _2 ->
    (
# 523 "src/lang/parser.mly"
                 ( `Term {label = ""; as_variable = Some _1; typ = None; default = _2} )
# 1925 "src/lang/parser.ml"
     : (Parsed_term.fun_arg))

let _menhir_action_032 =
  fun _2 _4 _6 ->
    (
# 524 "src/lang/parser.mly"
                                  (
                   `Term {label = ""; as_variable =  Some _2; typ = Some _4; default =  _6}
                 )
# 1935 "src/lang/parser.ml"
     : (Parsed_term.fun_arg))

let _menhir_action_033 =
  fun _3 ->
    (
# 527 "src/lang/parser.mly"
                          (
                   `Argsof {only = []; except = []; source = _3 }
                 )
# 1945 "src/lang/parser.ml"
     : (Parsed_term.fun_arg))

let _menhir_action_034 =
  fun _3 ->
    (
# 530 "src/lang/parser.mly"
                               (
                   `Argsof {only = []; except = []; source = String.concat "." _3 }
                 )
# 1955 "src/lang/parser.ml"
     : (Parsed_term.fun_arg))

let _menhir_action_035 =
  fun _3 _4 ->
    (
# 533 "src/lang/parser.mly"
                                                  (
                   `Argsof {only = fst _4; except = snd _4; source = _3 }
                )
# 1965 "src/lang/parser.ml"
     : (Parsed_term.fun_arg))

let _menhir_action_036 =
  fun _3 _4 ->
    (
# 536 "src/lang/parser.mly"
                                                        (
                   `Argsof {only = fst _4; except = snd _4; source = String.concat "." _3 }
                )
# 1975 "src/lang/parser.ml"
     : (Parsed_term.fun_arg))

let _menhir_action_037 =
  fun () ->
    (
# 512 "src/lang/parser.mly"
                          ( [] )
# 1983 "src/lang/parser.ml"
     : (Parser_helper.arglist))

let _menhir_action_038 =
  fun _1 ->
    (
# 513 "src/lang/parser.mly"
                          ( [_1] )
# 1991 "src/lang/parser.ml"
     : (Parser_helper.arglist))

let _menhir_action_039 =
  fun _1 _3 ->
    (
# 514 "src/lang/parser.mly"
                          ( _1::_3 )
# 1999 "src/lang/parser.ml"
     : (Parser_helper.arglist))

let _menhir_action_040 =
  fun _1 ->
    (
# 544 "src/lang/parser.mly"
                                 ( [_1], [] )
# 2007 "src/lang/parser.ml"
     : (string list * string list))

let _menhir_action_041 =
  fun _2 ->
    (
# 545 "src/lang/parser.mly"
                                 ( [], [_2] )
# 2015 "src/lang/parser.ml"
     : (string list * string list))

let _menhir_action_042 =
  fun _1 _3 ->
    (
# 546 "src/lang/parser.mly"
                                 ( _1::(fst _3), (snd _3) )
# 2023 "src/lang/parser.ml"
     : (string list * string list))

let _menhir_action_043 =
  fun _2 _4 ->
    (
# 547 "src/lang/parser.mly"
                                 ( (fst _4), _2::(snd _4) )
# 2031 "src/lang/parser.ml"
     : (string list * string list))

let _menhir_action_044 =
  fun () ->
    (
# 360 "src/lang/parser.mly"
                       ( [] )
# 2039 "src/lang/parser.ml"
     : (Parsed_term.type_annotation Type.argument list))

let _menhir_action_045 =
  fun _1 ->
    (
# 361 "src/lang/parser.mly"
                       ( [_1] )
# 2047 "src/lang/parser.ml"
     : (Parsed_term.type_annotation Type.argument list))

let _menhir_action_046 =
  fun _1 _3 ->
    (
# 362 "src/lang/parser.mly"
                       ( _1::_3 )
# 2055 "src/lang/parser.ml"
     : (Parsed_term.type_annotation Type.argument list))

let _menhir_action_047 =
  fun _1 ->
    (
# 355 "src/lang/parser.mly"
                          ( false,"",_1 )
# 2063 "src/lang/parser.ml"
     : (Parsed_term.type_annotation Type.argument))

let _menhir_action_048 =
  fun _1 _3 ->
    (
# 356 "src/lang/parser.mly"
                          ( false,_1,_3 )
# 2071 "src/lang/parser.ml"
     : (Parsed_term.type_annotation Type.argument))

let _menhir_action_049 =
  fun _2 _4 ->
    (
# 357 "src/lang/parser.mly"
                          ( true,_2,_4 )
# 2079 "src/lang/parser.ml"
     : (Parsed_term.type_annotation Type.argument))

let _menhir_action_050 =
  fun _1 _3 _endpos__1_ _startpos__1_ ->
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    (
# 504 "src/lang/parser.mly"
                             ( `Binding Parser_helper.(let_args ~decoration:`None ~pat:({ pat_pos = _loc__1_; pat_entry = `PVar [_1] }) ~def:_3 ()) )
# 2088 "src/lang/parser.ml"
     : (Parser_helper.binding))

let _menhir_action_051 =
  fun _1 ->
    (
# 505 "src/lang/parser.mly"
                             ( (_1 :> binding) )
# 2096 "src/lang/parser.ml"
     : (Parser_helper.binding))

let _menhir_action_052 =
  fun _1 ->
    (
# 489 "src/lang/parser.mly"
        ( Parser_helper.let_decoration_of_lexer_let_decoration _1 )
# 2104 "src/lang/parser.ml"
     : (Parsed_term.let_decoration))

let _menhir_action_053 =
  fun () ->
    (
# 561 "src/lang/parser.mly"
                 ( [] )
# 2112 "src/lang/parser.ml"
     : (Parser_helper.Term.encoder_params))

let _menhir_action_054 =
  fun _2 ->
    (
# 562 "src/lang/parser.mly"
                             ( _2 )
# 2120 "src/lang/parser.ml"
     : (Parser_helper.Term.encoder_params))

let _menhir_action_055 =
  fun _1 _3 ->
    (
# 565 "src/lang/parser.mly"
                        ( `Labelled (`Verbatim _1, _3) )
# 2128 "src/lang/parser.ml"
     : ([ `Anonymous of Parsed_term.string_param
  | `Encoder of Parsed_term.encoder
  | `Labelled of Parsed_term.string_param * Parsed_term.t ]))

let _menhir_action_056 =
  fun _1 _3 _endpos__1_ _startpos__1_ ->
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    (
# 566 "src/lang/parser.mly"
                        ( `Labelled (`String (_loc__1_, _1), _3) )
# 2139 "src/lang/parser.ml"
     : ([ `Anonymous of Parsed_term.string_param
  | `Encoder of Parsed_term.encoder
  | `Labelled of Parsed_term.string_param * Parsed_term.t ]))

let _menhir_action_057 =
  fun _1 ->
    (
# 567 "src/lang/parser.mly"
                        ( `Anonymous (`Verbatim _1) )
# 2149 "src/lang/parser.ml"
     : ([ `Anonymous of Parsed_term.string_param
  | `Encoder of Parsed_term.encoder
  | `Labelled of Parsed_term.string_param * Parsed_term.t ]))

let _menhir_action_058 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    (
# 568 "src/lang/parser.mly"
                        ( `Anonymous (`String ((_loc__1_, _1))) )
# 2160 "src/lang/parser.ml"
     : ([ `Anonymous of Parsed_term.string_param
  | `Encoder of Parsed_term.encoder
  | `Labelled of Parsed_term.string_param * Parsed_term.t ]))

let _menhir_action_059 =
  fun _1 _2 ->
    (
# 569 "src/lang/parser.mly"
                        ( `Encoder (_1, _2) )
# 2170 "src/lang/parser.ml"
     : ([ `Anonymous of Parsed_term.string_param
  | `Encoder of Parsed_term.encoder
  | `Labelled of Parsed_term.string_param * Parsed_term.t ]))

let _menhir_action_060 =
  fun () ->
    (
# 572 "src/lang/parser.mly"
                                       ( [] )
# 2180 "src/lang/parser.ml"
     : (Parser_helper.Term.encoder_params))

let _menhir_action_061 =
  fun _1 ->
    (
# 573 "src/lang/parser.mly"
                                       ( [_1] )
# 2188 "src/lang/parser.ml"
     : (Parser_helper.Term.encoder_params))

let _menhir_action_062 =
  fun _1 _3 ->
    (
# 574 "src/lang/parser.mly"
                                       ( _1::_3 )
# 2196 "src/lang/parser.ml"
     : (Parser_helper.Term.encoder_params))

let _menhir_action_063 =
  fun _1 _2 _4 ->
    (
# 492 "src/lang/parser.mly"
                             ( `Let Parser_helper.(let_args ~decoration:_1 ~pat:_2 ~def:_4 ()) )
# 2204 "src/lang/parser.ml"
     : (Parser_helper.explicit_binding))

let _menhir_action_064 =
  fun _1 _3 _5 _8 ->
    (
# 494 "src/lang/parser.mly"
                             ( `Let Parser_helper.(let_args ~decoration:_1 ~pat:_3 ~def:_8 ~cast:_5 ()) )
# 2212 "src/lang/parser.ml"
     : (Parser_helper.explicit_binding))

let _menhir_action_065 =
  fun _1 _2 _4 _endpos__2_ _startpos__2_ ->
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    (
# 495 "src/lang/parser.mly"
                             ( `Let Parser_helper.(let_args ~decoration:_1 ~pat:({ pat_pos = _loc__2_; pat_entry = `PVar _2 }) ~def:_4 ()) )
# 2221 "src/lang/parser.ml"
     : (Parser_helper.explicit_binding))

let _menhir_action_066 =
  fun _1 _2 _4 _endpos__2_ _startpos__2_ ->
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    (
# 496 "src/lang/parser.mly"
                             ( `Def Parser_helper.(let_args ~decoration:_1 ~pat:({ pat_pos = _loc__2_; pat_entry = `PVar [_2] }) ~def:_4 ()) )
# 2230 "src/lang/parser.ml"
     : (Parser_helper.explicit_binding))

let _menhir_action_067 =
  fun _1 _3 _5 _8 _endpos__3_ _startpos__3_ ->
    let _loc__3_ = (_startpos__3_, _endpos__3_) in
    (
# 498 "src/lang/parser.mly"
                             ( `Def Parser_helper.(let_args ~decoration:_1 ~pat:({ pat_pos = _loc__3_; pat_entry =`PVar [_3] }) ~def:_8 ~cast:_5 ()) )
# 2239 "src/lang/parser.ml"
     : (Parser_helper.explicit_binding))

let _menhir_action_068 =
  fun _1 _2 _4 _endpos__2_ _startpos__2_ ->
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    (
# 499 "src/lang/parser.mly"
                             ( `Def Parser_helper.(let_args ~decoration:_1 ~pat:({ pat_pos = _loc__2_; pat_entry = `PVar _2 }) ~def:_4 ()) )
# 2248 "src/lang/parser.ml"
     : (Parser_helper.explicit_binding))

let _menhir_action_069 =
  fun _1 _2 _3 _6 _endpos__2_ _startpos__2_ ->
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    (
# 501 "src/lang/parser.mly"
                             ( `Def Parser_helper.(let_args ~decoration:_1 ~pat:({ pat_pos = _loc__2_; pat_entry = `PVar _2 }) ~arglist:_3 ~def:_6 ()) )
# 2257 "src/lang/parser.ml"
     : (Parser_helper.explicit_binding))

let _menhir_action_070 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 201 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Include _1) )
# 2268 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_071 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 202 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`If_def _1) )
# 2279 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_072 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 203 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`If_encoder _1) )
# 2290 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_073 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 204 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`If_version _1) )
# 2301 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_074 =
  fun _2 _4 _endpos__5_ _startpos__1_ ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 205 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Cast {cast = _2; typ = _4}) )
# 2312 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_075 =
  fun _2 _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 206 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Negative _2) )
# 2323 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_076 =
  fun _2 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 207 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Parenthesis _2) )
# 2334 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_077 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 208 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Int _1) )
# 2345 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_078 =
  fun _2 _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 209 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Not _2) )
# 2356 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_079 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 210 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Bool _1) )
# 2367 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_080 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 211 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Float _1) )
# 2378 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_081 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 212 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`String _1) )
# 2389 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_082 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 213 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`String_interpolation _1) )
# 2400 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_083 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 214 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Var _1) )
# 2411 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_084 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 215 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`List _1) )
# 2422 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_085 =
  fun _2 _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 216 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Get _2) )
# 2433 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_086 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 217 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Set (_1, _3)) )
# 2444 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_087 =
  fun _1 _2 _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 218 "src/lang/parser.mly"
                                     ( mk_encoder ~pos:_loc _1 _2 )
# 2455 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_088 =
  fun _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 219 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Tuple []) )
# 2466 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_089 =
  fun _2 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 220 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Tuple _2) )
# 2477 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_090 =
  fun _1 _4 _endpos__5_ _startpos__1_ ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 221 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Methods (Some _1, _4)) )
# 2488 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_091 =
  fun _1 _4 _endpos__6_ _startpos__1_ ->
    let _endpos = _endpos__6_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 223 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Methods (Some _1, _4)) )
# 2499 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_092 =
  fun _2 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 224 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Methods (None, _2)) )
# 2510 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_093 =
  fun _2 _endpos__4_ _startpos__1_ ->
    let _endpos = _endpos__4_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 225 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Methods (None, _2)) )
# 2521 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_094 =
  fun _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 226 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Methods (None, [])) )
# 2532 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_095 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 227 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Invoke { invoked = _1; meth = _3; optional = true }) )
# 2543 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_096 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 228 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Invoke { invoked = _1; meth = _3; optional = false }) )
# 2554 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_097 =
  fun _1 _2 _endpos__1_ _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 229 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`App (mk ~pos:_loc__1_ (`Var _1), _2)) )
# 2566 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_098 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 230 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Append (_1, _3)) )
# 2577 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_099 =
  fun _1 _2 _endpos__1_ _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 231 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Assoc (mk ~pos:_loc__1_ (`Var _1), _2)) )
# 2589 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_100 =
  fun _1 _3 _4 _endpos__3_ _endpos__5_ _startpos__1_ ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 232 "src/lang/parser.mly"
                                     ( let src = mk ~pos:(_startpos__1_,_endpos__3_) (`Invoke ({invoked = _1; optional = false; meth = `String _3})) in
                                       mk ~pos:_loc (`Assoc (src, _4)) )
# 2601 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_101 =
  fun _2 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 234 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Block _2) )
# 2612 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_102 =
  fun _3 _6 _endpos__6_ _startpos__1_ ->
    let _endpos = _endpos__6_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 235 "src/lang/parser.mly"
                                     ( mk_fun ~pos:_loc _3 _6 )
# 2623 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_103 =
  fun _2 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 236 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Simple_fun _2) )
# 2634 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_104 =
  fun _2 _4 _endpos__5_ _startpos__1_ ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 237 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`While {while_condition = _2; while_loop = _4 }) )
# 2645 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_105 =
  fun _2 _4 _6 _8 _endpos__9_ _startpos__1_ ->
    let _endpos = _endpos__9_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 239 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`For { for_variable = _2; for_from = _4; for_to = _6; for_loop = _8 }) )
# 2656 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_106 =
  fun _2 _4 _6 _endpos__7_ _startpos__1_ ->
    let _endpos = _endpos__7_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 241 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Iterable_for {
                                         iterable_for_variable = _2;
                                         iterable_for_iterator = _4;
                                         iterable_for_loop = _6
                                       } ) )
# 2671 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_107 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 246 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Coalesce (_1, _3)) )
# 2682 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_108 =
  fun _2 _4 _endpos__5_ _startpos__1_ ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 247 "src/lang/parser.mly"
                                         ( mk_try ~pos:_loc ~ensure:_4 ~variable:"_" ~body:_2 () )
# 2693 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_109 =
  fun _2 _4 _6 _8 _endpos__6_ _endpos__9_ _startpos__1_ _startpos__6_ ->
    let _endpos = _endpos__9_ in
    let _startpos = _startpos__1_ in
    let _loc__6_ = (_startpos__6_, _endpos__6_) in
    let _loc = (_startpos, _endpos) in
    (
# 249 "src/lang/parser.mly"
                                     ( mk_try ~pos:_loc ~handler:_8 ~errors_list:(mk ~pos:_loc__6_ (`List _6)) ~variable:_4 ~body:_2 () )
# 2705 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_110 =
  fun _10 _2 _4 _6 _8 _endpos__11_ _endpos__6_ _startpos__1_ _startpos__6_ ->
    let _endpos = _endpos__11_ in
    let _startpos = _startpos__1_ in
    let _loc__6_ = (_startpos__6_, _endpos__6_) in
    let _loc = (_startpos, _endpos) in
    (
# 251 "src/lang/parser.mly"
                                     ( mk_try ~pos:_loc ~ensure:_10 ~handler:_8 ~errors_list:(mk ~pos:_loc__6_ (`List _6)) ~variable:_4 ~body:_2 () )
# 2717 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_111 =
  fun _2 _4 _6 _endpos__7_ _startpos__1_ ->
    let _endpos = _endpos__7_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 253 "src/lang/parser.mly"
                                     ( mk_try ~pos:_loc ~handler:_6 ~variable:_4 ~body:_2 () )
# 2728 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_112 =
  fun _2 _4 _6 _8 _endpos__9_ _startpos__1_ ->
    let _endpos = _endpos__9_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 255 "src/lang/parser.mly"
                                     ( mk_try ~pos:_loc ~ensure:_8 ~handler:_6 ~variable:_4 ~body:_2 () )
# 2739 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_113 =
  fun _2 _4 _5 _endpos__6_ _startpos__1_ ->
    let _endpos = _endpos__6_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 256 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`If {if_condition = _2; if_then = _4; if_elsif = fst _5; if_else = snd _5 }) )
# 2750 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_114 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 257 "src/lang/parser.mly"
                                     (  mk ~pos:_loc (`Regexp _1) )
# 2761 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_115 =
  fun _1 _3 _5 _endpos__5_ _startpos__1_ ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 258 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (`Inline_if {if_condition = _1; if_then = _3; if_elsif = []; if_else = Some _5}) )
# 2772 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_116 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 259 "src/lang/parser.mly"
                                   ( match _1.term, _3.term with
                                       | `BoolOp ("and", l), `BoolOp ("and", l') -> mk ~pos:_loc (`BoolOp ("and", l@l'))
                                       |  `BoolOp ("and", l), _ -> mk ~pos:_loc (`BoolOp ("and", l@[_3]))
                                       |  _, `BoolOp ("and", l) -> mk ~pos:_loc (`BoolOp ("and", _1::l))
                                       | _ -> mk ~pos:_loc (`BoolOp ("and", [_1; _3])) )
# 2787 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_117 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 264 "src/lang/parser.mly"
                                  ( match _1.term, _3.term with
                                       | `BoolOp ("or", l), `BoolOp ("or", l') -> mk ~pos:_loc (`BoolOp ("or", l@l'))
                                       |  `BoolOp ("or", l), _ -> mk ~pos:_loc (`BoolOp ("or", l@[_3]))
                                       |  _, `BoolOp ("or", l) -> mk ~pos:_loc (`BoolOp ("or", _1::l))
                                       | _ -> mk ~pos:_loc (`BoolOp ("or", [_1; _3])) )
# 2802 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_118 =
  fun _1 _2 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 269 "src/lang/parser.mly"
                                   ( mk ~pos:_loc (`Infix (_1, _2, _3)) )
# 2813 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_119 =
  fun _1 _2 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 270 "src/lang/parser.mly"
                                   ( mk ~pos:_loc (`Infix (_1, _2, _3)) )
# 2824 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_120 =
  fun _1 _2 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 271 "src/lang/parser.mly"
                                   ( mk ~pos:_loc (`Infix (_1, _2, _3)) )
# 2835 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_121 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 272 "src/lang/parser.mly"
                                   ( mk ~pos:_loc (`Infix (_1, "*", _3)) )
# 2846 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_122 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 273 "src/lang/parser.mly"
                                   ( mk ~pos:_loc (`Infix (_1, "-", _3)) )
# 2857 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_123 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 274 "src/lang/parser.mly"
                                   ( mk ~pos:_loc (`At (_1, _3)) )
# 2868 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_124 =
  fun _1 ->
    (
# 275 "src/lang/parser.mly"
                                   ( _1 )
# 2876 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_125 =
  fun _2 _4 _endpos__4_ _startpos__1_ ->
    let _endpos = _endpos__4_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 184 "src/lang/parser.mly"
                             ( mk ~pos:_loc (`Open (_2,_4)) )
# 2887 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_126 =
  fun _1 ->
    (
# 185 "src/lang/parser.mly"
                             ( _1 )
# 2895 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_127 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 186 "src/lang/parser.mly"
                             ( mk ~pos:_loc (`Seq (_1,_3)) )
# 2906 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_128 =
  fun _1 _endpos__1_ _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 187 "src/lang/parser.mly"
                             ( mk_let ~pos:_loc__1_ _1 (mk ~pos:_loc `Eof) )
# 2918 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_129 =
  fun _1 _3 _endpos__1_ _startpos__1_ ->
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    (
# 188 "src/lang/parser.mly"
                             ( mk_let ~pos:_loc__1_ _1 _3 )
# 2927 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_130 =
  fun () ->
    (
# 181 "src/lang/parser.mly"
     ()
# 2935 "src/lang/parser.ml"
     : (unit))

let _menhir_action_131 =
  fun () ->
    (
# 181 "src/lang/parser.mly"
               ()
# 2943 "src/lang/parser.ml"
     : (unit))

let _menhir_action_132 =
  fun _1 _2 _3 ->
    (
# 605 "src/lang/parser.mly"
                                       ( {
      if_def_negative = _1;
      if_def_condition = String.concat "." _2;
      if_def_then = _3;
      if_def_else = None
   } )
# 2956 "src/lang/parser.ml"
     : (Parsed_term.if_def))

let _menhir_action_133 =
  fun _1 _2 _3 _5 ->
    (
# 611 "src/lang/parser.mly"
                                                     ( {
      if_def_negative = _1;
      if_def_condition = String.concat "." _2;
      if_def_then = _3;
      if_def_else = Some _5;
  } )
# 2969 "src/lang/parser.ml"
     : (Parsed_term.if_def))

let _menhir_action_134 =
  fun _1 ->
    (
# 601 "src/lang/parser.mly"
                       ( [_1] )
# 2977 "src/lang/parser.ml"
     : (string list))

let _menhir_action_135 =
  fun _1 _3 ->
    (
# 602 "src/lang/parser.mly"
                       ( _1::_3 )
# 2985 "src/lang/parser.ml"
     : (string list))

let _menhir_action_136 =
  fun _2 _4 _5 ->
    (
# 556 "src/lang/parser.mly"
                                    ( (_2, _4)::(fst _5), snd _5 )
# 2993 "src/lang/parser.ml"
     : ((Parsed_term.t * Parsed_term.t) list * Parsed_term.t option))

let _menhir_action_137 =
  fun _2 ->
    (
# 557 "src/lang/parser.mly"
                                    ( [], Some _2 )
# 3001 "src/lang/parser.ml"
     : ((Parsed_term.t * Parsed_term.t) list * Parsed_term.t option))

let _menhir_action_138 =
  fun () ->
    (
# 558 "src/lang/parser.mly"
                                    ( [], None )
# 3009 "src/lang/parser.ml"
     : ((Parsed_term.t * Parsed_term.t) list * Parsed_term.t option))

let _menhir_action_139 =
  fun _1 _2 _3 ->
    (
# 619 "src/lang/parser.mly"
                                        ( {
      if_encoder_negative = _1;
      if_encoder_condition = _2;
      if_encoder_then = _3;
      if_encoder_else = None
   } )
# 3022 "src/lang/parser.ml"
     : (Parsed_term.if_encoder))

let _menhir_action_140 =
  fun _1 _2 _3 _5 ->
    (
# 625 "src/lang/parser.mly"
                                                      ( {
      if_encoder_negative = _1;
      if_encoder_condition = _2;
      if_encoder_then = _3;
      if_encoder_else = Some _5;
  } )
# 3035 "src/lang/parser.ml"
     : (Parsed_term.if_encoder))

let _menhir_action_141 =
  fun _2 _3 _4 ->
    (
# 649 "src/lang/parser.mly"
                                                                 ( {
      if_version_op = _2;
      if_version_version = _3;
      if_version_then = _4;
      if_version_else = None
   } )
# 3048 "src/lang/parser.ml"
     : (Parsed_term.if_version))

let _menhir_action_142 =
  fun _2 _3 _4 _6 ->
    (
# 655 "src/lang/parser.mly"
                                                                               ( {
      if_version_op = _2;
      if_version_version = _3;
      if_version_then = _4;
      if_version_else = Some _6;
  } )
# 3061 "src/lang/parser.ml"
     : (Parsed_term.if_version))

let _menhir_action_143 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 633 "src/lang/parser.mly"
         (
      match _1 with
        | "==" -> `Eq
        | ">=" -> `Geq
        | "<=" -> `Leq
        | "<" -> `Lt
        | ">" -> `Gt
        | _ -> raise (Term_base.Parse_error (_loc, "invalid %ifversion operand"))
  )
# 3080 "src/lang/parser.ml"
     : ([ `Eq | `Geq | `Gt | `Leq | `Lt ]))

let _menhir_action_144 =
  fun _1 ->
    (
# 644 "src/lang/parser.mly"
             ( _1 )
# 3088 "src/lang/parser.ml"
     : (Lang_string.Version.t))

let _menhir_action_145 =
  fun _1 ->
    (
# 645 "src/lang/parser.mly"
             ( Lang_string.Version.of_string _1 )
# 3096 "src/lang/parser.ml"
     : (Lang_string.Version.t))

let _menhir_action_146 =
  fun _1 ->
    (
# 646 "src/lang/parser.mly"
             ( Lang_string.Version.of_string _1 )
# 3104 "src/lang/parser.ml"
     : (Lang_string.Version.t))

let _menhir_action_147 =
  fun _1 ->
    (
# 470 "src/lang/parser.mly"
                        ( [_1] )
# 3112 "src/lang/parser.ml"
     : (string list))

let _menhir_action_148 =
  fun _1 _3 ->
    (
# 471 "src/lang/parser.mly"
                        ( _1::_3 )
# 3120 "src/lang/parser.ml"
     : (string list))

let _menhir_action_149 =
  fun _1 ->
    (
# 552 "src/lang/parser.mly"
            ( [_1] )
# 3128 "src/lang/parser.ml"
     : (string list))

let _menhir_action_150 =
  fun _1 _3 ->
    (
# 553 "src/lang/parser.mly"
                             ( _1::_3 )
# 3136 "src/lang/parser.ml"
     : (string list))

let _menhir_action_151 =
  fun _1 _3 ->
    (
# 369 "src/lang/parser.mly"
                          ( _1::_3 )
# 3144 "src/lang/parser.ml"
     : (Parsed_term.list_el list))

let _menhir_action_152 =
  fun _1 ->
    (
# 370 "src/lang/parser.mly"
                          ( [_1] )
# 3152 "src/lang/parser.ml"
     : (Parsed_term.list_el list))

let _menhir_action_153 =
  fun () ->
    (
# 371 "src/lang/parser.mly"
                          ( [] )
# 3160 "src/lang/parser.ml"
     : (Parsed_term.list_el list))

let _menhir_action_154 =
  fun _2 ->
    (
# 374 "src/lang/parser.mly"
                   ( `Ellipsis _2 )
# 3168 "src/lang/parser.ml"
     : (Parsed_term.list_el))

let _menhir_action_155 =
  fun _1 ->
    (
# 375 "src/lang/parser.mly"
                   ( `Term _1 )
# 3176 "src/lang/parser.ml"
     : (Parsed_term.list_el))

let _menhir_action_156 =
  fun _1 _3 ->
    (
# 378 "src/lang/parser.mly"
                    ( [_1;_3] )
# 3184 "src/lang/parser.ml"
     : (Parsed_term.t list))

let _menhir_action_157 =
  fun _1 _3 ->
    (
# 379 "src/lang/parser.mly"
                           ( _1::_3 )
# 3192 "src/lang/parser.ml"
     : (Parsed_term.t list))

let _menhir_action_158 =
  fun _endpos__1_ _startpos__1_ ->
    let _ = let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 176 "src/lang/parser.mly"
          ( raise (Term_base.Parse_error (_loc, "Syntax error!")) )
# 3203 "src/lang/parser.ml"
     : (Parsed_term.t)) in
    prerr_string "Menhir: misuse: the semantic action associated with the production\ninteractive -> error\nis expected to abort the parser, but does not do so.\n";
    assert false

let _menhir_action_159 =
  fun _1 ->
    (
# 177 "src/lang/parser.mly"
                 ( _1 )
# 3213 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_160 =
  fun () ->
    (
# 178 "src/lang/parser.mly"
        ( raise End_of_file )
# 3221 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_161 =
  fun _1 ->
    (
# 278 "src/lang/parser.mly"
                          ( `String _1 )
# 3229 "src/lang/parser.ml"
     : (Parsed_term.invoke_meth))

let _menhir_action_162 =
  fun _1 _2 ->
    (
# 279 "src/lang/parser.mly"
                          ( `App (_1, _2) )
# 3237 "src/lang/parser.ml"
     : (Parsed_term.invoke_meth))

let _menhir_action_163 =
  fun _1 ->
    (
# 478 "src/lang/parser.mly"
                             ( [_1] )
# 3245 "src/lang/parser.ml"
     : (Parser_helper.let_opt_el list))

let _menhir_action_164 =
  fun _1 _3 ->
    (
# 479 "src/lang/parser.mly"
                             ( _1::_3 )
# 3253 "src/lang/parser.ml"
     : (Parser_helper.let_opt_el list))

let _menhir_action_165 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 474 "src/lang/parser.mly"
                  ( _1, mk ~pos:_loc (`Var _1) )
# 3264 "src/lang/parser.ml"
     : (Parser_helper.let_opt_el))

let _menhir_action_166 =
  fun _1 _3 ->
    (
# 475 "src/lang/parser.mly"
                  ( _1, _3 )
# 3272 "src/lang/parser.ml"
     : (Parser_helper.let_opt_el))

let _menhir_action_167 =
  fun _2 ->
    (
# 422 "src/lang/parser.mly"
                                       ( `PList _2 )
# 3280 "src/lang/parser.ml"
     : (Parsed_term.pattern_entry))

let _menhir_action_168 =
  fun _1 ->
    (
# 446 "src/lang/parser.mly"
                                     ( `PMeth _1             )
# 3288 "src/lang/parser.ml"
     : (Parsed_term.pattern_entry))

let _menhir_action_169 =
  fun _1 ->
    (
# 447 "src/lang/parser.mly"
                                     ( `PMeth (None,     _1) )
# 3296 "src/lang/parser.ml"
     : (Parsed_term.pattern_entry))

let _menhir_action_170 =
  fun _1 _3 _endpos__1_ _startpos__1_ ->
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    (
# 448 "src/lang/parser.mly"
                                     ( let pat = { pat_pos = _loc__1_; pat_entry = `PVar [_1] } in
                                       `PMeth (Some pat, _3) )
# 3306 "src/lang/parser.ml"
     : (Parsed_term.pattern_entry))

let _menhir_action_171 =
  fun _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 450 "src/lang/parser.mly"
                                     ( let pat = { pat_pos = _loc; pat_entry = `PVar ["_"] } in
                                       `PMeth (Some pat, _3) )
# 3318 "src/lang/parser.ml"
     : (Parsed_term.pattern_entry))

let _menhir_action_172 =
  fun _1 _3 _endpos__1_ _startpos__1_ ->
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    (
# 452 "src/lang/parser.mly"
                                     ( let pat = { pat_pos = _loc__1_; pat_entry = _1 } in
                                       `PMeth (Some pat,  _3) )
# 3328 "src/lang/parser.ml"
     : (Parsed_term.pattern_entry))

let _menhir_action_173 =
  fun _1 _3 _endpos__1_ _startpos__1_ ->
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    (
# 454 "src/lang/parser.mly"
                                     ( let pat = { pat_pos = _loc__1_; pat_entry = _1 } in
                                       `PMeth (Some pat,  _3) )
# 3338 "src/lang/parser.ml"
     : (Parsed_term.pattern_entry))

let _menhir_action_174 =
  fun _1 ->
    (
# 425 "src/lang/parser.mly"
                     ( _1, `None )
# 3346 "src/lang/parser.ml"
     : (string * Parsed_term.meth_term_default))

let _menhir_action_175 =
  fun _1 ->
    (
# 426 "src/lang/parser.mly"
                     ( _1, `Nullable )
# 3354 "src/lang/parser.ml"
     : (string * Parsed_term.meth_term_default))

let _menhir_action_176 =
  fun _1 _3 ->
    (
# 427 "src/lang/parser.mly"
                     ( _1, `Pattern _3 )
# 3362 "src/lang/parser.ml"
     : (string * Parsed_term.meth_term_default))

let _menhir_action_177 =
  fun () ->
    (
# 430 "src/lang/parser.mly"
                                            ( [] )
# 3370 "src/lang/parser.ml"
     : ((string * Parsed_term.meth_term_default) list))

let _menhir_action_178 =
  fun _1 ->
    (
# 431 "src/lang/parser.mly"
                                            ( [_1] )
# 3378 "src/lang/parser.ml"
     : ((string * Parsed_term.meth_term_default) list))

let _menhir_action_179 =
  fun _1 _3 ->
    (
# 432 "src/lang/parser.mly"
                                            ( _1::_3 )
# 3386 "src/lang/parser.ml"
     : ((string * Parsed_term.meth_term_default) list))

let _menhir_action_180 =
  fun _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 438 "src/lang/parser.mly"
                                           ( Some ({ pat_pos = _loc; pat_entry = `PVar ["_"] }), [] )
# 3397 "src/lang/parser.ml"
     : (Parsed_term.pattern option * (string * Parsed_term.meth_term_default) list))

let _menhir_action_181 =
  fun _2 _endpos__2_ _startpos__2_ ->
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    (
# 439 "src/lang/parser.mly"
                                           ( Some ({ pat_pos = _loc__2_; pat_entry = `PVar [_2] }), [] )
# 3406 "src/lang/parser.ml"
     : (Parsed_term.pattern option * (string * Parsed_term.meth_term_default) list))

let _menhir_action_182 =
  fun _1 _3 ->
    (
# 440 "src/lang/parser.mly"
                                           ( fst _3, _1::(snd _3) )
# 3414 "src/lang/parser.ml"
     : (Parsed_term.pattern option * (string * Parsed_term.meth_term_default) list))

let _menhir_action_183 =
  fun _1 _3 ->
    (
# 304 "src/lang/parser.mly"
                            ( { optional = false; name = _1; typ = _3; json_name = None } )
# 3422 "src/lang/parser.ml"
     : (Parsed_term.meth_annotation))

let _menhir_action_184 =
  fun _1 _4 ->
    (
# 305 "src/lang/parser.mly"
                            ( { optional = true; name = _1; typ = _4; json_name = None } )
# 3430 "src/lang/parser.ml"
     : (Parsed_term.meth_annotation))

let _menhir_action_185 =
  fun _1 _2 _3 _5 _endpos__5_ _startpos__1_ ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 306 "src/lang/parser.mly"
                            (
       match _2 with
         |"as" ->             { optional = false; name = _3; typ = _5; json_name = Some (render_string ~pos:_loc _1) }
         | _ -> raise (Term_base.Parse_error (_loc, "Invalid type constructor")) )
# 3444 "src/lang/parser.ml"
     : (Parsed_term.meth_annotation))

let _menhir_action_186 =
  fun _1 _2 _3 _6 _endpos__6_ _startpos__1_ ->
    let _endpos = _endpos__6_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 310 "src/lang/parser.mly"
                                     (
       match _2 with
         |"as" ->             { optional = true; name = _3; typ = _6; json_name = Some (render_string ~pos:_loc _1) }
         | _ -> raise (Term_base.Parse_error (_loc, "Invalid type constructor")) )
# 3458 "src/lang/parser.ml"
     : (Parsed_term.meth_annotation))

let _menhir_action_187 =
  fun _2 ->
    (
# 541 "src/lang/parser.mly"
              ( Some _2 )
# 3466 "src/lang/parser.ml"
     : (Parsed_term.t option))

let _menhir_action_188 =
  fun () ->
    (
# 542 "src/lang/parser.mly"
              ( None )
# 3474 "src/lang/parser.ml"
     : (Parsed_term.t option))

let _menhir_action_189 =
  fun () ->
    (
# 580 "src/lang/parser.mly"
          ()
# 3482 "src/lang/parser.ml"
     : (unit))

let _menhir_action_190 =
  fun _1 ->
    (
# 399 "src/lang/parser.mly"
               ( _1 )
# 3490 "src/lang/parser.ml"
     : (string))

let _menhir_action_191 =
  fun () ->
    (
# 400 "src/lang/parser.mly"
               ( "_" )
# 3498 "src/lang/parser.ml"
     : (string))

let _menhir_action_192 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 461 "src/lang/parser.mly"
                  ( { pat_pos = _loc; pat_entry = _1 } )
# 3509 "src/lang/parser.ml"
     : (Parsed_term.pattern))

let _menhir_action_193 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 462 "src/lang/parser.mly"
                  ( { pat_pos = _loc; pat_entry = _1 } )
# 3520 "src/lang/parser.ml"
     : (Parsed_term.pattern))

let _menhir_action_194 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 463 "src/lang/parser.mly"
                  ( { pat_pos = _loc; pat_entry = _1 } )
# 3531 "src/lang/parser.ml"
     : (Parsed_term.pattern))

let _menhir_action_195 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 464 "src/lang/parser.mly"
                  ( { pat_pos = _loc; pat_entry = _1 } )
# 3542 "src/lang/parser.ml"
     : (Parsed_term.pattern))

let _menhir_action_196 =
  fun () ->
    (
# 403 "src/lang/parser.mly"
                               ( [] )
# 3550 "src/lang/parser.ml"
     : (Parsed_term.pattern list))

let _menhir_action_197 =
  fun _1 ->
    (
# 404 "src/lang/parser.mly"
                               ( [_1] )
# 3558 "src/lang/parser.ml"
     : (Parsed_term.pattern list))

let _menhir_action_198 =
  fun _1 _3 ->
    (
# 405 "src/lang/parser.mly"
                               ( _1@[_3] )
# 3566 "src/lang/parser.ml"
     : (Parsed_term.pattern list))

let _menhir_action_199 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 412 "src/lang/parser.mly"
                                                 ( [], Some (_loc, _1),    [] )
# 3577 "src/lang/parser.ml"
     : (Parsed_term.pattern list * (Term_base.parsed_pos * string) option *
  Parsed_term.pattern list))

let _menhir_action_200 =
  fun _1 ->
    (
# 413 "src/lang/parser.mly"
                                                 ( _1, None,               [] )
# 3586 "src/lang/parser.ml"
     : (Parsed_term.pattern list * (Term_base.parsed_pos * string) option *
  Parsed_term.pattern list))

let _menhir_action_201 =
  fun _1 _3 _endpos__1_ _startpos__1_ ->
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    (
# 414 "src/lang/parser.mly"
                                                 ( [], Some (_loc__1_, _1), _3 )
# 3596 "src/lang/parser.ml"
     : (Parsed_term.pattern list * (Term_base.parsed_pos * string) option *
  Parsed_term.pattern list))

let _menhir_action_202 =
  fun _1 _3 _endpos__3_ _startpos__3_ ->
    let _loc__3_ = (_startpos__3_, _endpos__3_) in
    (
# 415 "src/lang/parser.mly"
                                                 ( _1, Some (_loc__3_, _3), [] )
# 3606 "src/lang/parser.ml"
     : (Parsed_term.pattern list * (Term_base.parsed_pos * string) option *
  Parsed_term.pattern list))

let _menhir_action_203 =
  fun _1 _3 _5 _endpos__3_ _startpos__3_ ->
    let _loc__3_ = (_startpos__3_, _endpos__3_) in
    (
# 416 "src/lang/parser.mly"
                                                 ( _1, Some (_loc__3_, _3), _5 )
# 3616 "src/lang/parser.ml"
     : (Parsed_term.pattern list * (Term_base.parsed_pos * string) option *
  Parsed_term.pattern list))

let _menhir_action_204 =
  fun _2 ->
    (
# 577 "src/lang/parser.mly"
                             ( _2 )
# 3625 "src/lang/parser.ml"
     : (Parser_helper.Term.encoder_params))

let _menhir_action_205 =
  fun _endpos__1_ _startpos__1_ ->
    let _ = let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 171 "src/lang/parser.mly"
          ( raise (Term_base.Parse_error (_loc, "Syntax error!")) )
# 3636 "src/lang/parser.ml"
     : (Parsed_term.t)) in
    prerr_string "Menhir: misuse: the semantic action associated with the production\nprogram -> error\nis expected to abort the parser, but does not do so.\n";
    assert false

let _menhir_action_206 =
  fun _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 172 "src/lang/parser.mly"
        ( mk ~pos:_loc `Eof )
# 3649 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_207 =
  fun _1 ->
    (
# 173 "src/lang/parser.mly"
              ( _1 )
# 3657 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_208 =
  fun _1 _3 ->
    (
# 583 "src/lang/parser.mly"
                   ( [`Method (_1, _3)] )
# 3665 "src/lang/parser.ml"
     : (Parsed_term.methods list))

let _menhir_action_209 =
  fun _2 ->
    (
# 584 "src/lang/parser.mly"
                   ( [`Ellipsis _2] )
# 3673 "src/lang/parser.ml"
     : (Parsed_term.methods list))

let _menhir_action_210 =
  fun _1 _3 _5 ->
    (
# 585 "src/lang/parser.mly"
                                ( _1@[`Method (_3,_5)] )
# 3681 "src/lang/parser.ml"
     : (Parsed_term.methods list))

let _menhir_action_211 =
  fun _1 _4 ->
    (
# 586 "src/lang/parser.mly"
                                ( _1@[`Ellipsis _4] )
# 3689 "src/lang/parser.ml"
     : (Parsed_term.methods list))

let _menhir_action_212 =
  fun _2 ->
    (
# 435 "src/lang/parser.mly"
                                ( _2 )
# 3697 "src/lang/parser.ml"
     : ((string * Parsed_term.meth_term_default) list))

let _menhir_action_213 =
  fun _2 ->
    (
# 443 "src/lang/parser.mly"
                               ( _2 )
# 3705 "src/lang/parser.ml"
     : (Parsed_term.pattern option * (string * Parsed_term.meth_term_default) list))

let _menhir_action_214 =
  fun () ->
    (
# 299 "src/lang/parser.mly"
                            ( [] )
# 3713 "src/lang/parser.ml"
     : (Parsed_term.meth_annotation list))

let _menhir_action_215 =
  fun _1 ->
    (
# 300 "src/lang/parser.mly"
                            ( [_1] )
# 3721 "src/lang/parser.ml"
     : (Parsed_term.meth_annotation list))

let _menhir_action_216 =
  fun _1 _3 ->
    (
# 301 "src/lang/parser.mly"
                            ( _1::_3 )
# 3729 "src/lang/parser.ml"
     : (Parsed_term.meth_annotation list))

let _menhir_action_217 =
  fun () ->
    (
# 180 "src/lang/parser.mly"
     ()
# 3737 "src/lang/parser.ml"
     : (unit))

let _menhir_action_218 =
  fun () ->
    (
# 180 "src/lang/parser.mly"
               ()
# 3745 "src/lang/parser.ml"
     : (unit))

let _menhir_action_219 =
  fun _2 _4 _endpos__4_ _startpos__1_ ->
    let _endpos = _endpos__4_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 193 "src/lang/parser.mly"
                             ( mk ~pos:_loc (`Open (_2,_4)) )
# 3756 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_220 =
  fun _1 ->
    (
# 194 "src/lang/parser.mly"
                             ( _1 )
# 3764 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_221 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 195 "src/lang/parser.mly"
                             ( mk ~pos:_loc (`Seq (_1,_3)) )
# 3775 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_222 =
  fun _1 _endpos__1_ _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 196 "src/lang/parser.mly"
                             ( mk_let ~pos:_loc__1_ _1 (mk ~pos:_loc unit) )
# 3787 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_223 =
  fun _1 _3 _endpos__1_ _startpos__1_ ->
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    (
# 197 "src/lang/parser.mly"
                             ( mk_let ~pos:_loc__1_ _1 _3 )
# 3796 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_224 =
  fun () ->
    (
# 408 "src/lang/parser.mly"
                     ( "_" )
# 3804 "src/lang/parser.ml"
     : (string))

let _menhir_action_225 =
  fun _2 ->
    (
# 409 "src/lang/parser.mly"
                     ( _2 )
# 3812 "src/lang/parser.ml"
     : (string))

let _menhir_action_226 =
  fun _1 _2 ->
    (
# 589 "src/lang/parser.mly"
                                                                     ( _1, _2 )
# 3820 "src/lang/parser.ml"
     : (char * Parsed_term.string_interpolation list))

let _menhir_action_227 =
  fun _1 ->
    (
# 592 "src/lang/parser.mly"
                         ( `String _1 )
# 3828 "src/lang/parser.ml"
     : (Parsed_term.string_interpolation))

let _menhir_action_228 =
  fun _1 ->
    (
# 593 "src/lang/parser.mly"
                         ( `Term _1 )
# 3836 "src/lang/parser.ml"
     : (Parsed_term.string_interpolation))

let _menhir_action_229 =
  fun _1 ->
    (
# 596 "src/lang/parser.mly"
                              ( [_1] )
# 3844 "src/lang/parser.ml"
     : (Parsed_term.string_interpolation list))

let _menhir_action_230 =
  fun _1 _2 ->
    (
# 598 "src/lang/parser.mly"
                              ( _1::_2 )
# 3852 "src/lang/parser.ml"
     : (Parsed_term.string_interpolation list))

let _menhir_action_231 =
  fun _1 _3 ->
    (
# 467 "src/lang/parser.mly"
                        ( _1::_3 )
# 3860 "src/lang/parser.ml"
     : (string list))

let _menhir_action_232 =
  fun _1 _3 ->
    (
# 550 "src/lang/parser.mly"
                             ( _1::_3 )
# 3868 "src/lang/parser.ml"
     : (string list))

let _menhir_action_233 =
  fun _1 ->
    (
# 508 "src/lang/parser.mly"
                          ( [_1] )
# 3876 "src/lang/parser.ml"
     : (string list))

let _menhir_action_234 =
  fun _1 _3 ->
    (
# 509 "src/lang/parser.mly"
                          ( _1::_3 )
# 3884 "src/lang/parser.ml"
     : (string list))

let _menhir_action_235 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 282 "src/lang/parser.mly"
             ( mk ~pos:_loc (`Time_interval _1) )
# 3895 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_236 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 283 "src/lang/parser.mly"
             ( mk ~pos:_loc (`Time _1) )
# 3906 "src/lang/parser.ml"
     : (Parsed_term.t))

let _menhir_action_237 =
  fun _2 ->
    (
# 419 "src/lang/parser.mly"
                                       ( `PTuple _2 )
# 3914 "src/lang/parser.ml"
     : (Parsed_term.pattern_entry))

let _menhir_action_238 =
  fun () ->
    (
# 286 "src/lang/parser.mly"
                                 ( `Named "_" )
# 3922 "src/lang/parser.ml"
     : (Parsed_term.type_annotation))

let _menhir_action_239 =
  fun _1 ->
    (
# 287 "src/lang/parser.mly"
                                 ( `Named _1 )
# 3930 "src/lang/parser.ml"
     : (Parsed_term.type_annotation))

let _menhir_action_240 =
  fun _1 ->
    (
# 288 "src/lang/parser.mly"
                                 ( `Nullable _1 )
# 3938 "src/lang/parser.ml"
     : (Parsed_term.type_annotation))

let _menhir_action_241 =
  fun _2 ->
    (
# 289 "src/lang/parser.mly"
                                 ( `List _2 )
# 3946 "src/lang/parser.ml"
     : (Parsed_term.type_annotation))

let _menhir_action_242 =
  fun _2 _4 _5 _7 _endpos__7_ _startpos__1_ ->
    let _endpos = _endpos__7_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 290 "src/lang/parser.mly"
                                 ( mk_json_assoc_object_ty ~pos:_loc (_2,_4,_5,_7) )
# 3957 "src/lang/parser.ml"
     : (Parsed_term.type_annotation))

let _menhir_action_243 =
  fun _2 ->
    (
# 291 "src/lang/parser.mly"
                                 ( `Tuple _2 )
# 3965 "src/lang/parser.ml"
     : (Parsed_term.type_annotation))

let _menhir_action_244 =
  fun _2 _5 ->
    (
# 292 "src/lang/parser.mly"
                                 ( `Arrow (_2,_5) )
# 3973 "src/lang/parser.ml"
     : (Parsed_term.type_annotation))

let _menhir_action_245 =
  fun _2 ->
    (
# 293 "src/lang/parser.mly"
                                 ( `Record _2 )
# 3981 "src/lang/parser.ml"
     : (Parsed_term.type_annotation))

let _menhir_action_246 =
  fun _1 _3 ->
    (
# 294 "src/lang/parser.mly"
                                 ( `Invoke (_1, _3) )
# 3989 "src/lang/parser.ml"
     : (Parsed_term.type_annotation))

let _menhir_action_247 =
  fun _1 _4 ->
    (
# 295 "src/lang/parser.mly"
                                 ( `Method (_1, _4) )
# 3997 "src/lang/parser.ml"
     : (Parsed_term.type_annotation))

let _menhir_action_248 =
  fun _1 ->
    (
# 296 "src/lang/parser.mly"
                                 ( `Source _1 )
# 4005 "src/lang/parser.ml"
     : (Parsed_term.type_annotation))

let _menhir_action_249 =
  fun _1 ->
    (
# 325 "src/lang/parser.mly"
                                  ( _1, [] )
# 4013 "src/lang/parser.ml"
     : (string * Parsed_term.track_annotation list))

let _menhir_action_250 =
  fun _1 _3 ->
    (
# 326 "src/lang/parser.mly"
                                  ( _1 ^ "." ^ _3, [] )
# 4021 "src/lang/parser.ml"
     : (string * Parsed_term.track_annotation list))

let _menhir_action_251 =
  fun _1 _3 _5 ->
    (
# 327 "src/lang/parser.mly"
                                  ( _1 ^ "." ^ _3 ^ "." ^ _5, [] )
# 4029 "src/lang/parser.ml"
     : (string * Parsed_term.track_annotation list))

let _menhir_action_252 =
  fun _1 _2 ->
    (
# 328 "src/lang/parser.mly"
                                  ( _1, _2 )
# 4037 "src/lang/parser.ml"
     : (string * Parsed_term.track_annotation list))

let _menhir_action_253 =
  fun _1 _3 _4 ->
    (
# 330 "src/lang/parser.mly"
                                  ( _1 ^ "." ^ _3, _4 )
# 4045 "src/lang/parser.ml"
     : (string * Parsed_term.track_annotation list))

let _menhir_action_254 =
  fun _1 _3 _5 _6 ->
    (
# 332 "src/lang/parser.mly"
                                  ( _1 ^ "." ^ _3 ^ "." ^ _5, _6 )
# 4053 "src/lang/parser.ml"
     : (string * Parsed_term.track_annotation list))

let _menhir_action_255 =
  fun _1 ->
    (
# 341 "src/lang/parser.mly"
                         ( ("", `Verbatim _1) )
# 4061 "src/lang/parser.ml"
     : (Parsed_term.track_annotation))

let _menhir_action_256 =
  fun _1 ->
    (
# 342 "src/lang/parser.mly"
                         ( ("", `Verbatim _1) )
# 4069 "src/lang/parser.ml"
     : (Parsed_term.track_annotation))

let _menhir_action_257 =
  fun _1 ->
    (
# 343 "src/lang/parser.mly"
                         ( ("", `Verbatim _1) )
# 4077 "src/lang/parser.ml"
     : (Parsed_term.track_annotation))

let _menhir_action_258 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    (
# 344 "src/lang/parser.mly"
                         ( ("", `String (_loc__1_, _1)) )
# 4086 "src/lang/parser.ml"
     : (Parsed_term.track_annotation))

let _menhir_action_259 =
  fun _1 _3 ->
    (
# 345 "src/lang/parser.mly"
                         ( (_1, `Verbatim _3) )
# 4094 "src/lang/parser.ml"
     : (Parsed_term.track_annotation))

let _menhir_action_260 =
  fun _1 _3 _endpos__3_ _startpos__3_ ->
    let _loc__3_ = (_startpos__3_, _endpos__3_) in
    (
# 346 "src/lang/parser.mly"
                         ( (_1, `String (_loc__3_, _3)) )
# 4103 "src/lang/parser.ml"
     : (Parsed_term.track_annotation))

let _menhir_action_261 =
  fun _1 _3 ->
    (
# 347 "src/lang/parser.mly"
                         ( (_1, `Verbatim _3) )
# 4111 "src/lang/parser.ml"
     : (Parsed_term.track_annotation))

let _menhir_action_262 =
  fun _1 _3 ->
    (
# 348 "src/lang/parser.mly"
                         ( (_1, `Verbatim _3) )
# 4119 "src/lang/parser.ml"
     : (Parsed_term.track_annotation))

let _menhir_action_263 =
  fun () ->
    (
# 336 "src/lang/parser.mly"
                                         ( [] )
# 4127 "src/lang/parser.ml"
     : (Parsed_term.track_annotation list))

let _menhir_action_264 =
  fun _1 ->
    (
# 337 "src/lang/parser.mly"
                                         ( [_1] )
# 4135 "src/lang/parser.ml"
     : (Parsed_term.track_annotation list))

let _menhir_action_265 =
  fun _1 _3 ->
    (
# 338 "src/lang/parser.mly"
                                         ( _1::_3 )
# 4143 "src/lang/parser.ml"
     : (Parsed_term.track_annotation list))

let _menhir_action_266 =
  fun _1 ->
    (
# 316 "src/lang/parser.mly"
                                  ( _1, { extensible = false; tracks = [] } )
# 4151 "src/lang/parser.ml"
     : (string * Parsed_term.source_annotation))

let _menhir_action_267 =
  fun _1 _2 ->
    (
# 317 "src/lang/parser.mly"
                                  ( _1, _2 )
# 4159 "src/lang/parser.ml"
     : (string * Parsed_term.source_annotation))

let _menhir_action_268 =
  fun _1 _3 ->
    (
# 320 "src/lang/parser.mly"
                        ( { extensible = false; tracks = [{track_name = _1; track_type = fst _3; track_params = snd _3}] } )
# 4167 "src/lang/parser.ml"
     : (Parsed_term.source_annotation))

let _menhir_action_269 =
  fun () ->
    (
# 321 "src/lang/parser.mly"
              ( { extensible = true; tracks = [] } )
# 4175 "src/lang/parser.ml"
     : (Parsed_term.source_annotation))

let _menhir_action_270 =
  fun _1 _3 _5 ->
    (
# 322 "src/lang/parser.mly"
                                               ( { _5 with tracks = { track_name = _1; track_type = fst _3; track_params = snd _3}::_5.tracks } )
# 4183 "src/lang/parser.ml"
     : (Parsed_term.source_annotation))

let _menhir_action_271 =
  fun _1 _3 ->
    (
# 351 "src/lang/parser.mly"
                ( [_1; _3] )
# 4191 "src/lang/parser.ml"
     : (Parsed_term.type_annotation list))

let _menhir_action_272 =
  fun _1 _3 ->
    (
# 352 "src/lang/parser.mly"
                      ( _1::_3 )
# 4199 "src/lang/parser.ml"
     : (Parsed_term.type_annotation list))

let _menhir_action_273 =
  fun _1 ->
    (
# 458 "src/lang/parser.mly"
           ( `PVar [_1] )
# 4207 "src/lang/parser.ml"
     : (Parsed_term.pattern_entry))

let _menhir_action_274 =
  fun _2 ->
    (
# 365 "src/lang/parser.mly"
                         ( _2 )
# 4215 "src/lang/parser.ml"
     : (Parsed_term.list_el list))

let _menhir_print_token : token -> string =
  fun _tok ->
    match _tok with
    | AND ->
        "AND"
    | ARGS_OF ->
        "ARGS_OF"
    | AT ->
        "AT"
    | BEGIN ->
        "BEGIN"
    | BEGIN_INTERPOLATION _ ->
        "BEGIN_INTERPOLATION"
    | BIN1 _ ->
        "BIN1"
    | BIN2 _ ->
        "BIN2"
    | BIN3 _ ->
        "BIN3"
    | BOOL _ ->
        "BOOL"
    | CATCH ->
        "CATCH"
    | COALESCE ->
        "COALESCE"
    | COLON ->
        "COLON"
    | COLONCOLON ->
        "COLONCOLON"
    | COMMA ->
        "COMMA"
    | DEF _ ->
        "DEF"
    | DO ->
        "DO"
    | DOT ->
        "DOT"
    | DOTDOTDOT ->
        "DOTDOTDOT"
    | DOTVAR _ ->
        "DOTVAR"
    | ELSE ->
        "ELSE"
    | ELSIF ->
        "ELSIF"
    | ENCODER _ ->
        "ENCODER"
    | END ->
        "END"
    | END_INTERPOLATION ->
        "END_INTERPOLATION"
    | EOF ->
        "EOF"
    | FINALLY ->
        "FINALLY"
    | FLOAT _ ->
        "FLOAT"
    | FOR ->
        "FOR"
    | FUN ->
        "FUN"
    | GET ->
        "GET"
    | GETS ->
        "GETS"
    | IF ->
        "IF"
    | INCLUDE _ ->
        "INCLUDE"
    | INT _ ->
        "INT"
    | INTERPOLATED_STRING _ ->
        "INTERPOLATED_STRING"
    | INTERVAL _ ->
        "INTERVAL"
    | LBRA ->
        "LBRA"
    | LCUR ->
        "LCUR"
    | LET _ ->
        "LET"
    | LETLBRA _ ->
        "LETLBRA"
    | LPAR ->
        "LPAR"
    | MINUS ->
        "MINUS"
    | NOT ->
        "NOT"
    | OPEN ->
        "OPEN"
    | OR ->
        "OR"
    | PP_ELSE ->
        "PP_ELSE"
    | PP_ENDIF ->
        "PP_ENDIF"
    | PP_ENDL ->
        "PP_ENDL"
    | PP_IFDEF _ ->
        "PP_IFDEF"
    | PP_IFENCODER _ ->
        "PP_IFENCODER"
    | PP_IFVERSION ->
        "PP_IFVERSION"
    | PP_INT_DOT_LCUR _ ->
        "PP_INT_DOT_LCUR"
    | PP_REGEXP _ ->
        "PP_REGEXP"
    | PP_STRING _ ->
        "PP_STRING"
    | QUESTION ->
        "QUESTION"
    | QUESTION_DOT ->
        "QUESTION_DOT"
    | RBRA ->
        "RBRA"
    | RCUR ->
        "RCUR"
    | REGEXP _ ->
        "REGEXP"
    | REPLACES ->
        "REPLACES"
    | RPAR ->
        "RPAR"
    | SEQ ->
        "SEQ"
    | SEQSEQ ->
        "SEQSEQ"
    | SET ->
        "SET"
    | SLASH ->
        "SLASH"
    | STRING _ ->
        "STRING"
    | THEN ->
        "THEN"
    | TILD ->
        "TILD"
    | TIME _ ->
        "TIME"
    | TIMES ->
        "TIMES"
    | TO ->
        "TO"
    | TRY ->
        "TRY"
    | UMINUS ->
        "UMINUS"
    | UNDERSCORE ->
        "UNDERSCORE"
    | VAR _ ->
        "VAR"
    | VARLBRA _ ->
        "VARLBRA"
    | VARLPAR _ ->
        "VARLPAR"
    | VERSION _ ->
        "VERSION"
    | WHILE ->
        "WHILE"
    | YIELDS ->
        "YIELDS"

let _menhir_fail : unit -> 'a =
  fun () ->
    Printf.eprintf "Internal failure -- please contact the parser generator's developers.\n%!";
    assert false

include struct
  
  [@@@ocaml.warning "-4-37"]
  
  let _menhir_run_018 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_annotate_metadata_entry =
    fun _menhir_stack _v ->
      MenhirBox_annotate_metadata_entry _v
  
  let _menhir_run_014 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_annotate =
    fun _menhir_stack _v ->
      let _1 = _v in
      let _v = _menhir_action_008 _1 in
      MenhirBox_annotate _v
  
  let rec _menhir_goto_annotate_metadata : type  ttv_stack. ttv_stack -> _ -> (ttv_stack, _menhir_box_annotate) _menhir_state -> _menhir_box_annotate =
    fun _menhir_stack _v _menhir_s ->
      match _menhir_s with
      | MenhirState000 ->
          _menhir_run_014 _menhir_stack _v
      | MenhirState003 ->
          _menhir_run_004 _menhir_stack _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_004 : type  ttv_stack. (ttv_stack, _menhir_box_annotate) _menhir_cell1_annotate_metadata_entry -> _ -> _menhir_box_annotate =
    fun _menhir_stack _v ->
      let MenhirCell1_annotate_metadata_entry (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_011 _1 _2 in
      _menhir_goto_annotate_metadata _menhir_stack _v _menhir_s
  
  let rec _menhir_run_001 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_009 _1 in
      _menhir_goto_annotate_key _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_annotate_key : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState017 ->
          _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState000 ->
          _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState003 ->
          _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_019 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_annotate_metadata_entry) _menhir_state -> _ -> _menhir_box_annotate_metadata_entry =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_annotate_key (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_s = MenhirState020 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_007 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_annotate_key as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_017 _1 in
      _menhir_goto_annotate_value _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_annotate_value : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_annotate_key as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState020 ->
          _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState006 ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_021 : type  ttv_stack. (ttv_stack, _menhir_box_annotate_metadata_entry) _menhir_cell1_annotate_key -> _ -> _ -> _ -> _ -> _menhir_box_annotate_metadata_entry =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let MenhirCell1_annotate_key (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_013 _1 _3 in
          _menhir_goto_annotate_metadata_entry _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_annotate_metadata_entry : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState017 ->
          _menhir_run_018 _menhir_stack _v
      | MenhirState003 ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState000 ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_003 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_annotate) _menhir_state -> _ -> _menhir_box_annotate =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_annotate_metadata_entry (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | VAR _v_0 ->
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState003
      | STRING _v_1 ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState003
      | _ ->
          _eRR ()
  
  and _menhir_run_002 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_010 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_annotate_key _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_012 : type  ttv_stack. (ttv_stack, _menhir_box_annotate) _menhir_cell1_annotate_key -> _ -> _ -> _ -> _ -> _menhir_box_annotate =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_annotate_key (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_013 _1 _3 in
          _menhir_goto_annotate_metadata_entry _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | COLON ->
          let MenhirCell1_annotate_key (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_012 _1 _3 in
          _menhir_goto_annotate_metadata _menhir_stack _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_008 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_annotate_key as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_018 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_annotate_value _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_009 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_annotate_key as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_014 _1 in
      _menhir_goto_annotate_value _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_010 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_annotate_key as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_015 _1 in
      _menhir_goto_annotate_value _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_011 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_annotate_key as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_016 _1 in
      _menhir_goto_annotate_value _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_005 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_annotate) _menhir_state -> _ -> _menhir_box_annotate =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_annotate_key (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_s = MenhirState006 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  let _menhir_run_000 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_annotate =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState000 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  let _menhir_run_017 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_annotate_metadata_entry =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState017 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  let _menhir_run_575 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_time_predicate =
    fun _menhir_stack _v ->
      MenhirBox_time_predicate _v
  
  let _menhir_run_563 : type  ttv_stack. ttv_stack _menhir_cell0_LPAR -> _ -> _menhir_box_plain_encoder_params =
    fun _menhir_stack _v ->
      let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_204 _2 in
      MenhirBox_plain_encoder_params _v
  
  let _menhir_goto_program : type  ttv_stack. ttv_stack -> _ -> _menhir_box_program =
    fun _menhir_stack _v ->
      MenhirBox_program _v
  
  let _menhir_run_570 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_program =
    fun _menhir_stack _v _tok ->
      match (_tok : MenhirBasics.token) with
      | EOF ->
          let _1 = _v in
          let _v = _menhir_action_207 _1 in
          _menhir_goto_program _menhir_stack _v
      | _ ->
          _eRR ()
  
  let _menhir_goto_interactive : type  ttv_stack. ttv_stack -> _ -> _menhir_box_interactive =
    fun _menhir_stack _v ->
      MenhirBox_interactive _v
  
  let _menhir_run_559 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_interactive =
    fun _menhir_stack _v _tok ->
      match (_tok : MenhirBasics.token) with
      | SEQSEQ ->
          let _1 = _v in
          let _v = _menhir_action_159 _1 in
          _menhir_goto_interactive _menhir_stack _v
      | _ ->
          _eRR ()
  
  let rec _menhir_run_025 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_WHILE (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState025 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_026 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_VARLPAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState026
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState026
      | VAR _v_2 ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState026
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | TIME _v_3 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState026
      | STRING _v_4 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState026
      | REGEXP _v_5 ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState026
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | PP_IFENCODER _v_6 ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState026
      | PP_IFDEF _v_7 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState026
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | INTERVAL _v_8 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState026
      | INT _v_9 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState026
      | INCLUDE _v_10 ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState026
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | FLOAT _v_11 ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState026
      | ENCODER _v_12 ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState026
      | BOOL _v_13 ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState026
      | BEGIN_INTERPOLATION _v_14 ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState026
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | ARGS_OF ->
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | RPAR ->
          let _v_15 = _menhir_action_019 () in
          _menhir_run_551 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15
      | _ ->
          _eRR ()
  
  and _menhir_run_027 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_VARLBRA (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _menhir_s = MenhirState027 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_028 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_083 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_expr : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState025 ->
          _menhir_run_553 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState027 ->
          _menhir_run_549 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState029 ->
          _menhir_run_548 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState050 ->
          _menhir_run_510 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState051 ->
          _menhir_run_509 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState503 ->
          _menhir_run_505 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState052 ->
          _menhir_run_501 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState054 ->
          _menhir_run_493 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState483 ->
          _menhir_run_484 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState056 ->
          _menhir_run_481 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState057 ->
          _menhir_run_478 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState476 ->
          _menhir_run_478 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState473 ->
          _menhir_run_474 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState064 ->
          _menhir_run_455 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState065 ->
          _menhir_run_454 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState452 ->
          _menhir_run_453 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState071 ->
          _menhir_run_441 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState073 ->
          _menhir_run_441 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState433 ->
          _menhir_run_434 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState076 ->
          _menhir_run_432 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState422 ->
          _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState081 ->
          _menhir_run_420 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState083 ->
          _menhir_run_419 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState417 ->
          _menhir_run_419 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState374 ->
          _menhir_run_375 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState371 ->
          _menhir_run_372 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState368 ->
          _menhir_run_369 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState566 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState023 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState554 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState030 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState542 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState544 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState534 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState536 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState529 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState042 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState525 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState044 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState520 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState049 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState515 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState511 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState497 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState494 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState485 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState061 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState462 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState464 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState466 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState468 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState438 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState435 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState412 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState408 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState401 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState302 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState298 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState188 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState085 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState026 ->
          _menhir_run_177 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState179 ->
          _menhir_run_177 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState100 ->
          _menhir_run_177 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState146 ->
          _menhir_run_147 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState141 ->
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState139 ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState133 ->
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState128 ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState126 ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState124 ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState122 ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState120 ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState118 ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState116 ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState113 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState110 ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState108 ->
          _menhir_run_109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState106 ->
          _menhir_run_107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState104 ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState102 ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState097 ->
          _menhir_run_098 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState092 ->
          _menhir_run_096 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_553 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_WHILE as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState553
      | SET ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState553
      | QUESTION_DOT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState553
      | QUESTION ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState553
      | OR ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState553
      | MINUS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState553
      | DOT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState553
      | DO ->
          let _menhir_stack = MenhirCell1_DO (_menhir_stack, MenhirState553) in
          let _menhir_s = MenhirState554 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | OPEN ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LETLBRA _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LET _v ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | DEF _v ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COLONCOLON ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState553
      | COALESCE ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState553
      | BIN3 _v_18 ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_18 MenhirState553
      | BIN2 _v_19 ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_19 MenhirState553
      | BIN1 _v_20 ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_20 MenhirState553
      | AT ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState553
      | AND ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState553
      | _ ->
          _eRR ()
  
  and _menhir_run_097 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_TIMES (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState097 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_029 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_UMINUS (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState029 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_030 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_TRY (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState030 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | OPEN ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LETLBRA _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LET _v ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | DEF _v ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_031 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | AND | AT | BEGIN | BEGIN_INTERPOLATION _ | BIN1 _ | BIN2 _ | BIN3 _ | BOOL _ | CATCH | COALESCE | COLONCOLON | DEF _ | DOT | ELSE | ELSIF | ENCODER _ | END | EOF | FINALLY | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | MINUS | NOT | OPEN | OR | PP_ELSE | PP_ENDIF | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | QUESTION | QUESTION_DOT | RCUR | REGEXP _ | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TIMES | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_083 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | GETS ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_190 _1 in
          _menhir_goto_optvar _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_optvar : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState532 ->
          _menhir_run_533 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState191 ->
          _menhir_run_411 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState067 ->
          _menhir_run_397 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState405 ->
          _menhir_run_397 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState376 ->
          _menhir_run_397 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState377 ->
          _menhir_run_378 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState304 ->
          _menhir_run_345 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState363 ->
          _menhir_run_345 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState312 ->
          _menhir_run_345 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState319 ->
          _menhir_run_345 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState331 ->
          _menhir_run_345 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState354 ->
          _menhir_run_345 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState356 ->
          _menhir_run_345 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState339 ->
          _menhir_run_345 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState343 ->
          _menhir_run_345 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState332 ->
          _menhir_run_333 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState321 ->
          _menhir_run_322 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState198 ->
          _menhir_run_199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState566 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState023 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState554 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState544 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState542 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState536 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState534 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState529 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState030 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState525 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState042 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState520 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState044 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState515 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState049 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState511 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState497 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState494 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState485 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState468 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState466 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState464 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState462 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState061 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState438 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState435 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState412 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState408 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState401 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState302 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState298 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState188 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState085 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState074 ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_533 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_TRY, ttv_result) _menhir_cell1_exprs as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_optvar (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | DO ->
          let _menhir_s = MenhirState534 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | OPEN ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LETLBRA _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LET _v ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | DEF _v ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COLON ->
          let _menhir_s = MenhirState540 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_032 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_191 () in
      _menhir_goto_optvar _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_033 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_236 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_time_predicate _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_time_predicate : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState572 ->
          _menhir_run_575 _menhir_stack _v
      | MenhirState566 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState023 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState554 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState025 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState026 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState027 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState029 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState544 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState542 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState536 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState534 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState529 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState030 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState525 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState042 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState520 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState044 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState515 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState049 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState511 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState050 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState051 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState503 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState052 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState497 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState494 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState054 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState485 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState483 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState056 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState476 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState057 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState473 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState468 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState466 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState464 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState462 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState061 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState064 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState065 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState452 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState071 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState073 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState438 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState435 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState433 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState076 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState422 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState081 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState417 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState083 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState412 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState408 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState401 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState374 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState371 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState368 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState302 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState298 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState188 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState179 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState100 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState146 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState141 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState139 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState133 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState128 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState126 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState124 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState122 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState120 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState118 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState116 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState113 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState110 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState108 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState106 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState104 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState102 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState097 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState092 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState085 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_089 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_124 _1 in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_034 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_081 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_035 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_114 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_036 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_PP_IFVERSION (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | BIN1 _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_0, _v) in
          let _v = _menhir_action_143 _1 _endpos__1_ _startpos__1_ in
          let _menhir_stack = MenhirCell0_if_version_op (_menhir_stack, _v) in
          (match (_tok : MenhirBasics.token) with
          | VERSION _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _1 = _v_0 in
              let _v = _menhir_action_144 _1 in
              _menhir_goto_if_version_version _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | INT _v_2 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _1 = _v_2 in
              let _v = _menhir_action_145 _1 in
              _menhir_goto_if_version_version _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | FLOAT _v_4 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _1 = _v_4 in
              let _v = _menhir_action_146 _1 in
              _menhir_goto_if_version_version _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_goto_if_version_version : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_PP_IFVERSION _menhir_cell0_if_version_op -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _menhir_stack = MenhirCell0_if_version_version (_menhir_stack, _v) in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState042
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState042
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState042
      | VAR _v_2 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState042
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState042
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState042
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState042
      | TIME _v_3 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState042
      | STRING _v_4 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState042
      | REGEXP _v_5 ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState042
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState042
      | PP_IFENCODER _v_6 ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState042
      | PP_IFDEF _v_7 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState042
      | OPEN ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState042
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState042
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState042
      | LETLBRA _v_8 ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState042
      | LET _v_9 ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState042
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState042
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState042
      | INTERVAL _v_10 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState042
      | INT _v_11 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState042
      | INCLUDE _v_12 ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState042
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState042
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState042
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState042
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState042
      | FLOAT _v_13 ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState042
      | ENCODER _v_14 ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState042
      | DEF _v_15 ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15 MenhirState042
      | BOOL _v_16 ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v_16 MenhirState042
      | BEGIN_INTERPOLATION _v_17 ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v_17 MenhirState042
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState042
      | _ ->
          _eRR ()
  
  and _menhir_run_043 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_PP_IFENCODER (_menhir_stack, _menhir_s, _v, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ENCODER _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_ENCODER (_menhir_stack, _v, _startpos) in
          let _menhir_s = MenhirState044 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | OPEN ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LETLBRA _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LET _v ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | DEF _v ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_045 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_PP_IFDEF (_menhir_stack, _menhir_s, _v, _startpos) in
      let _menhir_s = MenhirState045 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_046 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState047 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | BEGIN | BEGIN_INTERPOLATION _ | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _1 = _v in
          let _v = _menhir_action_134 _1 in
          _menhir_goto_if_def_var _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_if_def_var : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState045 ->
          _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState047 ->
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_049 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_PP_IFDEF as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_if_def_var (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState049
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState049
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState049
      | VAR _v_2 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState049
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState049
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState049
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState049
      | TIME _v_3 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState049
      | STRING _v_4 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState049
      | REGEXP _v_5 ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState049
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState049
      | PP_IFENCODER _v_6 ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState049
      | PP_IFDEF _v_7 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState049
      | OPEN ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState049
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState049
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState049
      | LETLBRA _v_8 ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState049
      | LET _v_9 ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState049
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState049
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState049
      | INTERVAL _v_10 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState049
      | INT _v_11 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState049
      | INCLUDE _v_12 ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState049
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState049
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState049
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState049
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState049
      | FLOAT _v_13 ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState049
      | ENCODER _v_14 ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState049
      | DEF _v_15 ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15 MenhirState049
      | BOOL _v_16 ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v_16 MenhirState049
      | BEGIN_INTERPOLATION _v_17 ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v_17 MenhirState049
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState049
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_050 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState050 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_051 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_NOT (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState051 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_052 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState052
      | VARLPAR _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState052
      | VARLBRA _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState052
      | VAR _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState052
      | UMINUS ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState052
      | TRY ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState052
      | TIME _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState052
      | STRING _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState052
      | RPAR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _endpos__2_) = (_startpos, _endpos) in
          let _v = _menhir_action_088 _endpos__2_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | REGEXP _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState052
      | PP_IFVERSION ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState052
      | PP_IFENCODER _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState052
      | PP_IFDEF _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState052
      | NOT ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState052
      | LPAR ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState052
      | LCUR ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState052
      | LBRA ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState052
      | INTERVAL _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState052
      | INT _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState052
      | INCLUDE _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState052
      | IF ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState052
      | GET ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState052
      | FUN ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState052
      | FOR ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState052
      | FLOAT _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState052
      | ENCODER _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState052
      | BOOL _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState052
      | BEGIN_INTERPOLATION _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState052
      | BEGIN ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState052
      | _ ->
          _eRR ()
  
  and _menhir_run_054 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState054
      | VARLPAR _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState054
      | VARLBRA _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState054
      | VAR _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | GETS ->
              let _menhir_stack = MenhirCell1_VAR (_menhir_stack, MenhirState054, _v, _startpos_0, _endpos) in
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer
          | AND | AT | BEGIN | BEGIN_INTERPOLATION _ | BIN1 _ | BIN2 _ | BIN3 _ | BOOL _ | COALESCE | COLONCOLON | DEF _ | DOT | ENCODER _ | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | MINUS | NOT | OPEN | OR | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | QUESTION | QUESTION_DOT | RCUR | REGEXP _ | SEQ | SET | STRING _ | TIME _ | TIMES | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
              let _v =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_0, _v) in
                _menhir_action_083 _1 _endpos__1_ _startpos__1_
              in
              _menhir_run_493 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos_0 _v MenhirState054 _tok
          | _ ->
              _eRR ())
      | UMINUS ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState054
      | TRY ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState054
      | TIME _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState054
      | STRING _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState054
      | REGEXP _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState054
      | RCUR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _endpos__2_) = (_startpos, _endpos) in
          let _v = _menhir_action_094 _endpos__2_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | PP_IFVERSION ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState054
      | PP_IFENCODER _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState054
      | PP_IFDEF _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState054
      | OPEN ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          let _menhir_s = MenhirState054 in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
          let _menhir_s = MenhirState483 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | NOT ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState054
      | LPAR ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState054
      | LETLBRA _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState054
      | LET _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState054
      | LCUR ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState054
      | LBRA ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState054
      | INTERVAL _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState054
      | INT _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState054
      | INCLUDE _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState054
      | IF ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState054
      | GET ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState054
      | FUN ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState054
      | FOR ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState054
      | FLOAT _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState054
      | ENCODER _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState054
      | DOTDOTDOT ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState054
      | DEF _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState054
      | BOOL _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState054
      | BEGIN_INTERPOLATION _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState054
      | BEGIN ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState054
      | _ ->
          _eRR ()
  
  and _menhir_run_056 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_VAR -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState056 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_057 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LBRA (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState057
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState057
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState057
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState057
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState057
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState057
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState057
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState057
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState057
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState057
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState057
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState057
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState057
      | DOTDOTDOT ->
          _menhir_run_473 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState057
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState057
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
      | RBRA ->
          let _v = _menhir_action_153 () in
          _menhir_run_479 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_058 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_235 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_time_predicate _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_059 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_060 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_070 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_061 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_IF (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState061 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | OPEN ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LETLBRA _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LET _v ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | DEF _v ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_062 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LETLBRA (_menhir_stack, _menhir_s, _v, _startpos) in
      let _menhir_s = MenhirState062 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_063 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState064 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COMMA | RBRA ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_165 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_let_opt_el _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_065 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_GET (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState065 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_066 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_FUN (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState067
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState067
          | TILD ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState067
          | LPAR ->
              _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState067
          | ARGS_OF ->
              _menhir_run_383 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState067
          | RPAR ->
              let _v = _menhir_action_037 () in
              _menhir_run_450 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState067
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_068 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_190 _1 in
      _menhir_goto_optvar _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_069 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_TILD (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | GETS ->
              let _menhir_stack = MenhirCell1_GETS (_menhir_stack, MenhirState070) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | WHILE ->
                  _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
              | VARLPAR _v_0 ->
                  _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState071
              | VARLBRA _v_1 ->
                  _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState071
              | VAR _v_2 ->
                  _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState071
              | UNDERSCORE ->
                  let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _menhir_stack = MenhirCell1_UNDERSCORE (_menhir_stack, MenhirState071, _startpos_3, _endpos_4) in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | GETS ->
                      _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState072
                  | COMMA | RPAR ->
                      let _v_5 = _menhir_action_188 () in
                      _menhir_run_442 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 _tok
                  | _ ->
                      _eRR ())
              | UMINUS ->
                  _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
              | TRY ->
                  _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
              | TIME _v_6 ->
                  _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState071
              | STRING _v_7 ->
                  _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState071
              | REGEXP _v_8 ->
                  _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState071
              | PP_IFVERSION ->
                  _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
              | PP_IFENCODER _v_9 ->
                  _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState071
              | PP_IFDEF _v_10 ->
                  _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState071
              | NOT ->
                  _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
              | LPAR ->
                  _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
              | LCUR ->
                  _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
              | LBRA ->
                  _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
              | INTERVAL _v_11 ->
                  _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState071
              | INT _v_12 ->
                  _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState071
              | INCLUDE _v_13 ->
                  _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState071
              | IF ->
                  _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
              | GET ->
                  _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
              | FUN ->
                  _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
              | FOR ->
                  _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
              | FLOAT _v_14 ->
                  _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState071
              | ENCODER _v_15 ->
                  _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15 MenhirState071
              | BOOL _v_16 ->
                  _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v_16 MenhirState071
              | BEGIN_INTERPOLATION _v_17 ->
                  _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v_17 MenhirState071
              | BEGIN ->
                  _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
              | _ ->
                  _eRR ())
          | COMMA | RPAR ->
              let _v_18 = _menhir_action_188 () in
              _menhir_run_443 _menhir_stack _menhir_lexbuf _menhir_lexer _v_18 _tok
          | _ ->
              _eRR ())
      | LPAR ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v, _startpos, _endpos) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | COLON ->
                  let _menhir_s = MenhirState446 in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | VARLPAR _v ->
                      _menhir_run_201 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                  | VAR _v ->
                      _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                  | UNDERSCORE ->
                      _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                  | LPAR ->
                      _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                  | LCUR ->
                      _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                  | LBRA ->
                      _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_073 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_GETS (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState073 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_074 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_FOR (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState074 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_077 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_080 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_078 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_ENCODER (_menhir_stack, _menhir_s, _v, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState078
      | AND | AT | BEGIN | BEGIN_INTERPOLATION _ | BIN1 _ | BIN2 _ | BIN3 _ | BOOL _ | CATCH | COALESCE | COLON | COLONCOLON | COMMA | DEF _ | DO | DOT | ELSE | ELSIF | ENCODER _ | END | END_INTERPOLATION | EOF | FINALLY | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERPOLATED_STRING _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | MINUS | NOT | OPEN | OR | PP_ELSE | PP_ENDIF | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | QUESTION | QUESTION_DOT | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TIMES | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v_0 = _menhir_action_053 () in
          _menhir_run_431 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_0 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_079 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ENCODER as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState079
      | STRING _v ->
          _menhir_run_421 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState079
      | ENCODER _v ->
          _menhir_run_424 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState079
      | RPAR ->
          let _v = _menhir_action_060 () in
          _menhir_run_426 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_080 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState081 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COMMA | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_057 _1 in
          _menhir_goto_encoder_param _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_082 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_079 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_083 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_BEGIN_INTERPOLATION (_menhir_stack, _menhir_s, _v, _startpos) in
      let _menhir_s = MenhirState083 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTERPOLATED_STRING _v ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_084 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_227 _1 in
      _menhir_goto_string_interpolation_elem _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_string_interpolation_elem : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState417
      | VARLPAR _v_0 ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState417
      | VARLBRA _v_1 ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState417
      | VAR _v_2 ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState417
      | UMINUS ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState417
      | TRY ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState417
      | TIME _v_3 ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState417
      | STRING _v_4 ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState417
      | REGEXP _v_5 ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState417
      | PP_IFVERSION ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState417
      | PP_IFENCODER _v_6 ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState417
      | PP_IFDEF _v_7 ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState417
      | NOT ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState417
      | LPAR ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState417
      | LCUR ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState417
      | LBRA ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState417
      | INTERVAL _v_8 ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState417
      | INTERPOLATED_STRING _v_9 ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState417
      | INT _v_10 ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState417
      | INCLUDE _v_11 ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState417
      | IF ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState417
      | GET ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState417
      | FUN ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState417
      | FOR ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState417
      | FLOAT _v_12 ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState417
      | ENCODER _v_13 ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState417
      | BOOL _v_14 ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState417
      | BEGIN_INTERPOLATION _v_15 ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15 MenhirState417
      | BEGIN ->
          let _menhir_stack = MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _v) in
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState417
      | END_INTERPOLATION ->
          let _1 = _v in
          let _v = _menhir_action_229 _1 in
          _menhir_goto_string_interpolation_elems _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_085 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_BEGIN (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState085 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | OPEN ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LETLBRA _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LET _v ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | DEF _v ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_086 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_startpos__1_, _1) = (_startpos, _v) in
      let _v = _menhir_action_006 _1 in
      _menhir_goto__let _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto__let : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1__let (_menhir_stack, _menhir_s, _v, _startpos) in
      match (_tok : MenhirBasics.token) with
      | VAR _v_0 ->
          let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | DOT ->
              let _menhir_stack = MenhirCell1_VAR (_menhir_stack, MenhirState304, _v_0, _startpos_1, _endpos) in
              let _menhir_s = MenhirState306 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VAR _v ->
                  _menhir_run_307 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | LCUR ->
                  _menhir_run_309 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | _ ->
                  _eRR ())
          | GETS ->
              let _v_3 =
                let _1 = _v_0 in
                _menhir_action_190 _1
              in
              _menhir_run_345 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos_1 _v_3 MenhirState304 _tok
          | _ ->
              _eRR ())
      | UNDERSCORE ->
          _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState304
      | LPAR ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, MenhirState304, _startpos_4) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_5 ->
              _menhir_run_313 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState363
          | UNDERSCORE ->
              _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState363
          | LPAR ->
              _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState363
          | LCUR ->
              _menhir_run_320 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState363
          | LBRA ->
              _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState363
          | COMMA | RPAR ->
              let _v_6 = _menhir_action_196 () in
              _menhir_run_358 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState363 _tok
          | _ ->
              _eRR ())
      | LCUR ->
          _menhir_run_320 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState304
      | LBRA ->
          _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState304
      | _ ->
          _eRR ()
  
  and _menhir_run_307 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState308 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_307 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | GETS ->
          let (_endpos__1_, _1) = (_endpos, _v) in
          let _v = _menhir_action_147 _1 in
          _menhir_goto_in_subfield _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_in_subfield : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState306 ->
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState194 ->
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState163 ->
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState308 ->
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState196 ->
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState166 ->
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_170 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_231 _1 _3 in
      _menhir_goto_subfield _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_subfield : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState191 ->
          _menhir_run_407 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState384 ->
          _menhir_run_395 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState304 ->
          _menhir_run_370 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState149 ->
          _menhir_run_175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_407 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_def as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_subfield (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          _menhir_run_297 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState407
      | BEGIN | BEGIN_INTERPOLATION _ | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v_0 = _menhir_action_130 () in
          _menhir_run_408 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState407 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_297 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_131 () in
      _menhir_goto_g _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_g : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState411 ->
          _menhir_run_412 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState407 ->
          _menhir_run_408 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState400 ->
          _menhir_run_401 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState296 ->
          _menhir_run_298 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_412 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_def, ttv_result) _menhir_cell1_optvar as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_g (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState412
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState412
      | VAR _v_2 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState412
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
      | TIME _v_3 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState412
      | STRING _v_4 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState412
      | REGEXP _v_5 ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState412
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
      | PP_IFENCODER _v_6 ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState412
      | PP_IFDEF _v_7 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState412
      | OPEN ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
      | LETLBRA _v_8 ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState412
      | LET _v_9 ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState412
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
      | INTERVAL _v_10 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState412
      | INT _v_11 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState412
      | INCLUDE _v_12 ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState412
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
      | FLOAT _v_13 ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState412
      | ENCODER _v_14 ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState412
      | DEF _v_15 ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15 MenhirState412
      | BOOL _v_16 ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v_16 MenhirState412
      | BEGIN_INTERPOLATION _v_17 ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v_17 MenhirState412
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
      | _ ->
          _eRR ()
  
  and _menhir_run_087 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_startpos__1_, _1) = (_startpos, _v) in
      let _v = _menhir_action_052 _1 in
      let _startpos = _startpos__1_ in
      let _menhir_stack = MenhirCell1_def (_menhir_stack, _menhir_s, _v, _startpos) in
      match (_tok : MenhirBasics.token) with
      | VARLPAR _v_0 ->
          _menhir_run_192 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState191
      | VAR _v_1 ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | DOT ->
              let _menhir_stack = MenhirCell1_VAR (_menhir_stack, MenhirState191, _v_1, _startpos_2, _endpos) in
              let _menhir_s = MenhirState194 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VARLPAR _v ->
                  _menhir_run_192 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | VAR _v ->
                  _menhir_run_195 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | _ ->
                  _eRR ())
          | BEGIN | BEGIN_INTERPOLATION _ | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | GETS | IF | INCLUDE _ | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
              let _v_5 =
                let _1 = _v_1 in
                _menhir_action_190 _1
              in
              _menhir_run_411 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos_2 _v_5 MenhirState191 _tok
          | _ ->
              _eRR ())
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState191
      | LPAR ->
          let _menhir_s = MenhirState191 in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          let _menhir_s = MenhirState198 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_192 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_233 _1 in
      _menhir_goto_subfield_lpar _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_subfield_lpar : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState191 ->
          _menhir_run_376 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState194 ->
          _menhir_run_197 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState196 ->
          _menhir_run_197 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_376 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_def as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_subfield_lpar (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | VAR _v_0 ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState376
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState376
      | TILD ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState376
      | LPAR ->
          _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState376
      | ARGS_OF ->
          _menhir_run_383 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState376
      | RPAR ->
          let _v_1 = _menhir_action_037 () in
          _menhir_run_399 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState376
      | _ ->
          _eRR ()
  
  and _menhir_run_377 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState377 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_383 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLBRA _v ->
              let _menhir_stack = MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s) in
              let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
              let _menhir_s = MenhirState384 in
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _menhir_stack = MenhirCell1_VARLBRA (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _menhir_s = MenhirState385 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VAR _v ->
                  _menhir_run_151 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | GET ->
                  _menhir_run_153 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | _ ->
                  _eRR ())
          | VAR _v ->
              let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | RPAR ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let _3 = _v in
                  let _v = _menhir_action_033 _3 in
                  _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
              | DOT ->
                  let _menhir_stack = MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s) in
                  let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
                  let _menhir_stack = MenhirCell1_VAR (_menhir_stack, MenhirState384, _v, _startpos_2, _endpos) in
                  _menhir_run_163 _menhir_stack _menhir_lexbuf _menhir_lexer
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_151 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState152 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_151 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GET ->
              _menhir_run_153 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | RBRA ->
          let _1 = _v in
          let _v = _menhir_action_040 _1 in
          _menhir_goto_args_of_params _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_153 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | COMMA ->
              let _menhir_stack = MenhirCell1_GET (_menhir_stack, _menhir_s, _startpos) in
              let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v, _startpos_0, _endpos) in
              let _menhir_s = MenhirState155 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VAR _v ->
                  _menhir_run_151 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | GET ->
                  _menhir_run_153 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | _ ->
                  _eRR ())
          | RBRA ->
              let _2 = _v in
              let _v = _menhir_action_041 _2 in
              _menhir_goto_args_of_params _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_goto_args_of_params : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState391 ->
          _menhir_run_392 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState385 ->
          _menhir_run_386 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState171 ->
          _menhir_run_172 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState150 ->
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState152 ->
          _menhir_run_157 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState155 ->
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_392 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, ttv_result) _menhir_cell1_subfield_lbra -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_subfield_lbra (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s) = _menhir_stack in
          let _4 = _v in
          let _v = _menhir_action_036 _3 _4 in
          _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_arg : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_arg (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_0 ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState405
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState405
          | TILD ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState405
          | LPAR ->
              _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState405
          | ARGS_OF ->
              _menhir_run_383 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState405
          | RPAR ->
              let _v_1 = _menhir_action_037 () in
              _menhir_run_406 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1
          | _ ->
              _eRR ())
      | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_038 _1 in
          _menhir_goto_arglist _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_406 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_arg -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_arg (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_039 _1 _3 in
      _menhir_goto_arglist _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_arglist : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState067 ->
          _menhir_run_450 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState405 ->
          _menhir_run_406 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState376 ->
          _menhir_run_399 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_450 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_FUN _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_arglist (_menhir_stack, _menhir_s, _v) in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell0_RPAR (_menhir_stack, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | YIELDS ->
          let _menhir_s = MenhirState452 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_399 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_def, ttv_result) _menhir_cell1_subfield_lpar as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_arglist (_menhir_stack, _menhir_s, _v) in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell0_RPAR (_menhir_stack, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          _menhir_run_297 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | BEGIN | BEGIN_INTERPOLATION _ | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v_0 = _menhir_action_130 () in
          _menhir_run_401 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState400 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_401 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_def, ttv_result) _menhir_cell1_subfield_lpar, ttv_result) _menhir_cell1_arglist _menhir_cell0_RPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_g (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState401
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState401
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState401
      | VAR _v_2 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState401
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState401
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState401
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState401
      | TIME _v_3 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState401
      | STRING _v_4 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState401
      | REGEXP _v_5 ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState401
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState401
      | PP_IFENCODER _v_6 ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState401
      | PP_IFDEF _v_7 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState401
      | OPEN ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState401
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState401
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState401
      | LETLBRA _v_8 ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState401
      | LET _v_9 ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState401
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState401
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState401
      | INTERVAL _v_10 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState401
      | INT _v_11 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState401
      | INCLUDE _v_12 ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState401
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState401
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState401
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState401
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState401
      | FLOAT _v_13 ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState401
      | ENCODER _v_14 ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState401
      | DEF _v_15 ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15 MenhirState401
      | BOOL _v_16 ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v_16 MenhirState401
      | BEGIN_INTERPOLATION _v_17 ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v_17 MenhirState401
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState401
      | _ ->
          _eRR ()
  
  and _menhir_run_386 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, ttv_result) _menhir_cell1_VARLBRA -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_VARLBRA (_menhir_stack, _, _3, _, _) = _menhir_stack in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s) = _menhir_stack in
          let _4 = _v in
          let _v = _menhir_action_035 _3 _4 in
          _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_172 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, ttv_result) _menhir_cell1_subfield_lbra -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_subfield_lbra (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s) = _menhir_stack in
          let _4 = _v in
          let _v = _menhir_action_027 _3 _4 in
          _menhir_goto_app_list_elem _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_app_list_elem : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_app_list_elem (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState179
          | VARLPAR _v_0 ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState179
          | VARLBRA _v_1 ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState179
          | VAR _v_2 ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState179
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState179
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState179
          | TIME _v_3 ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState179
          | STRING _v_4 ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState179
          | REGEXP _v_5 ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState179
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState179
          | PP_IFENCODER _v_6 ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState179
          | PP_IFDEF _v_7 ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState179
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState179
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState179
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState179
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState179
          | INTERVAL _v_8 ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState179
          | INT _v_9 ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState179
          | INCLUDE _v_10 ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState179
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState179
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState179
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState179
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState179
          | FLOAT _v_11 ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState179
          | ENCODER _v_12 ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState179
          | BOOL _v_13 ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState179
          | BEGIN_INTERPOLATION _v_14 ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState179
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState179
          | ARGS_OF ->
              _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState179
          | RPAR ->
              let _v_15 = _menhir_action_019 () in
              _menhir_run_180 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15
          | _ ->
              _eRR ())
      | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_020 _1 in
          _menhir_goto_app_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_101 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState102 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | AND | AT | BIN1 _ | BIN2 _ | BIN3 _ | COALESCE | COLONCOLON | COMMA | DOT | MINUS | OR | QUESTION | QUESTION_DOT | RPAR | SET | TIMES ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_083 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_148 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLBRA _v ->
              let _menhir_stack = MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s) in
              let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
              let _menhir_s = MenhirState149 in
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _menhir_stack = MenhirCell1_VARLBRA (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _menhir_s = MenhirState150 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VAR _v ->
                  _menhir_run_151 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | GET ->
                  _menhir_run_153 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | _ ->
                  _eRR ())
          | VAR _v ->
              let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | RPAR ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let _3 = _v in
                  let _v = _menhir_action_024 _3 in
                  _menhir_goto_app_list_elem _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
              | DOT ->
                  let _menhir_stack = MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s) in
                  let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
                  let _menhir_stack = MenhirCell1_VAR (_menhir_stack, MenhirState149, _v, _startpos_2, _endpos) in
                  _menhir_run_163 _menhir_stack _menhir_lexbuf _menhir_lexer
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_163 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, ttv_result) _menhir_cell1_VAR -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState163 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VARLBRA _v ->
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_165 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_164 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_149 _1 in
      _menhir_goto_in_subfield_lbra _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_in_subfield_lbra : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState163 ->
          _menhir_run_169 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState166 ->
          _menhir_run_167 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_169 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_232 _1 _3 in
      _menhir_goto_subfield_lbra _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_subfield_lbra : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState384 ->
          _menhir_run_391 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState149 ->
          _menhir_run_171 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_391 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_subfield_lbra (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | VAR _v_0 ->
          _menhir_run_151 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState391
      | GET ->
          _menhir_run_153 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState391
      | _ ->
          _eRR ()
  
  and _menhir_run_171 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_subfield_lbra (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | VAR _v_0 ->
          _menhir_run_151 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState171
      | GET ->
          _menhir_run_153 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState171
      | _ ->
          _eRR ()
  
  and _menhir_run_167 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_150 _1 _3 in
      _menhir_goto_in_subfield_lbra _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_165 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState166 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLBRA _v ->
              _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_165 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | RPAR ->
          let (_endpos__1_, _1) = (_endpos, _v) in
          let _v = _menhir_action_147 _1 in
          _menhir_goto_in_subfield _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_180 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_app_list_elem -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_app_list_elem (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_021 _1 _3 in
      _menhir_goto_app_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_app_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState026 ->
          _menhir_run_551 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState100 ->
          _menhir_run_181 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState179 ->
          _menhir_run_180 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_551 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VARLPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_VARLPAR (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_097 _1 _2 _endpos__1_ _endpos__3_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_181 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VARLPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_VARLPAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_162 _1 _2 in
      _menhir_goto_invoke _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _v _menhir_s _tok
  
  and _menhir_goto_invoke : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState099 ->
          _menhir_run_183 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState112 ->
          _menhir_run_145 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_183 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_QUESTION_DOT -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_QUESTION_DOT (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_095 _1 _3 _endpos__3_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_145 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_DOT -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_DOT (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_096 _1 _3 _endpos__3_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_158 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, ttv_result) _menhir_cell1_VARLBRA -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_VARLBRA (_menhir_stack, _, _3, _, _) = _menhir_stack in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s) = _menhir_stack in
          let _4 = _v in
          let _v = _menhir_action_026 _3 _4 in
          _menhir_goto_app_list_elem _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_157 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_042 _1 _3 in
      _menhir_goto_args_of_params _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_156 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_GET _menhir_cell0_VAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell0_VAR (_menhir_stack, _2, _, _) = _menhir_stack in
      let MenhirCell1_GET (_menhir_stack, _menhir_s, _) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_043 _2 _4 in
      _menhir_goto_args_of_params _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_197 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_234 _1 _3 in
      _menhir_goto_subfield_lpar _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_195 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState196 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v ->
              _menhir_run_192 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_195 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | BEGIN | BEGIN_INTERPOLATION _ | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | GETS | IF | INCLUDE _ | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let (_endpos__1_, _1) = (_endpos, _v) in
          let _v = _menhir_action_147 _1 in
          _menhir_goto_in_subfield _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_411 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_def as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_optvar (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          _menhir_run_297 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState411
      | BEGIN | BEGIN_INTERPOLATION _ | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v_0 = _menhir_action_130 () in
          _menhir_run_412 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState411 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_408 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_def, ttv_result) _menhir_cell1_subfield as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_g (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState408
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState408
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState408
      | VAR _v_2 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState408
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState408
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState408
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState408
      | TIME _v_3 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState408
      | STRING _v_4 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState408
      | REGEXP _v_5 ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState408
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState408
      | PP_IFENCODER _v_6 ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState408
      | PP_IFDEF _v_7 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState408
      | OPEN ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState408
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState408
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState408
      | LETLBRA _v_8 ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState408
      | LET _v_9 ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState408
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState408
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState408
      | INTERVAL _v_10 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState408
      | INT _v_11 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState408
      | INCLUDE _v_12 ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState408
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState408
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState408
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState408
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState408
      | FLOAT _v_13 ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState408
      | ENCODER _v_14 ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState408
      | DEF _v_15 ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15 MenhirState408
      | BOOL _v_16 ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v_16 MenhirState408
      | BEGIN_INTERPOLATION _v_17 ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v_17 MenhirState408
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState408
      | _ ->
          _eRR ()
  
  and _menhir_run_298 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_def, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_optvar, ttv_result) _menhir_cell1_ty _menhir_cell0_RPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_g (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState298
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState298
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState298
      | VAR _v_2 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState298
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState298
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState298
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState298
      | TIME _v_3 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState298
      | STRING _v_4 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState298
      | REGEXP _v_5 ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState298
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState298
      | PP_IFENCODER _v_6 ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState298
      | PP_IFDEF _v_7 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState298
      | OPEN ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState298
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState298
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState298
      | LETLBRA _v_8 ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState298
      | LET _v_9 ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState298
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState298
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState298
      | INTERVAL _v_10 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState298
      | INT _v_11 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState298
      | INCLUDE _v_12 ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState298
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState298
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState298
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState298
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState298
      | FLOAT _v_13 ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState298
      | ENCODER _v_14 ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState298
      | DEF _v_15 ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15 MenhirState298
      | BOOL _v_16 ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v_16 MenhirState298
      | BEGIN_INTERPOLATION _v_17 ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v_17 MenhirState298
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState298
      | _ ->
          _eRR ()
  
  and _menhir_run_395 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_034 _3 in
          _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_370 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1__let as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_subfield (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_s = MenhirState371 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_175 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_025 _3 in
          _menhir_goto_app_list_elem _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_168 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_148 _1 _3 in
      _menhir_goto_in_subfield _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _v _menhir_s _tok
  
  and _menhir_run_309 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_310 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState309
      | RCUR ->
          let _v = _menhir_action_177 () in
          _menhir_run_325 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_310 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v in
          let _v = _menhir_action_175 _1 in
          _menhir_goto_meth_pattern_el _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | GETS ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState312 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_313 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_320 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COMMA | RCUR ->
          let _1 = _v in
          let _v = _menhir_action_174 _1 in
          _menhir_goto_meth_pattern_el _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_meth_pattern_el : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState362 ->
          _menhir_run_361 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState309 ->
          _menhir_run_361 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState328 ->
          _menhir_run_327 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState320 ->
          _menhir_run_327 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_361 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_meth_pattern_el (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_0 ->
              _menhir_run_310 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState362
          | RCUR ->
              let _v_1 = _menhir_action_177 () in
              _menhir_run_330 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1
          | _ ->
              _eRR ())
      | RCUR ->
          let _1 = _v in
          let _v = _menhir_action_178 _1 in
          _menhir_goto_meth_pattern_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_330 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_meth_pattern_el -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_meth_pattern_el (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_179 _1 _3 in
      _menhir_goto_meth_pattern_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_meth_pattern_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState362 ->
          _menhir_run_330 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState328 ->
          _menhir_run_330 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState309 ->
          _menhir_run_325 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState320 ->
          _menhir_run_325 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_325 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LCUR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_212 _2 in
      _menhir_goto_record_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_record_pattern : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState348 ->
          _menhir_run_349 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState304 ->
          _menhir_run_341 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState363 ->
          _menhir_run_341 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState312 ->
          _menhir_run_341 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState319 ->
          _menhir_run_341 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState354 ->
          _menhir_run_341 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState356 ->
          _menhir_run_341 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState331 ->
          _menhir_run_341 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState343 ->
          _menhir_run_341 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState339 ->
          _menhir_run_341 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState336 ->
          _menhir_run_337 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState317 ->
          _menhir_run_318 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState306 ->
          _menhir_run_315 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState314 ->
          _menhir_run_315 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_349 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_list_pattern -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_list_pattern (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_173 _1 _3 _endpos__1_ _startpos__1_ in
      _menhir_goto_meth_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_meth_pattern : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_195 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_pattern : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState304 ->
          _menhir_run_373 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState363 ->
          _menhir_run_364 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState312 ->
          _menhir_run_360 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState319 ->
          _menhir_run_350 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState331 ->
          _menhir_run_350 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState356 ->
          _menhir_run_350 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState339 ->
          _menhir_run_350 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState354 ->
          _menhir_run_344 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState343 ->
          _menhir_run_344 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_373 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1__let as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_pattern (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_s = MenhirState374 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_364 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1__let, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _menhir_stack = MenhirCell1_pattern (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState365 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v ->
              _menhir_run_201 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COMMA | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_197 _1 in
          _menhir_goto_pattern_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_201 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v_0 ->
          let _menhir_stack = MenhirCell1_VARLPAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_202 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState201
      | RPAR ->
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_1, _endpos__2_) = (_v, _endpos_1) in
          let _v = _menhir_action_266 _1 in
          _menhir_goto_ty_source _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _v _menhir_s _tok
      | DOTDOTDOT ->
          let _menhir_stack = MenhirCell1_VARLPAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState201
      | _ ->
          _eRR ()
  
  and _menhir_run_202 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v_0 ->
              let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _menhir_stack = MenhirCell0_VARLPAR (_menhir_stack, _v_0, _startpos_1, _endpos_2) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VAR _v_3 ->
                  _menhir_run_205 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState204
              | STRING _v_4 ->
                  _menhir_run_211 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState204
              | INT _v_5 ->
                  _menhir_run_212 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState204
              | FLOAT _v_6 ->
                  _menhir_run_213 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState204
              | RPAR ->
                  let _v_7 = _menhir_action_263 () in
                  _menhir_run_214 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7
              | _ ->
                  _eRR ())
          | VAR _v_8 ->
              let _startpos_9 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_10 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | DOT ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | VARLPAR _v_11 ->
                      let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v_8, _startpos_9, _endpos_10) in
                      let _startpos_12 = _menhir_lexbuf.Lexing.lex_start_p in
                      let _endpos_13 = _menhir_lexbuf.Lexing.lex_curr_p in
                      let _menhir_stack = MenhirCell0_VARLPAR (_menhir_stack, _v_11, _startpos_12, _endpos_13) in
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | VAR _v_14 ->
                          _menhir_run_205 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState221
                      | STRING _v_15 ->
                          _menhir_run_211 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15 MenhirState221
                      | INT _v_16 ->
                          _menhir_run_212 _menhir_stack _menhir_lexbuf _menhir_lexer _v_16 MenhirState221
                      | FLOAT _v_17 ->
                          _menhir_run_213 _menhir_stack _menhir_lexbuf _menhir_lexer _v_17 MenhirState221
                      | RPAR ->
                          let _v_18 = _menhir_action_263 () in
                          _menhir_run_222 _menhir_stack _menhir_lexbuf _menhir_lexer _v_18
                      | _ ->
                          _eRR ())
                  | VAR _v_19 ->
                      let _startpos_20 = _menhir_lexbuf.Lexing.lex_start_p in
                      let _endpos_21 = _menhir_lexbuf.Lexing.lex_curr_p in
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | DOT ->
                          let _tok = _menhir_lexer _menhir_lexbuf in
                          (match (_tok : MenhirBasics.token) with
                          | VARLPAR _v_22 ->
                              let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v_8, _startpos_9, _endpos_10) in
                              let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v_19, _startpos_20, _endpos_21) in
                              let _startpos_23 = _menhir_lexbuf.Lexing.lex_start_p in
                              let _endpos_24 = _menhir_lexbuf.Lexing.lex_curr_p in
                              let _menhir_stack = MenhirCell0_VARLPAR (_menhir_stack, _v_22, _startpos_23, _endpos_24) in
                              let _tok = _menhir_lexer _menhir_lexbuf in
                              (match (_tok : MenhirBasics.token) with
                              | VAR _v_25 ->
                                  _menhir_run_205 _menhir_stack _menhir_lexbuf _menhir_lexer _v_25 MenhirState226
                              | STRING _v_26 ->
                                  _menhir_run_211 _menhir_stack _menhir_lexbuf _menhir_lexer _v_26 MenhirState226
                              | INT _v_27 ->
                                  _menhir_run_212 _menhir_stack _menhir_lexbuf _menhir_lexer _v_27 MenhirState226
                              | FLOAT _v_28 ->
                                  _menhir_run_213 _menhir_stack _menhir_lexbuf _menhir_lexer _v_28 MenhirState226
                              | RPAR ->
                                  let _v_29 = _menhir_action_263 () in
                                  _menhir_run_227 _menhir_stack _menhir_lexbuf _menhir_lexer _v_29
                              | _ ->
                                  _eRR ())
                          | VAR _v_30 ->
                              let _tok = _menhir_lexer _menhir_lexbuf in
                              let (_1, _3, _5) = (_v_8, _v_19, _v_30) in
                              let _v = _menhir_action_251 _1 _3 _5 in
                              _menhir_goto_ty_content _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
                          | _ ->
                              _eRR ())
                      | COMMA | RPAR ->
                          let (_1, _3) = (_v_8, _v_19) in
                          let _v = _menhir_action_250 _1 _3 in
                          _menhir_goto_ty_content _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
                      | _ ->
                          _eRR ())
                  | _ ->
                      _eRR ())
              | COMMA | RPAR ->
                  let _1 = _v_8 in
                  let _v = _menhir_action_249 _1 in
                  _menhir_goto_ty_content _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_205 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_1, _3) = (_v, _v_0) in
              let _v = _menhir_action_259 _1 _3 in
              _menhir_goto_ty_content_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | STRING _v_3 ->
              let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_1, _endpos__3_, _startpos__3_, _3) = (_v, _endpos_5, _startpos_4, _v_3) in
              let _v = _menhir_action_260 _1 _3 _endpos__3_ _startpos__3_ in
              _menhir_goto_ty_content_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | INT _v_6 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_1, _3) = (_v, _v_6) in
              let _v = _menhir_action_261 _1 _3 in
              _menhir_goto_ty_content_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | FLOAT _v_9 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_1, _3) = (_v, _v_9) in
              let _v = _menhir_action_262 _1 _3 in
              _menhir_goto_ty_content_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | COMMA | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_255 _1 in
          _menhir_goto_ty_content_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_ty_content_arg : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_ty_content_arg (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_0 ->
              _menhir_run_205 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState217
          | STRING _v_1 ->
              _menhir_run_211 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState217
          | INT _v_2 ->
              _menhir_run_212 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState217
          | FLOAT _v_3 ->
              _menhir_run_213 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState217
          | RPAR ->
              let _v_4 = _menhir_action_263 () in
              _menhir_run_218 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4
          | _ ->
              _eRR ())
      | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_264 _1 in
          _menhir_goto_ty_content_args _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_211 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_258 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_ty_content_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_212 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_256 _1 in
      _menhir_goto_ty_content_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_213 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_257 _1 in
      _menhir_goto_ty_content_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_218 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ty_content_arg -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_ty_content_arg (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_265 _1 _3 in
      _menhir_goto_ty_content_args _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_ty_content_args : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState226 ->
          _menhir_run_227 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState221 ->
          _menhir_run_222 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState217 ->
          _menhir_run_218 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState204 ->
          _menhir_run_214 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_227 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR _menhir_cell0_VAR _menhir_cell0_VAR _menhir_cell0_VARLPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_VARLPAR (_menhir_stack, _5, _, _) = _menhir_stack in
      let MenhirCell0_VAR (_menhir_stack, _3, _, _) = _menhir_stack in
      let MenhirCell0_VAR (_menhir_stack, _1, _, _) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_254 _1 _3 _5 _6 in
      _menhir_goto_ty_content _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_goto_ty_content : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell0_ty_content (_menhir_stack, _v) in
          let _menhir_s = MenhirState231 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_202 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | DOTDOTDOT ->
              _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | RPAR ->
          let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_268 _1 _3 in
          _menhir_goto_ty_source_tracks _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_232 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_269 () in
      _menhir_goto_ty_source_tracks _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_ty_source_tracks : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState201 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState231 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_235 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VARLPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_VARLPAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let (_2, _endpos__3_) = (_v, _endpos) in
          let _v = _menhir_action_267 _1 _2 in
          _menhir_goto_ty_source _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_ty_source : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      let (_endpos__1_, _1) = (_endpos, _v) in
      let _v = _menhir_action_248 _1 in
      _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_ty : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState506 ->
          _menhir_run_507 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState446 ->
          _menhir_run_447 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState379 ->
          _menhir_run_380 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState365 ->
          _menhir_run_366 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState200 ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState293 ->
          _menhir_run_294 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState288 ->
          _menhir_run_289 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState284 ->
          _menhir_run_286 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState239 ->
          _menhir_run_283 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState279 ->
          _menhir_run_280 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState241 ->
          _menhir_run_276 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState272 ->
          _menhir_run_273 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState245 ->
          _menhir_run_271 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState264 ->
          _menhir_run_265 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState262 ->
          _menhir_run_263 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState246 ->
          _menhir_run_248 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_507 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COLON as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_COLON (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _, _2, _, _) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_074 _2 _4 _endpos__5_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_254 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ty -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_ty (_menhir_stack, _menhir_s, _1, _) = _menhir_stack in
      let _endpos__2_ = _endpos in
      let _v = _menhir_action_240 _1 in
      _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _v _menhir_s _tok
  
  and _menhir_run_255 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ty -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_ty (_menhir_stack, _menhir_s, _1, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_246 _1 _3 in
          _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _v _menhir_s _tok
      | LCUR ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LCUR (_menhir_stack, _startpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_243 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState257
          | STRING _v ->
              _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState257
          | RCUR ->
              let _v = _menhir_action_214 () in
              _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_243 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_QUESTION (_menhir_stack, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | COLON ->
              let _menhir_s = MenhirState245 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VARLPAR _v ->
                  _menhir_run_201 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | VAR _v ->
                  _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | UNDERSCORE ->
                  _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LPAR ->
                  _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LCUR ->
                  _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LBRA ->
                  _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | COLON ->
          let _menhir_s = MenhirState272 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v ->
              _menhir_run_201 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_237 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _1) = (_endpos, _v) in
      let _v = _menhir_action_239 _1 in
      _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_238 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _endpos__1_ = _endpos in
      let _v = _menhir_action_238 () in
      _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_239 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VARLPAR _v ->
          _menhir_run_201 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState239
      | VAR _v ->
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState239
      | UNDERSCORE ->
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState239
      | QUESTION ->
          _menhir_run_277 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState239
      | LPAR ->
          _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState239
      | LCUR ->
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState239
      | LBRA ->
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState239
      | RPAR ->
          let _v = _menhir_action_044 () in
          _menhir_run_291 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState239
      | _ ->
          _eRR ()
  
  and _menhir_run_240 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState241 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v ->
              _menhir_run_201 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COMMA | DOT | QUESTION | RPAR | TIMES ->
          let (_endpos__1_, _1) = (_endpos, _v) in
          let _v = _menhir_action_239 _1 in
          _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_242 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_243 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState242
      | STRING _v ->
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState242
      | RCUR ->
          let _v = _menhir_action_214 () in
          _menhir_run_274 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_258 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_STRING (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v, _startpos, _endpos) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | QUESTION ->
                  let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _menhir_stack = MenhirCell0_QUESTION (_menhir_stack, _endpos) in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | COLON ->
                      let _menhir_s = MenhirState262 in
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | VARLPAR _v ->
                          _menhir_run_201 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                      | VAR _v ->
                          _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                      | UNDERSCORE ->
                          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                      | LPAR ->
                          _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                      | LCUR ->
                          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                      | LBRA ->
                          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                      | _ ->
                          _eRR ())
                  | _ ->
                      _eRR ())
              | COLON ->
                  let _menhir_s = MenhirState264 in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | VARLPAR _v ->
                      _menhir_run_201 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                  | VAR _v ->
                      _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                  | UNDERSCORE ->
                      _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                  | LPAR ->
                      _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                  | LCUR ->
                      _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                  | LBRA ->
                      _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_246 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LBRA (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState246 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VARLPAR _v ->
          _menhir_run_201 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UNDERSCORE ->
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_274 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LCUR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LCUR (_menhir_stack, _menhir_s, _) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_245 _2 in
      _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _v _menhir_s _tok
  
  and _menhir_run_277 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_QUESTION (_menhir_stack, _menhir_s, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | COLON ->
              let _menhir_s = MenhirState279 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VARLPAR _v ->
                  _menhir_run_201 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | VAR _v ->
                  _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | UNDERSCORE ->
                  _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LPAR ->
                  _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LCUR ->
                  _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LBRA ->
                  _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_291 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_argsty (_menhir_stack, _menhir_s, _v) in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell0_RPAR (_menhir_stack, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | YIELDS ->
          let _menhir_s = MenhirState293 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v ->
              _menhir_run_201 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_266 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ty _menhir_cell0_LCUR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_LCUR (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_ty (_menhir_stack, _menhir_s, _1, _) = _menhir_stack in
      let (_4, _endpos__5_) = (_v, _endpos) in
      let _v = _menhir_action_247 _1 _4 in
      _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _v _menhir_s _tok
  
  and _menhir_run_447 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_TILD _menhir_cell0_LPAR _menhir_cell0_VAR as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_RPAR (_menhir_stack, _endpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | GETS ->
              _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState448
          | COMMA | RPAR ->
              let _v_1 = _menhir_action_188 () in
              _menhir_run_449 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 _tok
          | _ ->
              _eRR ())
      | QUESTION ->
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_449 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_TILD _menhir_cell0_LPAR _menhir_cell0_VAR, ttv_result) _menhir_cell1_ty _menhir_cell0_RPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell0_RPAR (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_ty (_menhir_stack, _, _5, _) = _menhir_stack in
      let MenhirCell0_VAR (_menhir_stack, _3, _, _) = _menhir_stack in
      let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_TILD (_menhir_stack, _menhir_s) = _menhir_stack in
      let _7 = _v in
      let _v = _menhir_action_029 _3 _5 _7 in
      _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_380 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_optvar as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_RPAR (_menhir_stack, _endpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | GETS ->
              _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState381
          | COMMA | RPAR ->
              let _v_1 = _menhir_action_188 () in
              _menhir_run_382 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 _tok
          | _ ->
              _eRR ())
      | QUESTION ->
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_382 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_optvar, ttv_result) _menhir_cell1_ty _menhir_cell0_RPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell0_RPAR (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_ty (_menhir_stack, _, _4, _) = _menhir_stack in
      let MenhirCell1_optvar (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_032 _2 _4 _6 in
      _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_366 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1__let, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_pattern as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_RPAR (_menhir_stack, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | GETS ->
              let _menhir_s = MenhirState368 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | WHILE ->
                  _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | VARLPAR _v ->
                  _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | VARLBRA _v ->
                  _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | VAR _v ->
                  _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | UMINUS ->
                  _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | TRY ->
                  _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | TIME _v ->
                  _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | STRING _v ->
                  _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | REGEXP _v ->
                  _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | PP_IFVERSION ->
                  _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | PP_IFENCODER _v ->
                  _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | PP_IFDEF _v ->
                  _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | NOT ->
                  _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LPAR ->
                  _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LCUR ->
                  _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LBRA ->
                  _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | INTERVAL _v ->
                  _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | INT _v ->
                  _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | INCLUDE _v ->
                  _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | IF ->
                  _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | GET ->
                  _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | FUN ->
                  _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | FOR ->
                  _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | FLOAT _v ->
                  _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | ENCODER _v ->
                  _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | BOOL _v ->
                  _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | BEGIN_INTERPOLATION _v ->
                  _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | BEGIN ->
                  _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | QUESTION ->
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_295 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_def, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_optvar as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_RPAR (_menhir_stack, _endpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | GETS ->
              _menhir_run_297 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState296
          | BEGIN | BEGIN_INTERPOLATION _ | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
              let _v_1 = _menhir_action_130 () in
              _menhir_run_298 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState296 _tok
          | _ ->
              _eRR ())
      | QUESTION ->
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_294 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_argsty _menhir_cell0_RPAR as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RBRA | RCUR | RPAR | TIMES ->
          let MenhirCell0_RPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_argsty (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _) = _menhir_stack in
          let (_5, _endpos__5_) = (_v, _endpos) in
          let _v = _menhir_action_244 _2 _5 in
          _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_289 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_argty as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_047 _1 in
          _menhir_goto_argty _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_argty : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_argty (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v_0 ->
              _menhir_run_201 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState288
          | VAR _v_1 ->
              _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState288
          | UNDERSCORE ->
              _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState288
          | QUESTION ->
              _menhir_run_277 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState288
          | LPAR ->
              _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState288
          | LCUR ->
              _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState288
          | LBRA ->
              _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState288
          | RPAR ->
              let _v_2 = _menhir_action_044 () in
              _menhir_run_290 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2
          | _ ->
              _eRR ())
      | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_045 _1 in
          _menhir_goto_argsty _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_290 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_argty -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_argty (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_046 _1 _3 in
      _menhir_goto_argsty _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_argsty : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState239 ->
          _menhir_run_291 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState288 ->
          _menhir_run_290 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_286 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ty as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_284 _menhir_stack _menhir_lexbuf _menhir_lexer
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let MenhirCell1_ty (_menhir_stack, _menhir_s, _1, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_271 _1 _3 in
          _menhir_goto_ty_tuple _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_284 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ty -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState284 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VARLPAR _v ->
          _menhir_run_201 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UNDERSCORE ->
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_ty_tuple : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState284 ->
          _menhir_run_285 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState239 ->
          _menhir_run_281 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_285 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ty -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_ty (_menhir_stack, _menhir_s, _1, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_272 _1 _3 in
      _menhir_goto_ty_tuple _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_281 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_243 _2 in
      _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _v _menhir_s _tok
  
  and _menhir_run_283 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_284 _menhir_stack _menhir_lexbuf _menhir_lexer
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_047 _1 in
          _menhir_goto_argty _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_280 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_QUESTION _menhir_cell0_VAR as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RPAR ->
          let MenhirCell0_VAR (_menhir_stack, _2, _, _) = _menhir_stack in
          let MenhirCell1_QUESTION (_menhir_stack, _menhir_s, _) = _menhir_stack in
          let _4 = _v in
          let _v = _menhir_action_049 _2 _4 in
          _menhir_goto_argty _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_276 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RPAR ->
          let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_048 _1 _3 in
          _menhir_goto_argty _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_273 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RCUR ->
          let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_183 _1 _3 in
          _menhir_goto_meth_ty _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_meth_ty : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_meth_ty (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_0 ->
              _menhir_run_243 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState269
          | STRING _v_1 ->
              _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState269
          | RCUR ->
              let _v_2 = _menhir_action_214 () in
              _menhir_run_270 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2
          | _ ->
              _eRR ())
      | RCUR ->
          let _1 = _v in
          let _v = _menhir_action_215 _1 in
          _menhir_goto_record_ty _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_270 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_meth_ty -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_meth_ty (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_216 _1 _3 in
      _menhir_goto_record_ty _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_record_ty : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState242 ->
          _menhir_run_274 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState269 ->
          _menhir_run_270 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState257 ->
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_271 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR _menhir_cell0_QUESTION as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RCUR ->
          let MenhirCell0_QUESTION (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _4 = _v in
          let _v = _menhir_action_184 _1 _4 in
          _menhir_goto_meth_ty _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_265 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STRING _menhir_cell0_VAR _menhir_cell0_VAR as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RCUR ->
          let MenhirCell0_VAR (_menhir_stack, _3, _, _) = _menhir_stack in
          let MenhirCell0_VAR (_menhir_stack, _2, _, _) = _menhir_stack in
          let MenhirCell1_STRING (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_5, _endpos__5_) = (_v, _endpos) in
          let _v = _menhir_action_185 _1 _2 _3 _5 _endpos__5_ _startpos__1_ in
          _menhir_goto_meth_ty _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_263 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STRING _menhir_cell0_VAR _menhir_cell0_VAR _menhir_cell0_QUESTION as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RCUR ->
          let MenhirCell0_QUESTION (_menhir_stack, _) = _menhir_stack in
          let MenhirCell0_VAR (_menhir_stack, _3, _, _) = _menhir_stack in
          let MenhirCell0_VAR (_menhir_stack, _2, _, _) = _menhir_stack in
          let MenhirCell1_STRING (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__6_, _6) = (_endpos, _v) in
          let _v = _menhir_action_186 _1 _2 _3 _6 _endpos__6_ _startpos__1_ in
          _menhir_goto_meth_ty _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_248 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LBRA as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | RBRA ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_1 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VAR _v_3 ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | DOT ->
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | VAR _v_6 ->
                          let _endpos_8 = _menhir_lexbuf.Lexing.lex_curr_p in
                          let _tok = _menhir_lexer _menhir_lexbuf in
                          let MenhirCell1_LBRA (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
                          let (_2, _5, _4, _7, _endpos__7_) = (_v, _v_3, _v_1, _v_6, _endpos_8) in
                          let _v = _menhir_action_242 _2 _4 _5 _7 _endpos__7_ _startpos__1_ in
                          _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _v _menhir_s _tok
                      | _ ->
                          _eRR ())
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | COMMA | DOT | QUESTION | RBRA | RCUR | RPAR | TIMES ->
              let MenhirCell1_LBRA (_menhir_stack, _menhir_s, _) = _menhir_stack in
              let (_2, _endpos__3_) = (_v, _endpos_0) in
              let _v = _menhir_action_241 _2 in
              _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _v _menhir_s _tok
          | _ ->
              _eRR ())
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_233 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR _menhir_cell0_ty_content -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell0_ty_content (_menhir_stack, _3) = _menhir_stack in
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _5 = _v in
      let _v = _menhir_action_270 _1 _3 _5 in
      _menhir_goto_ty_source_tracks _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_222 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR _menhir_cell0_VAR _menhir_cell0_VARLPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_VARLPAR (_menhir_stack, _3, _, _) = _menhir_stack in
      let MenhirCell0_VAR (_menhir_stack, _1, _, _) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_253 _1 _3 _4 in
      _menhir_goto_ty_content _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_214 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR _menhir_cell0_VARLPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_VARLPAR (_menhir_stack, _1, _, _) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_252 _1 _2 in
      _menhir_goto_ty_content _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_goto_pattern_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState363 ->
          _menhir_run_358 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState319 ->
          _menhir_run_358 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState356 ->
          _menhir_run_357 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState331 ->
          _menhir_run_353 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState339 ->
          _menhir_run_342 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_358 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_2, _endpos__3_) = (_v, _endpos) in
          let _v = _menhir_action_237 _2 in
          let (_endpos, _startpos) = (_endpos__3_, _startpos__1_) in
          (match (_tok : MenhirBasics.token) with
          | DOT ->
              let _menhir_stack = MenhirCell1_tuple_pattern (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _menhir_s = MenhirState336 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | LCUR ->
                  _menhir_run_309 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | _ ->
                  _eRR ())
          | COLON | COMMA | GETS | RBRA | RCUR | RPAR ->
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
              let _v = _menhir_action_193 _1 _endpos__1_ _startpos__1_ in
              _menhir_goto_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | COMMA ->
          let _menhir_stack = MenhirCell1_pattern_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_343 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_343 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_pattern_list -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState343 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_313 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UNDERSCORE ->
          _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_320 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_313 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState314 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LCUR ->
              _menhir_run_309 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COLON | COMMA | RBRA | RCUR | RPAR ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_190 _1 in
          _menhir_goto_optvar _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_316 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_UNDERSCORE (_menhir_stack, _menhir_s, _startpos, _endpos) in
          let _menhir_s = MenhirState317 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LCUR ->
              _menhir_run_309 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COLON | COMMA | GETS | RBRA | RCUR | RPAR ->
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_191 () in
          _menhir_goto_optvar _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_319 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_313 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState319
      | UNDERSCORE ->
          _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | LPAR ->
          _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | LCUR ->
          _menhir_run_320 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | LBRA ->
          _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | COMMA | RPAR ->
          let _v = _menhir_action_196 () in
          _menhir_run_358 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState319 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_320 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_310 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState320
      | DOTDOTDOT ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState320
      | RCUR ->
          let _v = _menhir_action_177 () in
          _menhir_run_325 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_321 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          let _menhir_stack = MenhirCell1_DOTDOTDOT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState321
      | UNDERSCORE ->
          let _menhir_stack = MenhirCell1_DOTDOTDOT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState321
      | RCUR ->
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_180 _endpos__1_ _startpos__1_ in
          _menhir_goto_meth_spread_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_meth_spread_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState328 ->
          _menhir_run_329 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState320 ->
          _menhir_run_323 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_329 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_meth_pattern_el -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_meth_pattern_el (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_182 _1 _3 in
      _menhir_goto_meth_spread_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_323 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LCUR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RCUR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_2, _endpos__3_) = (_v, _endpos) in
          let _v = _menhir_action_213 _2 in
          let (_endpos, _startpos) = (_endpos__3_, _startpos__1_) in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_168 _1 in
          _menhir_goto_meth_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_331 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LBRA (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_313 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState331
      | UNDERSCORE ->
          _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState331
      | LPAR ->
          _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState331
      | LCUR ->
          _menhir_run_320 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState331
      | LBRA ->
          _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState331
      | DOTDOTDOT ->
          _menhir_run_332 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState331
      | COMMA | RBRA ->
          let _v = _menhir_action_196 () in
          _menhir_run_353 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState331 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_332 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          let _menhir_stack = MenhirCell1_DOTDOTDOT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState332
      | UNDERSCORE ->
          let _menhir_stack = MenhirCell1_DOTDOTDOT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState332
      | COMMA | RBRA ->
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_224 () in
          _menhir_goto_spread _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_spread : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState354 ->
          _menhir_run_355 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState331 ->
          _menhir_run_338 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_355 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LBRA, ttv_result) _menhir_cell1_pattern_list as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_spread (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_0 ->
              _menhir_run_313 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState356
          | UNDERSCORE ->
              _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState356
          | LPAR ->
              _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState356
          | LCUR ->
              _menhir_run_320 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState356
          | LBRA ->
              _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState356
          | COMMA | RBRA ->
              let _v_1 = _menhir_action_196 () in
              _menhir_run_357 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState356 _tok
          | _ ->
              _eRR ())
      | RBRA ->
          let MenhirCell1_pattern_list (_menhir_stack, _, _1) = _menhir_stack in
          let (_endpos__3_, _startpos__3_, _3) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_202 _1 _3 _endpos__3_ _startpos__3_ in
          _menhir_goto_pattern_list_with_spread _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_357 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_LBRA, ttv_result) _menhir_cell1_pattern_list, ttv_result) _menhir_cell1_spread as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_pattern_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_343 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RBRA ->
          let MenhirCell1_spread (_menhir_stack, _, _3, _startpos__3_, _endpos__3_) = _menhir_stack in
          let MenhirCell1_pattern_list (_menhir_stack, _, _1) = _menhir_stack in
          let _5 = _v in
          let _v = _menhir_action_203 _1 _3 _5 _endpos__3_ _startpos__3_ in
          _menhir_goto_pattern_list_with_spread _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_goto_pattern_list_with_spread : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LBRA -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LBRA (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_167 _2 in
      let (_endpos, _startpos) = (_endpos__3_, _startpos__1_) in
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_list_pattern (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState348 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LCUR ->
              _menhir_run_309 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COLON | COMMA | GETS | RBRA | RCUR | RPAR ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_194 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_338 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LBRA as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_spread (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_0 ->
              _menhir_run_313 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState339
          | UNDERSCORE ->
              _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState339
          | LPAR ->
              _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState339
          | LCUR ->
              _menhir_run_320 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState339
          | LBRA ->
              _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState339
          | COMMA | RBRA ->
              let _v_1 = _menhir_action_196 () in
              _menhir_run_342 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState339 _tok
          | _ ->
              _eRR ())
      | RBRA ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_199 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_pattern_list_with_spread _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_342 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LBRA, ttv_result) _menhir_cell1_spread as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_pattern_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_343 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RBRA ->
          let MenhirCell1_spread (_menhir_stack, _, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_201 _1 _3 _endpos__1_ _startpos__1_ in
          _menhir_goto_pattern_list_with_spread _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_353 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LBRA as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_pattern_list (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState354 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_313 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_320 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOTDOTDOT ->
              _menhir_run_332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | RBRA ->
          let _1 = _v in
          let _v = _menhir_action_200 _1 in
          _menhir_goto_pattern_list_with_spread _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_360 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_176 _1 _3 in
      _menhir_goto_meth_pattern_el _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_350 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_197 _1 in
      _menhir_goto_pattern_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_344 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_pattern_list -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_pattern_list (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_198 _1 _3 in
      _menhir_goto_pattern_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_341 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_169 _1 in
      _menhir_goto_meth_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_337 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_tuple_pattern -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_tuple_pattern (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_172 _1 _3 _endpos__1_ _startpos__1_ in
      _menhir_goto_meth_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_318 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_UNDERSCORE -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_UNDERSCORE (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_171 _3 _endpos__3_ _startpos__1_ in
      _menhir_goto_meth_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_315 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_170 _1 _3 _endpos__1_ _startpos__1_ in
      _menhir_goto_meth_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_327 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_meth_pattern_el (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_0 ->
              _menhir_run_310 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState328
          | DOTDOTDOT ->
              _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | RCUR ->
              let _v_1 = _menhir_action_177 () in
              _menhir_run_330 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1
          | _ ->
              _eRR ())
      | RCUR ->
          let _1 = _v in
          let _v = _menhir_action_178 _1 in
          _menhir_goto_meth_pattern_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_345 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_273 _1 in
      let (_endpos, _startpos) = (_endpos__1_, _startpos__1_) in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_192 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_string_interpolation_elems : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState417 ->
          _menhir_run_418 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState083 ->
          _menhir_run_415 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_418 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_string_interpolation_elem -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_string_interpolation_elem (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_230 _1 _2 in
      _menhir_goto_string_interpolation_elems _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_415 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_BEGIN_INTERPOLATION -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_BEGIN_INTERPOLATION (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_226 _1 _2 in
      let (_endpos, _startpos) = (_endpos__3_, _startpos__1_) in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_082 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_encoder_param : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_encoder_param (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_0 ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState429
          | STRING _v_1 ->
              _menhir_run_421 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState429
          | ENCODER _v_2 ->
              _menhir_run_424 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState429
          | RPAR ->
              let _v_3 = _menhir_action_060 () in
              _menhir_run_430 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3
          | _ ->
              _eRR ())
      | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_061 _1 in
          _menhir_goto_encoder_params _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_421 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_stack = MenhirCell1_STRING (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState422 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COMMA | RPAR ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_058 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_encoder_param _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_424 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_ENCODER (_menhir_stack, _menhir_s, _v, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState424
      | COMMA | RPAR ->
          let _v_0 = _menhir_action_053 () in
          _menhir_run_425 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_425 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ENCODER -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_ENCODER (_menhir_stack, _menhir_s, _1, _) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_059 _1 _2 in
      _menhir_goto_encoder_param _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_430 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_encoder_param -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_encoder_param (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_062 _1 _3 in
      _menhir_goto_encoder_params _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_encoder_params : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState562 ->
          _menhir_run_563 _menhir_stack _v
      | MenhirState429 ->
          _menhir_run_430 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState079 ->
          _menhir_run_426 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_426 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ENCODER, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_054 _2 in
      _menhir_goto_encoder_opt _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _v _menhir_s _tok
  
  and _menhir_goto_encoder_opt : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ENCODER as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState078 ->
          _menhir_run_431 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState424 ->
          _menhir_run_425 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_431 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ENCODER -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_ENCODER (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
      let (_endpos__2_, _2) = (_endpos, _v) in
      let _v = _menhir_action_087 _1 _2 _endpos__2_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_442 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_TILD _menhir_cell0_VAR, ttv_result) _menhir_cell1_GETS, ttv_result) _menhir_cell1_UNDERSCORE -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_UNDERSCORE (_menhir_stack, _, _, _) = _menhir_stack in
      let MenhirCell1_GETS (_menhir_stack, _) = _menhir_stack in
      let MenhirCell0_VAR (_menhir_stack, _2, _, _) = _menhir_stack in
      let MenhirCell1_TILD (_menhir_stack, _menhir_s) = _menhir_stack in
      let _5 = _v in
      let _v = _menhir_action_030 _2 _5 in
      _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_443 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_TILD _menhir_cell0_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell0_VAR (_menhir_stack, _2, _, _) = _menhir_stack in
      let MenhirCell1_TILD (_menhir_stack, _menhir_s) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_028 _2 _3 in
      _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_let_opt_el : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_let_opt_el (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState457 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | RBRA ->
          let _1 = _v in
          let _v = _menhir_action_163 _1 in
          _menhir_goto_let_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_goto_let_opt : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState062 ->
          _menhir_run_459 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState457 ->
          _menhir_run_458 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_459 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LETLBRA -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LETLBRA (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_007 _1 _2 _endpos__3_ _startpos__1_ in
      _menhir_goto__let _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_458 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_let_opt_el -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_let_opt_el (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_164 _1 _3 in
      _menhir_goto_let_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_473 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_DOTDOTDOT (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState473 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_479 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LBRA -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LBRA (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_274 _2 in
      _menhir_goto_varlist _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_varlist : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState540 ->
          _menhir_run_541 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState566 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState023 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState554 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState025 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState026 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState027 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState029 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState544 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState542 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState536 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState534 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState529 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState030 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState525 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState042 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState520 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState044 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState515 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState049 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState511 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState050 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState051 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState503 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState052 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState497 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState494 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState054 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState485 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState483 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState056 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState476 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState057 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState473 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState468 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState466 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState464 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState462 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState061 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState064 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState065 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState452 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState071 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState073 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState438 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState435 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState433 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState076 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState422 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState081 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState417 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState083 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState412 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState408 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState401 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState374 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState371 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState368 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState302 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState298 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState188 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState179 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState100 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState146 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState141 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState139 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState133 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState128 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState126 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState124 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState122 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState120 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState118 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState116 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState113 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState110 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState108 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState106 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState104 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState102 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState097 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState092 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState085 ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_541 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_TRY, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_optvar as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_varlist (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | DO ->
          let _menhir_s = MenhirState542 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | OPEN ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LETLBRA _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LET _v ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | DEF _v ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_088 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_084 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_493 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LCUR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState493
      | SET ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState493
      | SEQ ->
          _menhir_run_187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState493
      | QUESTION_DOT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState493
      | QUESTION ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState493
      | OR ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState493
      | MINUS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState493
      | DOT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState493
      | COLONCOLON ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState493
      | COALESCE ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState493
      | BIN3 _v_0 ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState493
      | BIN2 _v_1 ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState493
      | BIN1 _v_2 ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState493
      | AT ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState493
      | AND ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState493
      | BEGIN | BEGIN_INTERPOLATION _ | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | RCUR | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v_3 = _menhir_action_217 () in
          _menhir_run_494 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_3 MenhirState493 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_104 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SET (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState104 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_187 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _endpos__1_ = _endpos in
      let _v = _menhir_action_218 () in
      _menhir_goto_s _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_s : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState510 ->
          _menhir_run_511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState496 ->
          _menhir_run_497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState493 ->
          _menhir_run_494 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState484 ->
          _menhir_run_485 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState301 ->
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState186 ->
          _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_511 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState511
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState511
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState511
      | VAR _v_2 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState511
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState511
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState511
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState511
      | TIME _v_3 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState511
      | STRING _v_4 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState511
      | REGEXP _v_5 ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState511
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState511
      | PP_IFENCODER _v_6 ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState511
      | PP_IFDEF _v_7 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState511
      | OPEN ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState511
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState511
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState511
      | LETLBRA _v_8 ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState511
      | LET _v_9 ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState511
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState511
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState511
      | INTERVAL _v_10 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState511
      | INT _v_11 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState511
      | INCLUDE _v_12 ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState511
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState511
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState511
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState511
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState511
      | FLOAT _v_13 ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState511
      | ENCODER _v_14 ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState511
      | DEF _v_15 ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15 MenhirState511
      | BOOL _v_16 ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v_16 MenhirState511
      | BEGIN_INTERPOLATION _v_17 ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v_17 MenhirState511
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState511
      | _ ->
          _eRR ()
  
  and _menhir_run_497 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_explicit_binding as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
      | VARLPAR _v_0 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState497
      | VARLBRA _v_1 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState497
      | VAR _v_2 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState497
      | UNDERSCORE ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
      | UMINUS ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
      | TRY ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
      | TIME _v_3 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState497
      | STRING _v_4 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState497
      | REGEXP _v_5 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState497
      | PP_IFVERSION ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
      | PP_IFENCODER _v_6 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState497
      | PP_IFDEF _v_7 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState497
      | OPEN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
      | NOT ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
      | LPAR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
      | LETLBRA _v_8 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState497
      | LET _v_9 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState497
      | LCUR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
      | LBRA ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
      | INTERVAL _v_10 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState497
      | INT _v_11 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState497
      | INCLUDE _v_12 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState497
      | IF ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
      | GET ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
      | FUN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
      | FOR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
      | FLOAT _v_13 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState497
      | ENCODER _v_14 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState497
      | DEF _v_15 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15 MenhirState497
      | BOOL _v_16 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v_16 MenhirState497
      | BEGIN_INTERPOLATION _v_17 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v_17 MenhirState497
      | BEGIN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
      | RCUR ->
          let MenhirCell1_explicit_binding (_menhir_stack, _, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
          let _endpos__2_ = _endpos in
          let _v = _menhir_action_222 _1 _endpos__1_ _endpos__2_ _startpos__1_ in
          _menhir_goto_simple_fun_body _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_simple_fun_body : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LCUR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RCUR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_2, _endpos__3_) = (_v, _endpos) in
          let _v = _menhir_action_103 _2 _endpos__3_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_494 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | VARLPAR _v_0 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState494
      | VARLBRA _v_1 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState494
      | VAR _v_2 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState494
      | UNDERSCORE ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | UMINUS ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | TRY ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | TIME _v_3 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState494
      | STRING _v_4 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState494
      | REGEXP _v_5 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState494
      | PP_IFVERSION ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | PP_IFENCODER _v_6 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState494
      | PP_IFDEF _v_7 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState494
      | OPEN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | NOT ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | LPAR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | LETLBRA _v_8 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState494
      | LET _v_9 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState494
      | LCUR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | LBRA ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | INTERVAL _v_10 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState494
      | INT _v_11 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState494
      | INCLUDE _v_12 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState494
      | IF ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | GET ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | FUN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | FOR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | FLOAT _v_13 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState494
      | ENCODER _v_14 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState494
      | DEF _v_15 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15 MenhirState494
      | BOOL _v_16 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v_16 MenhirState494
      | BEGIN_INTERPOLATION _v_17 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v_17 MenhirState494
      | BEGIN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | RCUR ->
          let MenhirCell1_expr (_menhir_stack, _, _1, _, _) = _menhir_stack in
          let _v = _menhir_action_220 _1 in
          _menhir_goto_simple_fun_body _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_485 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState485
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState485
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState485
      | VAR _v_2 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState485
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState485
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState485
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState485
      | TIME _v_3 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState485
      | STRING _v_4 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState485
      | REGEXP _v_5 ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState485
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState485
      | PP_IFENCODER _v_6 ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState485
      | PP_IFDEF _v_7 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState485
      | OPEN ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState485
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState485
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState485
      | LETLBRA _v_8 ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState485
      | LET _v_9 ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState485
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState485
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState485
      | INTERVAL _v_10 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState485
      | INT _v_11 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState485
      | INCLUDE _v_12 ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState485
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState485
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState485
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState485
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState485
      | FLOAT _v_13 ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState485
      | ENCODER _v_14 ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState485
      | DEF _v_15 ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15 MenhirState485
      | BOOL _v_16 ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v_16 MenhirState485
      | BEGIN_INTERPOLATION _v_17 ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v_17 MenhirState485
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState485
      | _ ->
          _eRR ()
  
  and _menhir_run_302 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_binding as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState302
      | VARLPAR _v_0 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState302
      | VARLBRA _v_1 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState302
      | VAR _v_2 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState302
      | UNDERSCORE ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState302
      | UMINUS ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState302
      | TRY ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState302
      | TIME _v_3 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState302
      | STRING _v_4 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState302
      | REGEXP _v_5 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState302
      | PP_IFVERSION ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState302
      | PP_IFENCODER _v_6 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState302
      | PP_IFDEF _v_7 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState302
      | OPEN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState302
      | NOT ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState302
      | LPAR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState302
      | LETLBRA _v_8 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState302
      | LET _v_9 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState302
      | LCUR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState302
      | LBRA ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState302
      | INTERVAL _v_10 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState302
      | INT _v_11 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState302
      | INCLUDE _v_12 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState302
      | IF ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState302
      | GET ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState302
      | FUN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState302
      | FOR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState302
      | FLOAT _v_13 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState302
      | ENCODER _v_14 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState302
      | DEF _v_15 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15 MenhirState302
      | BOOL _v_16 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v_16 MenhirState302
      | BEGIN_INTERPOLATION _v_17 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v_17 MenhirState302
      | BEGIN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState302
      | CATCH | ELSE | ELSIF | END | EOF | FINALLY | PP_ELSE | PP_ENDIF | RCUR | SEQSEQ | THEN ->
          let MenhirCell1_binding (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
          let _endpos__2_ = _endpos in
          let _v = _menhir_action_128 _1 _endpos__1_ _endpos__2_ _startpos__1_ in
          _menhir_goto_exprs _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_exprs : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState566 ->
          _menhir_run_570 _menhir_stack _v _tok
      | MenhirState023 ->
          _menhir_run_559 _menhir_stack _v _tok
      | MenhirState554 ->
          _menhir_run_555 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState544 ->
          _menhir_run_545 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState542 ->
          _menhir_run_543 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState536 ->
          _menhir_run_537 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState534 ->
          _menhir_run_535 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState529 ->
          _menhir_run_530 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState030 ->
          _menhir_run_528 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState525 ->
          _menhir_run_526 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState042 ->
          _menhir_run_523 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState520 ->
          _menhir_run_521 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState044 ->
          _menhir_run_518 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState515 ->
          _menhir_run_516 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState049 ->
          _menhir_run_513 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState511 ->
          _menhir_run_512 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState497 ->
          _menhir_run_498 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState494 ->
          _menhir_run_495 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState485 ->
          _menhir_run_486 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState468 ->
          _menhir_run_469 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState466 ->
          _menhir_run_467 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState464 ->
          _menhir_run_465 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState462 ->
          _menhir_run_463 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState061 ->
          _menhir_run_461 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState438 ->
          _menhir_run_439 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState435 ->
          _menhir_run_436 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState412 ->
          _menhir_run_413 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState408 ->
          _menhir_run_409 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState401 ->
          _menhir_run_402 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState302 ->
          _menhir_run_303 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState298 ->
          _menhir_run_299 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState188 ->
          _menhir_run_189 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState085 ->
          _menhir_run_184 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_555 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_WHILE, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_DO -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_DO (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _, _2, _, _) = _menhir_stack in
          let MenhirCell1_WHILE (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_104 _2 _4 _endpos__5_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_545 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_TRY, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_optvar, ttv_result) _menhir_cell1_varlist, ttv_result) _menhir_cell1_exprs -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_exprs (_menhir_stack, _, _8, _) = _menhir_stack in
          let MenhirCell1_varlist (_menhir_stack, _, _6, _startpos__6_, _endpos__6_) = _menhir_stack in
          let MenhirCell1_optvar (_menhir_stack, _, _4, _, _) = _menhir_stack in
          let MenhirCell1_exprs (_menhir_stack, _, _2, _) = _menhir_stack in
          let MenhirCell1_TRY (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos__11_, _10) = (_endpos_0, _v) in
          let _v = _menhir_action_110 _10 _2 _4 _6 _8 _endpos__11_ _endpos__6_ _startpos__1_ _startpos__6_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__11_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_543 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_TRY, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_optvar, ttv_result) _menhir_cell1_varlist as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | FINALLY ->
          let _menhir_stack = MenhirCell1_exprs (_menhir_stack, _menhir_s, _v, _endpos) in
          let _menhir_s = MenhirState544 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | OPEN ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LETLBRA _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LET _v ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | DEF _v ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | END ->
          let _endpos_18 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_varlist (_menhir_stack, _, _6, _startpos__6_, _endpos__6_) = _menhir_stack in
          let MenhirCell1_optvar (_menhir_stack, _, _4, _, _) = _menhir_stack in
          let MenhirCell1_exprs (_menhir_stack, _, _2, _) = _menhir_stack in
          let MenhirCell1_TRY (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_8, _endpos__9_) = (_v, _endpos_18) in
          let _v = _menhir_action_109 _2 _4 _6 _8 _endpos__6_ _endpos__9_ _startpos__1_ _startpos__6_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__9_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_537 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_TRY, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_optvar, ttv_result) _menhir_cell1_exprs -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_exprs (_menhir_stack, _, _6, _) = _menhir_stack in
          let MenhirCell1_optvar (_menhir_stack, _, _4, _, _) = _menhir_stack in
          let MenhirCell1_exprs (_menhir_stack, _, _2, _) = _menhir_stack in
          let MenhirCell1_TRY (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_8, _endpos__9_) = (_v, _endpos_0) in
          let _v = _menhir_action_112 _2 _4 _6 _8 _endpos__9_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__9_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_535 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_TRY, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_optvar as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | FINALLY ->
          let _menhir_stack = MenhirCell1_exprs (_menhir_stack, _menhir_s, _v, _endpos) in
          let _menhir_s = MenhirState536 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | OPEN ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LETLBRA _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LET _v ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | DEF _v ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | END ->
          let _endpos_18 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_optvar (_menhir_stack, _, _4, _, _) = _menhir_stack in
          let MenhirCell1_exprs (_menhir_stack, _, _2, _) = _menhir_stack in
          let MenhirCell1_TRY (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_6, _endpos__7_) = (_v, _endpos_18) in
          let _v = _menhir_action_111 _2 _4 _6 _endpos__7_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_530 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_TRY, ttv_result) _menhir_cell1_exprs -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_exprs (_menhir_stack, _, _2, _) = _menhir_stack in
          let MenhirCell1_TRY (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_108 _2 _4 _endpos__5_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_528 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_TRY as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_exprs (_menhir_stack, _menhir_s, _v, _endpos) in
      match (_tok : MenhirBasics.token) with
      | FINALLY ->
          let _menhir_s = MenhirState529 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | OPEN ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LETLBRA _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LET _v ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | DEF _v ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | CATCH ->
          let _menhir_s = MenhirState532 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_526 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_PP_IFVERSION _menhir_cell0_if_version_op _menhir_cell0_if_version_version, ttv_result) _menhir_cell1_exprs -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | PP_ENDIF ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_exprs (_menhir_stack, _, _4, _) = _menhir_stack in
          let MenhirCell0_if_version_version (_menhir_stack, _3) = _menhir_stack in
          let MenhirCell0_if_version_op (_menhir_stack, _2) = _menhir_stack in
          let MenhirCell1_PP_IFVERSION (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_6, _endpos__7_) = (_v, _endpos_0) in
          let _v = _menhir_action_142 _2 _3 _4 _6 in
          _menhir_goto_if_version _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_if_version : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_073 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_523 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_PP_IFVERSION _menhir_cell0_if_version_op _menhir_cell0_if_version_version as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | PP_ENDIF ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_if_version_version (_menhir_stack, _3) = _menhir_stack in
          let MenhirCell0_if_version_op (_menhir_stack, _2) = _menhir_stack in
          let MenhirCell1_PP_IFVERSION (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_141 _2 _3 _4 in
          _menhir_goto_if_version _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | PP_ELSE ->
          let _menhir_stack = MenhirCell1_exprs (_menhir_stack, _menhir_s, _v, _endpos) in
          let _menhir_s = MenhirState525 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | OPEN ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LETLBRA _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LET _v ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | DEF _v ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_521 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_PP_IFENCODER _menhir_cell0_ENCODER, ttv_result) _menhir_cell1_exprs -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | PP_ENDIF ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_exprs (_menhir_stack, _, _3, _) = _menhir_stack in
          let MenhirCell0_ENCODER (_menhir_stack, _2, _) = _menhir_stack in
          let MenhirCell1_PP_IFENCODER (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
          let (_endpos__6_, _5) = (_endpos_0, _v) in
          let _v = _menhir_action_140 _1 _2 _3 _5 in
          _menhir_goto_if_encoder _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__6_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_if_encoder : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_518 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_PP_IFENCODER _menhir_cell0_ENCODER as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | PP_ENDIF ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_ENCODER (_menhir_stack, _2, _) = _menhir_stack in
          let MenhirCell1_PP_IFENCODER (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
          let (_3, _endpos__4_) = (_v, _endpos_0) in
          let _v = _menhir_action_139 _1 _2 _3 in
          _menhir_goto_if_encoder _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | PP_ELSE ->
          let _menhir_stack = MenhirCell1_exprs (_menhir_stack, _menhir_s, _v, _endpos) in
          let _menhir_s = MenhirState520 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | OPEN ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LETLBRA _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LET _v ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | DEF _v ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_516 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_PP_IFDEF, ttv_result) _menhir_cell1_if_def_var, ttv_result) _menhir_cell1_exprs -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | PP_ENDIF ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_exprs (_menhir_stack, _, _3, _) = _menhir_stack in
          let MenhirCell1_if_def_var (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_PP_IFDEF (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
          let (_endpos__6_, _5) = (_endpos_0, _v) in
          let _v = _menhir_action_133 _1 _2 _3 _5 in
          _menhir_goto_if_def _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__6_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_if_def : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_071 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_513 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_PP_IFDEF, ttv_result) _menhir_cell1_if_def_var as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | PP_ENDIF ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_if_def_var (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_PP_IFDEF (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
          let (_3, _endpos__4_) = (_v, _endpos_0) in
          let _v = _menhir_action_132 _1 _2 _3 in
          _menhir_goto_if_def _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | PP_ELSE ->
          let _menhir_stack = MenhirCell1_exprs (_menhir_stack, _menhir_s, _v, _endpos) in
          let _menhir_s = MenhirState515 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | OPEN ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LETLBRA _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LET _v ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | DEF _v ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_512 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_s -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_s (_menhir_stack, _, _, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_endpos__4_, _4) = (_endpos, _v) in
      let _v = _menhir_action_125 _2 _4 _endpos__4_ _startpos__1_ in
      _menhir_goto_exprs _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _v _menhir_s _tok
  
  and _menhir_run_498 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_explicit_binding, ttv_result) _menhir_cell1_s -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_s (_menhir_stack, _, _, _) = _menhir_stack in
      let MenhirCell1_explicit_binding (_menhir_stack, _, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_223 _1 _3 _endpos__1_ _startpos__1_ in
      _menhir_goto_simple_fun_body _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_495 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_s -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_s (_menhir_stack, _, _, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _, _1, _startpos__1_, _) = _menhir_stack in
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_221 _1 _3 _endpos__3_ _startpos__1_ in
      _menhir_goto_simple_fun_body _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_486 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_s -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_s (_menhir_stack, _, _, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_OPEN (_menhir_stack, _, _startpos__1_) = _menhir_stack in
      let (_endpos__4_, _4) = (_endpos, _v) in
      let _v = _menhir_action_219 _2 _4 _endpos__4_ _startpos__1_ in
      _menhir_goto_simple_fun_body _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_469 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_ELSE -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_ELSE (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_137 _2 in
      _menhir_goto_if_elsif _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_if_elsif : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_exprs as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState463 ->
          _menhir_run_471 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState467 ->
          _menhir_run_470 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_471 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_IF, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_exprs -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_exprs (_menhir_stack, _, _4, _) = _menhir_stack in
          let MenhirCell1_exprs (_menhir_stack, _, _2, _) = _menhir_stack in
          let MenhirCell1_IF (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos__6_, _5) = (_endpos, _v) in
          let _v = _menhir_action_113 _2 _4 _5 _endpos__6_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__6_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_470 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_ELSIF, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_exprs -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_exprs (_menhir_stack, _, _4, _) = _menhir_stack in
      let MenhirCell1_exprs (_menhir_stack, _, _2, _) = _menhir_stack in
      let MenhirCell1_ELSIF (_menhir_stack, _menhir_s) = _menhir_stack in
      let _5 = _v in
      let _v = _menhir_action_136 _2 _4 _5 in
      _menhir_goto_if_elsif _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_467 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_ELSIF, ttv_result) _menhir_cell1_exprs as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_exprs (_menhir_stack, _menhir_s, _v, _endpos) in
      match (_tok : MenhirBasics.token) with
      | ELSIF ->
          _menhir_run_464 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState467
      | ELSE ->
          _menhir_run_468 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState467
      | END ->
          let _v_0 = _menhir_action_138 () in
          _menhir_run_470 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_464 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_exprs as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_ELSIF (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState464 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | OPEN ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LETLBRA _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LET _v ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | DEF _v ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_468 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_exprs as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_ELSE (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState468 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | OPEN ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LETLBRA _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LET _v ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | DEF _v ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_465 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_ELSIF as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_exprs (_menhir_stack, _menhir_s, _v, _endpos) in
      match (_tok : MenhirBasics.token) with
      | THEN ->
          let _menhir_s = MenhirState466 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | OPEN ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LETLBRA _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LET _v ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | DEF _v ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_463 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_IF, ttv_result) _menhir_cell1_exprs as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_exprs (_menhir_stack, _menhir_s, _v, _endpos) in
      match (_tok : MenhirBasics.token) with
      | ELSIF ->
          _menhir_run_464 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState463
      | ELSE ->
          _menhir_run_468 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState463
      | END ->
          let _v_0 = _menhir_action_138 () in
          _menhir_run_471 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_461 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_IF as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_exprs (_menhir_stack, _menhir_s, _v, _endpos) in
      match (_tok : MenhirBasics.token) with
      | THEN ->
          let _menhir_s = MenhirState462 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | OPEN ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LETLBRA _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LET _v ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | DEF _v ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_439 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_FOR, ttv_result) _menhir_cell1_optvar, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_DO -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_DO (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _, _4, _, _) = _menhir_stack in
          let MenhirCell1_optvar (_menhir_stack, _, _2, _, _) = _menhir_stack in
          let MenhirCell1_FOR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_6, _endpos__7_) = (_v, _endpos_0) in
          let _v = _menhir_action_106 _2 _4 _6 _endpos__7_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_436 : type  ttv_stack ttv_result. ((((((ttv_stack, ttv_result) _menhir_cell1_FOR, ttv_result) _menhir_cell1_optvar, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_TO, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_DO -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_DO (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _, _6, _, _) = _menhir_stack in
          let MenhirCell1_TO (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _, _4, _, _) = _menhir_stack in
          let MenhirCell1_optvar (_menhir_stack, _, _2, _, _) = _menhir_stack in
          let MenhirCell1_FOR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_8, _endpos__9_) = (_v, _endpos_0) in
          let _v = _menhir_action_105 _2 _4 _6 _8 _endpos__9_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__9_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_413 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_def, ttv_result) _menhir_cell1_optvar, ttv_result) _menhir_cell1_g -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_g (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_optvar (_menhir_stack, _, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_def (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_066 _1 _2 _4 _endpos__2_ _startpos__2_ in
          _menhir_goto_explicit_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_explicit_binding : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState054 ->
          _menhir_run_496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState566 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState023 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState554 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState030 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState542 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState544 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState534 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState536 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState529 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState042 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState525 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState044 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState520 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState049 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState515 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState511 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState497 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState494 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState485 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState061 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState462 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState464 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState466 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState468 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState438 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState435 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState085 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState412 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState408 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState401 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState302 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState298 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState188 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_496 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LCUR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_explicit_binding (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | SEQ ->
          _menhir_run_187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState496
      | BEGIN | BEGIN_INTERPOLATION _ | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | RCUR | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v_0 = _menhir_action_217 () in
          _menhir_run_497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_0 MenhirState496 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_190 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_051 _1 in
      _menhir_goto_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_binding : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_binding (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | SEQ ->
          _menhir_run_187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState301
      | BEGIN | BEGIN_INTERPOLATION _ | BOOL _ | CATCH | DEF _ | ELSE | ELSIF | ENCODER _ | END | EOF | FINALLY | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | PP_ELSE | PP_ENDIF | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | RCUR | REGEXP _ | SEQSEQ | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v_0 = _menhir_action_217 () in
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_0 MenhirState301 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_409 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_def, ttv_result) _menhir_cell1_subfield, ttv_result) _menhir_cell1_g -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_g (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_subfield (_menhir_stack, _, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_def (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_068 _1 _2 _4 _endpos__2_ _startpos__2_ in
          _menhir_goto_explicit_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_402 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_def, ttv_result) _menhir_cell1_subfield_lpar, ttv_result) _menhir_cell1_arglist _menhir_cell0_RPAR, ttv_result) _menhir_cell1_g -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_g (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell0_RPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_arglist (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_subfield_lpar (_menhir_stack, _, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_def (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
          let (_6, _endpos__7_) = (_v, _endpos_0) in
          let _v = _menhir_action_069 _1 _2 _3 _6 _endpos__2_ _startpos__2_ in
          _menhir_goto_explicit_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_303 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_binding, ttv_result) _menhir_cell1_s -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_s (_menhir_stack, _, _, _) = _menhir_stack in
      let MenhirCell1_binding (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_129 _1 _3 _endpos__1_ _startpos__1_ in
      _menhir_goto_exprs _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _v _menhir_s _tok
  
  and _menhir_run_299 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_def, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_optvar, ttv_result) _menhir_cell1_ty _menhir_cell0_RPAR, ttv_result) _menhir_cell1_g -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_g (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell0_RPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ty (_menhir_stack, _, _5, _) = _menhir_stack in
          let MenhirCell1_optvar (_menhir_stack, _, _3, _startpos__3_, _endpos__3_) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_def (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
          let (_8, _endpos__9_) = (_v, _endpos_0) in
          let _v = _menhir_action_067 _1 _3 _5 _8 _endpos__3_ _startpos__3_ in
          _menhir_goto_explicit_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__9_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_189 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_s -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_s (_menhir_stack, _, _, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_127 _1 _3 _endpos__3_ _startpos__1_ in
      _menhir_goto_exprs _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _v _menhir_s _tok
  
  and _menhir_run_184 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_BEGIN -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_BEGIN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_2, _endpos__3_) = (_v, _endpos_0) in
          let _v = _menhir_action_101 _2 _endpos__3_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_188 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState188
      | VARLPAR _v_0 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState188
      | VARLBRA _v_1 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState188
      | VAR _v_2 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState188
      | UNDERSCORE ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState188
      | UMINUS ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState188
      | TRY ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState188
      | TIME _v_3 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState188
      | STRING _v_4 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState188
      | REGEXP _v_5 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState188
      | PP_IFVERSION ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState188
      | PP_IFENCODER _v_6 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState188
      | PP_IFDEF _v_7 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState188
      | OPEN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState188
      | NOT ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState188
      | LPAR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState188
      | LETLBRA _v_8 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState188
      | LET _v_9 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState188
      | LCUR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState188
      | LBRA ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState188
      | INTERVAL _v_10 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState188
      | INT _v_11 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState188
      | INCLUDE _v_12 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState188
      | IF ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState188
      | GET ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState188
      | FUN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState188
      | FOR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState188
      | FLOAT _v_13 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState188
      | ENCODER _v_14 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState188
      | DEF _v_15 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15 MenhirState188
      | BOOL _v_16 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v_16 MenhirState188
      | BEGIN_INTERPOLATION _v_17 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v_17 MenhirState188
      | BEGIN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState188
      | CATCH | ELSE | ELSIF | END | EOF | FINALLY | PP_ELSE | PP_ENDIF | RCUR | SEQSEQ | THEN ->
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _endpos__2_ = _endpos in
          let _v = _menhir_action_126 _1 in
          _menhir_goto_exprs _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_099 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_QUESTION_DOT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState099 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VARLPAR _v ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_100 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_VARLPAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState100
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState100
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState100
      | VAR _v_2 ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState100
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState100
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState100
      | TIME _v_3 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState100
      | STRING _v_4 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState100
      | REGEXP _v_5 ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState100
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState100
      | PP_IFENCODER _v_6 ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState100
      | PP_IFDEF _v_7 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState100
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState100
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState100
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState100
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState100
      | INTERVAL _v_8 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState100
      | INT _v_9 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState100
      | INCLUDE _v_10 ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState100
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState100
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState100
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState100
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState100
      | FLOAT _v_11 ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState100
      | ENCODER _v_12 ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState100
      | BOOL _v_13 ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState100
      | BEGIN_INTERPOLATION _v_14 ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState100
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState100
      | ARGS_OF ->
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState100
      | RPAR ->
          let _v_15 = _menhir_action_019 () in
          _menhir_run_181 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15
      | _ ->
          _eRR ()
  
  and _menhir_run_130 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _1) = (_endpos, _v) in
      let _v = _menhir_action_161 _1 in
      _menhir_goto_invoke _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_106 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_QUESTION (_menhir_stack, _menhir_s, _endpos) in
      let _menhir_s = MenhirState106 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_108 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_OR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState108 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_110 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_MINUS (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState110 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_112 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_DOT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState112 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VARLPAR _v ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell1_VARLBRA (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState113 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | VAR _v ->
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LCUR ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          let _menhir_s = MenhirState131 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | GETS ->
                  _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer
              | _ ->
                  _eRR ())
          | DOTDOTDOT ->
              _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_133 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LCUR as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_DOTDOTDOT (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState133 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_116 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_COLONCOLON (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState116 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_118 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_COALESCE (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState118 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_120 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_BIN3 (_menhir_stack, _menhir_s, _v) in
      let _menhir_s = MenhirState120 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_122 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_BIN2 (_menhir_stack, _menhir_s, _v) in
      let _menhir_s = MenhirState122 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_124 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_BIN1 (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _menhir_s = MenhirState124 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_126 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_AT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState126 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_128 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_AND (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState128 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_048 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_135 _1 _3 in
      _menhir_goto_if_def_var _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_397 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_optvar (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState397
      | COMMA | RPAR ->
          let _v_0 = _menhir_action_188 () in
          _menhir_run_398 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_398 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_optvar -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_optvar (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_031 _1 _2 in
      _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_378 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_optvar (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _menhir_s = MenhirState379 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v ->
              _menhir_run_201 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_333 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_DOTDOTDOT -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_DOTDOTDOT (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      let (_endpos__2_, _2) = (_endpos, _v) in
      let _v = _menhir_action_225 _2 in
      _menhir_goto_spread _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_322 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_DOTDOTDOT -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let MenhirCell1_DOTDOTDOT (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
      let (_endpos__2_, _startpos__2_, _2) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_181 _2 _endpos__2_ _startpos__2_ in
      _menhir_goto_meth_spread_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_199 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_def, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_optvar (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _menhir_s = MenhirState200 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v ->
              _menhir_run_201 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_091 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_optvar (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_s = MenhirState092 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_075 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_FOR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_optvar (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_s = MenhirState076 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_549 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VARLBRA as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState549
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState549
      | RBRA ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_VARLBRA (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
          let (_2, _endpos__3_) = (_v, _endpos_0) in
          let _v = _menhir_action_099 _1 _2 _endpos__1_ _endpos__3_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState549
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState549
      | OR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState549
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState549
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState549
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState549
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState549
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState549
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState549
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState549
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState549
      | AND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState549
      | _ ->
          _eRR ()
  
  and _menhir_run_548 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_UMINUS -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_UMINUS (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_endpos__2_, _2) = (_endpos, _v) in
      let _v = _menhir_action_075 _2 _endpos__2_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_510 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OPEN as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState510
      | SET ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState510
      | SEQ ->
          _menhir_run_187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState510
      | QUESTION_DOT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState510
      | QUESTION ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState510
      | OR ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState510
      | MINUS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState510
      | DOT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState510
      | COLONCOLON ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState510
      | COALESCE ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState510
      | BIN3 _v_0 ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState510
      | BIN2 _v_1 ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState510
      | BIN1 _v_2 ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState510
      | AT ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState510
      | AND ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState510
      | BEGIN | BEGIN_INTERPOLATION _ | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v_3 = _menhir_action_217 () in
          _menhir_run_511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_3 MenhirState510 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_509 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_NOT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState509
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState509
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState509
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState509
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState509
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState509
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState509
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState509
      | BIN1 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState509
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState509
      | AND | BEGIN | BEGIN_INTERPOLATION _ | BOOL _ | CATCH | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | END_INTERPOLATION | EOF | FINALLY | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERPOLATED_STRING _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | OR | PP_ELSE | PP_ENDIF | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | QUESTION | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_NOT (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos__2_, _2) = (_endpos, _v) in
          let _v = _menhir_action_078 _2 _endpos__2_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_505 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COMMA as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState505
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState505
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState505
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState505
      | OR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState505
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState505
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState505
      | COMMA ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_503 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState505
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState505
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState505
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState505
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState505
      | BIN1 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState505
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState505
      | AND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState505
      | RPAR ->
          let MenhirCell1_COMMA (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_156 _1 _3 in
          _menhir_goto_inner_tuple _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_503 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_COMMA (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState503 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_inner_tuple : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState503 ->
          _menhir_run_504 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState052 ->
          _menhir_run_499 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_504 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COMMA -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_COMMA (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_157 _1 _3 in
      _menhir_goto_inner_tuple _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_499 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_089 _2 _endpos__3_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_501 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState501
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState501
      | RPAR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_2, _endpos__3_) = (_v, _endpos_0) in
          let _v = _menhir_action_076 _2 _endpos__3_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState501
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState501
      | OR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState501
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState501
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState501
      | COMMA ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_503 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState501
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState501
      | COLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_stack = MenhirCell1_COLON (_menhir_stack, MenhirState501) in
          let _menhir_s = MenhirState506 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v ->
              _menhir_run_201 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState501
      | BIN3 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState501
      | BIN2 _v_4 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState501
      | BIN1 _v_5 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState501
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState501
      | AND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState501
      | _ ->
          _eRR ()
  
  and _menhir_run_484 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_OPEN as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState484
      | SET ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState484
      | SEQ ->
          _menhir_run_187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState484
      | QUESTION_DOT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState484
      | QUESTION ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState484
      | OR ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState484
      | MINUS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState484
      | DOT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState484
      | COLONCOLON ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState484
      | COALESCE ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState484
      | BIN3 _v_0 ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState484
      | BIN2 _v_1 ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState484
      | BIN1 _v_2 ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState484
      | AT ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState484
      | AND ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState484
      | BEGIN | BEGIN_INTERPOLATION _ | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v_3 = _menhir_action_217 () in
          _menhir_run_485 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_3 MenhirState484 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_481 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState481
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState481
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState481
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState481
      | OR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState481
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState481
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState481
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState481
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState481
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState481
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState481
      | BIN1 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState481
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState481
      | AND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState481
      | COMMA | RCUR ->
          let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_208 _1 _3 in
          _menhir_goto_record _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_record : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LCUR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState054 ->
          _menhir_run_489 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState131 ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_489 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LCUR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | RCUR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_2, _endpos__3_) = (_v, _endpos) in
          let _v = _menhir_action_092 _2 _endpos__3_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | COMMA ->
          let _menhir_stack = MenhirCell1_record (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_137 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_record as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          let _menhir_stack = MenhirCell1_COMMA (_menhir_stack, _menhir_s) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | GETS ->
              let _menhir_s = MenhirState139 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | WHILE ->
                  _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | VARLPAR _v ->
                  _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | VARLBRA _v ->
                  _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | VAR _v ->
                  _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | UMINUS ->
                  _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | TRY ->
                  _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | TIME _v ->
                  _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | STRING _v ->
                  _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | REGEXP _v ->
                  _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | PP_IFVERSION ->
                  _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | PP_IFENCODER _v ->
                  _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | PP_IFDEF _v ->
                  _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | NOT ->
                  _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LPAR ->
                  _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LCUR ->
                  _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LBRA ->
                  _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | INTERVAL _v ->
                  _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | INT _v ->
                  _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | INCLUDE _v ->
                  _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | IF ->
                  _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | GET ->
                  _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | FUN ->
                  _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | FOR ->
                  _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | FLOAT _v ->
                  _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | ENCODER _v ->
                  _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | BOOL _v ->
                  _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | BEGIN_INTERPOLATION _v ->
                  _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | BEGIN ->
                  _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | DOTDOTDOT ->
          let _menhir_stack = MenhirCell1_COMMA (_menhir_stack, _menhir_s) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_DOTDOTDOT (_menhir_stack, _startpos, _endpos) in
          let _menhir_s = MenhirState141 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | RCUR ->
          let _ = _menhir_action_189 () in
          _menhir_goto_optional_comma _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_optional_comma : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_record as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      match _menhir_s with
      | MenhirState489 ->
          _menhir_run_491 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MenhirState135 ->
          _menhir_run_143 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_491 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_record -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_record (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let _endpos__4_ = _endpos in
      let _v = _menhir_action_093 _2 _endpos__4_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_143 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_DOT, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_record -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_record (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_LCUR (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_DOT (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      let _endpos__6_ = _endpos in
      let _v = _menhir_action_091 _1 _4 _endpos__6_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__6_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_135 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_DOT, ttv_result) _menhir_cell1_LCUR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | RCUR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LCUR (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_DOT (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_4, _endpos__5_) = (_v, _endpos) in
          let _v = _menhir_action_090 _1 _4 _endpos__5_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | COMMA ->
          let _menhir_stack = MenhirCell1_record (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState135
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_478 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState478
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState478
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState478
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState478
      | OR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState478
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState478
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState478
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState478
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState478
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState478
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState478
      | BIN1 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState478
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState478
      | AND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState478
      | COMMA | RBRA ->
          let _1 = _v in
          let _v = _menhir_action_155 _1 in
          _menhir_goto_inner_list_item _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_inner_list_item : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_inner_list_item (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState476
          | VARLPAR _v_0 ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState476
          | VARLBRA _v_1 ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState476
          | VAR _v_2 ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState476
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState476
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState476
          | TIME _v_3 ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState476
          | STRING _v_4 ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState476
          | REGEXP _v_5 ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState476
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState476
          | PP_IFENCODER _v_6 ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState476
          | PP_IFDEF _v_7 ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState476
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState476
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState476
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState476
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState476
          | INTERVAL _v_8 ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState476
          | INT _v_9 ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState476
          | INCLUDE _v_10 ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState476
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState476
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState476
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState476
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState476
          | FLOAT _v_11 ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState476
          | ENCODER _v_12 ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState476
          | DOTDOTDOT ->
              _menhir_run_473 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState476
          | BOOL _v_13 ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState476
          | BEGIN_INTERPOLATION _v_14 ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState476
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState476
          | RBRA ->
              let _v_15 = _menhir_action_153 () in
              _menhir_run_477 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15
          | _ ->
              _eRR ())
      | RBRA ->
          let _1 = _v in
          let _v = _menhir_action_152 _1 in
          _menhir_goto_inner_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_477 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_inner_list_item -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_inner_list_item (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_151 _1 _3 in
      _menhir_goto_inner_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_inner_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState057 ->
          _menhir_run_479 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState476 ->
          _menhir_run_477 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_474 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_DOTDOTDOT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState474
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState474
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState474
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState474
      | OR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState474
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState474
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState474
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState474
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState474
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState474
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState474
      | BIN1 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState474
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState474
      | AND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState474
      | COMMA | RBRA ->
          let MenhirCell1_DOTDOTDOT (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_154 _2 in
          _menhir_goto_inner_list_item _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_455 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | OR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState455
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState455
      | BIN1 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState455
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | AND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | COMMA | RBRA ->
          let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_166 _1 _3 in
          _menhir_goto_let_opt_el _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_454 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_GET as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState454
      | AND | AT | BEGIN | BEGIN_INTERPOLATION _ | BIN1 _ | BIN2 _ | BIN3 _ | BOOL _ | CATCH | COALESCE | COLON | COLONCOLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | END_INTERPOLATION | EOF | FINALLY | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERPOLATED_STRING _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | MINUS | NOT | OPEN | OR | PP_ELSE | PP_ENDIF | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | QUESTION | QUESTION_DOT | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TIMES | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_GET (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos__2_, _2) = (_endpos, _v) in
          let _v = _menhir_action_085 _2 _endpos__2_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_453 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_FUN _menhir_cell0_LPAR, ttv_result) _menhir_cell1_arglist _menhir_cell0_RPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState453
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState453
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState453
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState453
      | OR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState453
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState453
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState453
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState453
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState453
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState453
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState453
      | BIN1 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState453
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState453
      | AND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState453
      | BEGIN | BEGIN_INTERPOLATION _ | BOOL _ | CATCH | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | END_INTERPOLATION | EOF | FINALLY | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERPOLATED_STRING _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | PP_ELSE | PP_ENDIF | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | STRING _ | THEN | TIME _ | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell0_RPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_arglist (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_FUN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos__6_, _6) = (_endpos, _v) in
          let _v = _menhir_action_102 _3 _6 _endpos__6_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__6_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_441 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_GETS as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState441
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState441
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState441
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState441
      | OR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState441
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState441
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState441
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState441
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState441
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState441
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState441
      | BIN1 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState441
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState441
      | AND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState441
      | COMMA | RPAR ->
          let MenhirCell1_GETS (_menhir_stack, _menhir_s) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_187 _2 in
          _menhir_goto_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_opt : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState448 ->
          _menhir_run_449 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState070 ->
          _menhir_run_443 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState072 ->
          _menhir_run_442 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState397 ->
          _menhir_run_398 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState381 ->
          _menhir_run_382 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_434 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_FOR, ttv_result) _menhir_cell1_optvar, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_TO as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState434
      | SET ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState434
      | QUESTION_DOT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState434
      | QUESTION ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState434
      | OR ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState434
      | MINUS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState434
      | DOT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState434
      | DO ->
          let _menhir_stack = MenhirCell1_DO (_menhir_stack, MenhirState434) in
          let _menhir_s = MenhirState435 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | OPEN ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LETLBRA _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LET _v ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | DEF _v ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COLONCOLON ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState434
      | COALESCE ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState434
      | BIN3 _v_18 ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_18 MenhirState434
      | BIN2 _v_19 ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_19 MenhirState434
      | BIN1 _v_20 ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_20 MenhirState434
      | AT ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState434
      | AND ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState434
      | _ ->
          _eRR ()
  
  and _menhir_run_432 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_FOR, ttv_result) _menhir_cell1_optvar as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_TO (_menhir_stack, MenhirState432) in
          let _menhir_s = MenhirState433 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | TIMES ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState432
      | SET ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState432
      | QUESTION_DOT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState432
      | QUESTION ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState432
      | OR ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState432
      | MINUS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState432
      | DOT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState432
      | DO ->
          let _menhir_stack = MenhirCell1_DO (_menhir_stack, MenhirState432) in
          let _menhir_s = MenhirState438 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | OPEN ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LETLBRA _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LET _v ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | DEF _v ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COLONCOLON ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState432
      | COALESCE ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState432
      | BIN3 _v_33 ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_33 MenhirState432
      | BIN2 _v_34 ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_34 MenhirState432
      | BIN1 _v_35 ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_35 MenhirState432
      | AT ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState432
      | AND ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState432
      | _ ->
          _eRR ()
  
  and _menhir_run_423 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STRING as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState423
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState423
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState423
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState423
      | OR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState423
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState423
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState423
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState423
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState423
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState423
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState423
      | BIN1 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState423
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState423
      | AND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState423
      | COMMA | RPAR ->
          let MenhirCell1_STRING (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_056 _1 _3 _endpos__1_ _startpos__1_ in
          _menhir_goto_encoder_param _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_420 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState420
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState420
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState420
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState420
      | OR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState420
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState420
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState420
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState420
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState420
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState420
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState420
      | BIN1 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState420
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState420
      | AND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState420
      | COMMA | RPAR ->
          let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_055 _1 _3 in
          _menhir_goto_encoder_param _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_419 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState419
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState419
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState419
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState419
      | OR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState419
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState419
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState419
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState419
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState419
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState419
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState419
      | BIN1 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState419
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState419
      | AND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState419
      | BEGIN | BEGIN_INTERPOLATION _ | BOOL _ | ENCODER _ | END_INTERPOLATION | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERPOLATED_STRING _ | INTERVAL _ | LBRA | LCUR | LPAR | NOT | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _1 = _v in
          let _v = _menhir_action_228 _1 in
          _menhir_goto_string_interpolation_elem _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_375 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1__let, ttv_result) _menhir_cell1_pattern as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState375
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState375
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState375
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState375
      | OR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState375
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState375
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState375
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState375
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState375
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState375
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState375
      | BIN1 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState375
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState375
      | AND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState375
      | BEGIN | BEGIN_INTERPOLATION _ | BOOL _ | CATCH | DEF _ | ELSE | ELSIF | ENCODER _ | END | EOF | FINALLY | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | PP_ELSE | PP_ENDIF | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | RCUR | REGEXP _ | SEQ | SEQSEQ | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_pattern (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1__let (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
          let (_endpos__4_, _4) = (_endpos, _v) in
          let _v = _menhir_action_063 _1 _2 _4 in
          _menhir_goto_explicit_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_372 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1__let, ttv_result) _menhir_cell1_subfield as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState372
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState372
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState372
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState372
      | OR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState372
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState372
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState372
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState372
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState372
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState372
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState372
      | BIN1 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState372
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState372
      | AND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState372
      | BEGIN | BEGIN_INTERPOLATION _ | BOOL _ | CATCH | DEF _ | ELSE | ELSIF | ENCODER _ | END | EOF | FINALLY | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | PP_ELSE | PP_ENDIF | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | RCUR | REGEXP _ | SEQ | SEQSEQ | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_subfield (_menhir_stack, _, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1__let (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
          let (_endpos__4_, _4) = (_endpos, _v) in
          let _v = _menhir_action_065 _1 _2 _4 _endpos__2_ _startpos__2_ in
          _menhir_goto_explicit_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_369 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1__let, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_pattern, ttv_result) _menhir_cell1_ty _menhir_cell0_RPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState369
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState369
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState369
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState369
      | OR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState369
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState369
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState369
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState369
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState369
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState369
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState369
      | BIN1 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState369
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState369
      | AND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState369
      | BEGIN | BEGIN_INTERPOLATION _ | BOOL _ | CATCH | DEF _ | ELSE | ELSIF | ENCODER _ | END | EOF | FINALLY | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | PP_ELSE | PP_ENDIF | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | RCUR | REGEXP _ | SEQ | SEQSEQ | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell0_RPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ty (_menhir_stack, _, _5, _) = _menhir_stack in
          let MenhirCell1_pattern (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1__let (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
          let (_endpos__8_, _8) = (_endpos, _v) in
          let _v = _menhir_action_064 _1 _3 _5 _8 in
          _menhir_goto_explicit_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__8_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_186 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState186
      | SET ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState186
      | SEQ ->
          _menhir_run_187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState186
      | QUESTION_DOT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState186
      | QUESTION ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState186
      | OR ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState186
      | MINUS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState186
      | DOT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState186
      | COLONCOLON ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState186
      | COALESCE ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState186
      | BIN3 _v_0 ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState186
      | BIN2 _v_1 ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState186
      | BIN1 _v_2 ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState186
      | AT ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState186
      | AND ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState186
      | BEGIN | BEGIN_INTERPOLATION _ | BOOL _ | CATCH | DEF _ | ELSE | ELSIF | ENCODER _ | END | EOF | FINALLY | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | PP_ELSE | PP_ENDIF | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | RCUR | REGEXP _ | SEQSEQ | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v_3 = _menhir_action_217 () in
          _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_3 MenhirState186 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_177 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
      | OR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState177
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState177
      | BIN1 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState177
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
      | AND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
      | COMMA | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_023 _1 in
          _menhir_goto_app_list_elem _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_147 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_QUESTION, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COLON -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_COLON (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _, _3, _, _) = _menhir_stack in
      let MenhirCell1_QUESTION (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      let (_5, _endpos__5_) = (_v, _endpos) in
      let _v = _menhir_action_115 _1 _3 _5 _endpos__5_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_142 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_record, ttv_result) _menhir_cell1_COMMA _menhir_cell0_DOTDOTDOT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState142
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState142
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState142
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState142
      | OR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState142
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState142
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState142
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState142
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState142
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState142
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState142
      | BIN1 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState142
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState142
      | AND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState142
      | COMMA | RCUR ->
          let MenhirCell0_DOTDOTDOT (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_COMMA (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_record (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _4 = _v in
          let _v = _menhir_action_211 _1 _4 in
          _menhir_goto_record _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_140 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_record, ttv_result) _menhir_cell1_COMMA _menhir_cell0_VAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState140
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState140
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState140
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState140
      | OR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState140
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState140
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState140
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState140
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState140
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState140
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState140
      | BIN1 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState140
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState140
      | AND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState140
      | COMMA | RCUR ->
          let MenhirCell0_VAR (_menhir_stack, _3, _, _) = _menhir_stack in
          let MenhirCell1_COMMA (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_record (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _5 = _v in
          let _v = _menhir_action_210 _1 _3 _5 in
          _menhir_goto_record _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_134 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_DOTDOTDOT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState134
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState134
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState134
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState134
      | OR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState134
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState134
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState134
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState134
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState134
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState134
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState134
      | BIN1 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState134
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState134
      | AND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState134
      | COMMA | RCUR ->
          let MenhirCell1_DOTDOTDOT (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_209 _2 in
          _menhir_goto_record _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_129 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_AND as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState129
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState129
      | OR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState129
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState129
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState129
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState129
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState129
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState129
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState129
      | BIN1 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState129
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState129
      | AND | BEGIN | BEGIN_INTERPOLATION _ | BOOL _ | CATCH | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | END_INTERPOLATION | EOF | FINALLY | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERPOLATED_STRING _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | PP_ELSE | PP_ENDIF | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | QUESTION | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_AND (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_116 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_127 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_AT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState127
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState127
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState127
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState127
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState127
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState127
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState127
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState127
      | AND | AT | BEGIN | BEGIN_INTERPOLATION _ | BIN1 _ | BOOL _ | CATCH | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | END_INTERPOLATION | EOF | FINALLY | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERPOLATED_STRING _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | OR | PP_ELSE | PP_ENDIF | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | QUESTION | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_AT (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_123 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_125 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_BIN1 as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState125
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState125
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState125
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState125
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState125
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState125
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState125
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState125
      | AND | AT | BEGIN | BEGIN_INTERPOLATION _ | BIN1 _ | BOOL _ | CATCH | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | END_INTERPOLATION | EOF | FINALLY | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERPOLATED_STRING _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | OR | PP_ELSE | PP_ENDIF | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | QUESTION | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_BIN1 (_menhir_stack, _, _2, _, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_118 _1 _2 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_123 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_BIN2 as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState123
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState123
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState123
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState123
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState123
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState123
      | AND | AT | BEGIN | BEGIN_INTERPOLATION _ | BIN1 _ | BIN2 _ | BOOL _ | CATCH | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | END_INTERPOLATION | EOF | FINALLY | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERPOLATED_STRING _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | MINUS | NOT | OPEN | OR | PP_ELSE | PP_ENDIF | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | QUESTION | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_BIN2 (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_119 _1 _2 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_121 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_BIN3 as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState121
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState121
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState121
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState121
      | AND | AT | BEGIN | BEGIN_INTERPOLATION _ | BIN1 _ | BIN2 _ | BIN3 _ | BOOL _ | CATCH | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | END_INTERPOLATION | EOF | FINALLY | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERPOLATED_STRING _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | MINUS | NOT | OPEN | OR | PP_ELSE | PP_ENDIF | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | QUESTION | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TIMES | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_BIN3 (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_120 _1 _2 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_119 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COALESCE as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState119
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState119
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState119
      | AND | AT | BEGIN | BEGIN_INTERPOLATION _ | BIN1 _ | BIN2 _ | BIN3 _ | BOOL _ | CATCH | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | END_INTERPOLATION | EOF | FINALLY | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERPOLATED_STRING _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | MINUS | NOT | OPEN | OR | PP_ELSE | PP_ENDIF | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | QUESTION | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TIMES | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_COALESCE (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_107 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_117 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COLONCOLON as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState117
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState117
      | AND | AT | BEGIN | BEGIN_INTERPOLATION _ | BIN1 _ | BIN2 _ | BIN3 _ | BOOL _ | CATCH | COALESCE | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | END_INTERPOLATION | EOF | FINALLY | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERPOLATED_STRING _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | MINUS | NOT | OPEN | OR | PP_ELSE | PP_ENDIF | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | QUESTION | QUESTION_DOT | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TIMES | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_COLONCOLON (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_098 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_114 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_DOT, ttv_result) _menhir_cell1_VARLBRA as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState114
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState114
      | RBRA ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_VARLBRA (_menhir_stack, _, _3, _, _endpos__3_) = _menhir_stack in
          let MenhirCell1_DOT (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_100 _1 _3 _4 _endpos__3_ _endpos__5_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState114
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState114
      | OR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState114
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState114
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState114
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState114
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState114
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState114
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState114
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState114
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState114
      | AND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState114
      | _ ->
          _eRR ()
  
  and _menhir_run_111 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_MINUS as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState111
      | AND | AT | BEGIN | BEGIN_INTERPOLATION _ | BIN1 _ | BIN2 _ | BOOL _ | CATCH | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | END_INTERPOLATION | EOF | FINALLY | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERPOLATED_STRING _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | MINUS | NOT | OPEN | OR | PP_ELSE | PP_ENDIF | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | QUESTION | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_MINUS (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_122 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_109 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_OR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState109
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState109
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState109
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState109
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState109
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState109
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState109
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState109
      | BIN1 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState109
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState109
      | AND | BEGIN | BEGIN_INTERPOLATION _ | BOOL _ | CATCH | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | END_INTERPOLATION | EOF | FINALLY | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERPOLATED_STRING _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | OR | PP_ELSE | PP_ENDIF | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | QUESTION | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_OR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_117 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_107 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_QUESTION as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
      | SET ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
      | QUESTION_DOT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
      | QUESTION ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
      | OR ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
      | MINUS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
      | DOT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
      | COLONCOLON ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
      | COLON ->
          let _menhir_stack = MenhirCell1_COLON (_menhir_stack, MenhirState107) in
          let _menhir_s = MenhirState146 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFVERSION ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PP_IFENCODER _v ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PP_IFDEF _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INCLUDE _v ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN_INTERPOLATION _v ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COALESCE ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
      | BIN3 _v_15 ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15 MenhirState107
      | BIN2 _v_16 ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_16 MenhirState107
      | BIN1 _v_17 ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_17 MenhirState107
      | AT ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
      | AND ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
      | _ ->
          _eRR ()
  
  and _menhir_run_105 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_SET as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState105
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState105
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState105
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState105
      | OR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState105
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState105
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState105
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState105
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState105
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState105
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState105
      | BIN1 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState105
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState105
      | AND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState105
      | BEGIN | BEGIN_INTERPOLATION _ | BOOL _ | CATCH | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | END_INTERPOLATION | EOF | FINALLY | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERPOLATED_STRING _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | PP_ELSE | PP_ENDIF | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | STRING _ | THEN | TIME _ | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_SET (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_086 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_103 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState103
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState103
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState103
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState103
      | OR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState103
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState103
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState103
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState103
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState103
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState103
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState103
      | BIN1 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState103
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState103
      | AND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState103
      | COMMA | RPAR ->
          let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_022 _1 _3 in
          _menhir_goto_app_list_elem _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_098 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_TIMES as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState098
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState098
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState098
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState098
      | AND | AT | BEGIN | BEGIN_INTERPOLATION _ | BIN1 _ | BIN2 _ | BIN3 _ | BOOL _ | CATCH | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | END_INTERPOLATION | EOF | FINALLY | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERPOLATED_STRING _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | MINUS | NOT | OPEN | OR | PP_ELSE | PP_ENDIF | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | QUESTION | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TIMES | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_TIMES (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_121 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_096 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_optvar as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState096
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState096
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState096
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState096
      | OR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState096
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState096
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState096
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState096
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState096
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState096
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState096
      | BIN1 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState096
      | AT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState096
      | AND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState096
      | BEGIN | BEGIN_INTERPOLATION _ | BOOL _ | CATCH | DEF _ | ELSE | ELSIF | ENCODER _ | END | EOF | FINALLY | FLOAT _ | FOR | FUN | GET | IF | INCLUDE _ | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | PP_ELSE | PP_ENDIF | PP_IFDEF _ | PP_IFENCODER _ | PP_IFVERSION | RCUR | REGEXP _ | SEQ | SEQSEQ | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_optvar (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_050 _1 _3 _endpos__1_ _startpos__1_ in
          _menhir_goto_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  let _menhir_run_023 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_interactive =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | VAR _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | OPEN ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | LETLBRA _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | LET _v ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | EOF ->
          let _v = _menhir_action_160 () in
          _menhir_goto_interactive _menhir_stack _v
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | DEF _v ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | _ ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_158 _endpos__1_ _startpos__1_ in
          MenhirBox_interactive _v
  
  let _menhir_run_561 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_plain_encoder_params =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState562
          | STRING _v ->
              _menhir_run_421 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState562
          | ENCODER _v ->
              _menhir_run_424 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState562
          | RPAR ->
              let _v = _menhir_action_060 () in
              _menhir_run_563 _menhir_stack _v
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  let _menhir_run_566 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_program =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState566
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState566
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState566
      | VAR _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState566
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState566
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState566
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState566
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState566
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState566
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState566
      | PP_IFVERSION ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState566
      | PP_IFENCODER _v ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState566
      | PP_IFDEF _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState566
      | OPEN ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState566
      | NOT ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState566
      | LPAR ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState566
      | LETLBRA _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState566
      | LET _v ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState566
      | LCUR ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState566
      | LBRA ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState566
      | INTERVAL _v ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState566
      | INT _v ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState566
      | INCLUDE _v ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState566
      | IF ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState566
      | GET ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState566
      | FUN ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState566
      | FOR ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState566
      | FLOAT _v ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState566
      | EOF ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_206 _endpos__1_ _startpos__1_ in
          _menhir_goto_program _menhir_stack _v
      | ENCODER _v ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState566
      | DEF _v ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState566
      | BOOL _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState566
      | BEGIN_INTERPOLATION _v ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState566
      | BEGIN ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState566
      | _ ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_205 _endpos__1_ _startpos__1_ in
          MenhirBox_program _v
  
  let _menhir_run_572 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_time_predicate =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | TIME _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _v =
            let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
            _menhir_action_236 _1 _endpos__1_ _startpos__1_
          in
          _menhir_run_575 _menhir_stack _v
      | INTERVAL _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _v =
            let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
            _menhir_action_235 _1 _endpos__1_ _startpos__1_
          in
          _menhir_run_575 _menhir_stack _v
      | _ ->
          _eRR ()
  
end

let time_predicate =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_time_predicate v = _menhir_run_572 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let program =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_program v = _menhir_run_566 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let plain_encoder_params =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_plain_encoder_params v = _menhir_run_561 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let interactive =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_interactive v = _menhir_run_023 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let annotate_metadata_entry =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_annotate_metadata_entry v = _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let annotate =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_annotate v = _menhir_run_000 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v
